package adlib;

import adlib.*;

public class Adlib extends InterfaceObject {

  static public native void _Initialize(String[] args);
  static public native void _Finalize();
  static public native void _InitInterFace();  
  static public native void _InitAPG(Group apg);

  static public void remap(Section dst, Section src) {

    //dst.dad.show("dst"); //debug
    //src.dad.show("src"); //debug

    Remap schedule=new Remap(dst.dad, src.dad, dst.type);
    schedule.execute(dst.reference, dst.offset, src.reference, src.offset);
  };
  
  static public void shift(Section dst, Section src, int shift, int dim, int mode) {
    Shift schedule=new Shift(dst.dad, src.dad, dst.type, shift, dim, mode);
    schedule.execute(dst.reference, dst.offset, src.reference, src.offset);
  };

  static public void copy(Section dst, Section src) {
    // This is temporaryly implemented as remap;

    Remap schedule=new Remap(dst.dad, src.dad, dst.type);
    schedule.execute(dst.reference, dst.offset, src.reference, src.offset);
  };

  
  static public native void _aprintf(String control, 
				     DAD dad, int type, Object ref, int ost);

  static public void aprintf(String control, Section arg) {
    _aprintf(control, arg.dad, arg.type, arg.reference, arg.offset);
  };

  static public void Initialize(String[] args) {
    _Initialize(args);
    _InitInterFace();

    apg=new Group();
    _InitAPG(apg);
  };

  static public void Finalize() {
    _Finalize();
  };
  
  static public Group apg;
  static public Group global;
  static public Group root;

  // Is this correct?
  public static final AdlibPrintStream out = new AdlibPrintStream(System.out);
}
