#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "adlib.h"

/*
extern "C" {
#include <mpi.h>
#include <stdio.h>
}
*/

int len = 0;
char** sargs = 0;

#include "adlib_Adlib.h"

#include "jctable.h"
extern jctable<Group> adlib_Group_Table;
//Group * adlib_Group_ResolvePtr(JNIEnv *, jobject);

DAD * adlib_DAD_ResolvePtr(JNIEnv *, jobject);

jfieldID hCPPObjID=0;

/*
 * Class:     adlib_Adlib
 * Method:    _aprintf
 * Signature: (Ljava/lang/String;Ladlib/DAD;ILjava/lang/Object;I)V
 */
JNIEXPORT void JNICALL Java_adlib_Adlib__1aprintf
  (JNIEnv * env, jclass jAdlib, 
   jstring ctr, 
   jobject jDAD, jint type, jobject ref, jint ost)
{
  int length=env->GetStringUTFLength(ctr);
  char * cCtr=new char[length+1];

  const char * jctrPtr=env->GetStringUTFChars(ctr, 0);

  for (int i=0; i<length; i++)
    cCtr[i]=*(jctrPtr+i);
  cCtr[length]='\0';

  env->ReleaseStringUTFChars(ctr, jctrPtr);

  DAD * dad=adlib_DAD_ResolvePtr(env, jDAD);

  void * data;
  jint * intArray;
  jfloat * floatArray;
  
  int len;

  switch (type) {
  case 4:
    intArray=env->GetIntArrayElements((jintArray)ref, 0);
    data=(void *)(intArray+ost);
    len=4;
    break;
  case 6:
    floatArray=env->GetFloatArrayElements((jfloatArray)ref, 0);
    data=(void*)(floatArray+ost);
    len=4;
    break;
  default:
    printf("not touched type %d\n", type);
    break;
  }

  //  AdlibPrintf("Constructing IOArg..."); //debug
  IOArg * arg=new IOArg(dad, data, len);
  //  AdlibPrintf("finished\n"); //debug


  //  AdlibPrintf("call aprintf..."); //debug
  aprintf(cCtr, arg);
  //  AdlibPrintf("finished\n"); //debug

  delete arg;

  switch (type) {
  case 4:
    env->ReleaseIntArrayElements((jintArray)ref, intArray, JNI_ABORT);
    break;
  case 6:
    env->ReleaseFloatArrayElements((jfloatArray)ref, floatArray, JNI_ABORT);
    break;
  default:
    printf("not touched type %d\n", type);
    break;

  }

  delete [] cCtr;

};

/*
 * Class:     adlib_Adlib
 * Method:    _InitAPG
 * Signature: (Ladlib/Group;)V
 */
JNIEXPORT void JNICALL Java_adlib_Adlib__1InitAPG
  (JNIEnv * env, jclass jthis, jobject jGroup)
{
  int pos = env->GetIntField(jGroup, hCPPObjID);

  delete (adlib_Group_Table.ObjPtr[pos]);

  adlib_Group_Table.ObjPtr[pos]=&apg;
};

/*
 * Class:     adlib_Adlib
 * Method:    _InitInterFace
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Adlib__1InitInterFace
  (JNIEnv * env, jclass jthis)
{
  //to init hCPPObjID;
  jclass InterfaceObject_class=env->FindClass("adlib/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
}


JNIEXPORT void JNICALL Java_adlib_Adlib__1Initialize
  (JNIEnv *env, jclass obj, jobjectArray argv) 
{
  jsize i;
  jstring jc;
  len = env->GetArrayLength(argv);

  //printf("argc=%d\n",len);

  sargs = (char**)calloc(len+1, sizeof(char*));
  for (i=0; i<len; i++) {	
    jc=(jstring)env->GetObjectArrayElement(argv,i);
    sargs[i]=new char[strlen(env->GetStringUTFChars(jc,0))];
    strcpy(sargs[i],env->GetStringUTFChars(jc,0));	

    //printf("sargs[%d]:%s\n",i,sargs[i]);
  }

  //printf("AdlibInit...\n");

  AdlibInit(len, sargs);

}

JNIEXPORT void JNICALL Java_adlib_Adlib__1Finalize
  (JNIEnv *env, jclass obj) {
  int i;

  //printf("AdlibFinalize...\n");

  AdlibFinalize();

  for (i=0; i<len; i++)
    //free(sargs[i]);
    delete [] sargs[i];
  free(sargs);
}


