/*
 * File         : adlib_Dimension.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 13 12:03:03 1997
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1998/01/08 19:45:30 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "adlib_Dimension.h"
#include "adlib.h"
#include "apgStack.h"

extern jfieldID hCPPObjID;

#include "jctable.h"
jctable<Dimension> adlib_Dimension_Table;

/*ResolvePtr
 */
Dimension * adlib_Dimension_ResolvePtr(JNIEnv *env, jobject jthis) {
  return(adlib_Dimension_Table.ObjPtr[env->GetIntField(jthis, hCPPObjID)]);
}

/*
 * Class:     adlib_Dimension
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Dimension_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("adlib/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
  jctable<Dimension> *tempadlib_Dimension_Table=new jctable<Dimension>;
  adlib_Dimension_Table=*tempadlib_Dimension_Table;
};

/*
 * Class:     adlib_Dimension
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Dimension_clean
  (JNIEnv *, jclass)
{
//  delete adlib_Dimension_ObjPtr;
//  delete adlib_Dimension_ObjRef;
};

/*
 * Class:     adlib_Dimension
 * Method:    constructor
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Dimension_constructor
  (JNIEnv * env, jobject jthis)
{
  Dimension *cppDim=new Dimension();
  long pos = adlib_Dimension_Table.NewHandle(cppDim);

  if (adlib_Dimension_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

//  adlib_Dimension_Table.IncRefCntr(pos);

  env->SetIntField(jthis, hCPPObjID, pos);
};

/*
 * Class:     adlib_Dimension
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Dimension_finalize
  (JNIEnv * env, jobject jthis)
{
  long thecppobj=env->GetIntField(jthis, hCPPObjID);
  long rc=adlib_Dimension_Table.DecRefCntr(thecppobj);
  if (rc==0) {
    delete adlib_Dimension_Table.ObjPtr[thecppobj];
    adlib_Dimension_Table.ObjPtr[thecppobj]=NULL;
  }
};


/*
 * Class:     adlib_Dimension
 * Method:    crd
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_adlib_Dimension_crd
  (JNIEnv * env, jobject jthis)
{
  int temp = adlib_Dimension_ResolvePtr(env, jthis)->crd();
  //printf("in crd dim address %x\n", adlib_Dimension_ResolvePtr(env, jthis));
  //printf("crd is %d\n", temp);
  return(temp);
};


/*
 * Class:     adlib_Dimension
 * Method:    over
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Dimension_over
  (JNIEnv * env, jobject jthis)
{
  apgStack.push(&apg) ;
  apg.restrict(*adlib_Dimension_ResolvePtr(env, jthis));
  //  adlib_Dimension_ResolvePtr(env, jthis)->where();
};

/*
 * Class:     adlib_Dimension
 * Method:    revo
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Dimension_revo
  (JNIEnv * env, jobject jthis)
{
  apgStack.pop(&apg) ;
  //  adlib_Dimension_ResolvePtr(env, jthis)->erewh();
};
