/*
 * File         : adlib_Index.C
 * Author       : Guansong Zhang
 * Created      : Thu Jan  8 10:05:03 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/01/08 21:35:44 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "adlib_Index.h"

#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;
#include "jctable.h"

extern jctable<Location> adlib_Location_Table;

Location * adlib_Location_ResolvePtr(JNIEnv *, jobject);
Range * adlib_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
Index * adlib_Index_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((Index *)adlib_Location_ResolvePtr(env, jthis));
}

/*
 * Class:     adlib_Index
 * Method:    constructor
 * Signature: (Ladlib/Range;)V
 */
JNIEXPORT void JNICALL Java_adlib_Index_constructor
  (JNIEnv * env, jobject jthis, jobject jRange)
{
  Index * cppIndex = new Index(*adlib_Range_ResolvePtr(env, jRange));

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (adlib_Location_Table.ObjPtr[pos]);
  
  adlib_Location_Table.ObjPtr[pos]=cppIndex;

  if (adlib_Location_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
  
};

/*
 * Class:     adlib_Index
 * Method:    begin
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Index_begin
  (JNIEnv * env, jobject jthis)
{
  adlib_Index_ResolvePtr(env, jthis)->begin();
};

/*
 * Class:     adlib_Index
 * Method:    next
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_adlib_Index_next
  (JNIEnv * env, jobject jthis)
{
  adlib_Index_ResolvePtr(env, jthis)->next();
};

/*
 * Class:     adlib_Index
 * Method:    crd
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_adlib_Index_crd
  (JNIEnv * env, jobject jthis)
{
  return (int)(*adlib_Index_ResolvePtr(env, jthis));
};

