#ifndef PASSION_BASE_H
#define PASSION_BASE_H

#include "define.h"

/*
#include "ocad.h"
#include "gad.h"
*/

#include "pfile.h"
#include "prefetch.h"

/*
#include "section.h"
#include "reuse.h"
*/

#define c_ad_FromPointer          c_ad_FromPointer__
#define c_ad_ToPointer            c_ad_ToPointer__
#define c_ad_RmPointer            c_ad_RmPointer__

#ifdef PASSION_CCPLUSPLUS
extern "C"
{
#endif


/* Basic system dependent routines */
PFILE *PASSION_open(char *FileName, unsigned int HeaderSize);
PFILE *PASSION_create(char *FileName, unsigned int HeaderSize, long int filesize);
int PASSION_close(PFILE *PFilePtr);
PFILE *LAF_create(int proc_id,unsigned int HeaderSize, long int filesize);
int LAF_close(PFILE *PFilePtr);
int LAF_close_all();
PFILE *CopyPfile(PFILE *pfile);

int passion_seek(LAF_File fd, unsigned long int offset);
int passion_read(LAF_File fd, unsigned long int offset, char *buffer, 
							 unsigned int buflen);
int passion_pread(LAF_File fd, unsigned long int offset, char *buffer, 
							 unsigned int buflen);
int passion_write(LAF_File fd, unsigned long int offset, char *buffer, 
								 unsigned int buflen);
int passion_read_cur(LAF_File fd, char *buffer, unsigned int buflen);
int passion_pread_cur(LAF_File fd, char *buffer, unsigned int buflen);
int passion_write_cur(LAF_File fd, char *buffer, unsigned int buflen);
int passion_validate_section(int rank, int start, int *stride, int *number, int headersize, int *ocla_size, int icla_size);
int PASSION_prefetch_wait(PREFETCH *PREFETCHp);
/*
int passion_validate_section(OCAD *OCADp, int AccessArray[][4], int *Index);
int passion_validate_gsection(OCAD *OCADp, int AccessArray[][4], int *Index);
int passion_sect_int(OCAD *OCADp, ARRAY_SECTION old_section, 
										 ARRAY_SECTION new_section, ARRAY_SECTION *ovl_section, 
										 ARRAY_SECTION novl_section[]);

*/

/* 1-D routines */
/* unstrided sections */
int passion_read_usection_1D(LAF_File fd, char *Array, unsigned int Index, 
                             int StartIndex, int DataLen, 
                             int elemsize, int headersize);
PREFETCH *passion_pread_usection_1D(LAF_File fd, char *Array, unsigned int Index, 
                             int StartIndex, int DataLen, 
                             int elemsize, int headersize);
/*
int passion_read_usection_1D(int fd, char *Array, unsigned int Index, 
										 int StartIndex, int EndIndex, int elemsize, int
										 headersize);
PREFETCH *passion_pread_usection_1D(int fd, char *Array, unsigned int Index, 
										 int StartIndex, int EndIndex, int elemsize, int
										 headersize);
int passion_write_usection_1D(int fd, char *Array, unsigned int Index, 
										 int StartIndex, int EndIndex, int elemsize, int
										 headersize);
*/
/* strided sections */
int passion_read_block_section_1D(LAF_File fd, char *Array, int ArrayIndex, 
                                  int StartIndex, int DataLen, int stride, 
                                  int elemsize, int headersize, int icla_size);
int passion_write_block_section_1D(LAF_File fd, char *Array, int ArrayIndex, 
                                  int StartIndex, int stride, int DataLen, 
                                  int elemsize, int headersize, int icla_size, 
			 	  int OldFile);
PREFETCH *passion_pread_block_section_1D(LAF_File fd, char *Array, int ArrayIndex, 
                                  int StartIndex, int DataLen, int stride, 
                                  int elemsize, int headersize, int icla_size);
/*
int passion_read_block_section_1D_reuse(REUSE *REUSEp, char *Array, int *Index, 
                                        int AccessArray[][4]);
PREFETCH *passion_pread_section_1D(int fd, char *Array, unsigned int Index, 
					int StartIndex, int EndIndex, int BlockSize,
					int stride, 
					int elemsize, int headersize, int icla_size);
int passion_write_block_section_1D(int fd, char *Array, unsigned int Index, 
					int StartIndex, int EndIndex, int stride, 
					int block_size, int elemsize, int headersize, 
					int icla_size, int OldFile);
*/

/* 2-D routines */
/* unstrided sections */
int passion_read_usection_2D(LAF_File fd, char *Array, int ArrayIndex, int StartIndex, 
			     int u0, int u1, int DataLen0, int DataLen1, 
			     int elemsize, int headersize, 
			     int icla_size_0, int ocla_size_0);
PREFETCH *passion_pread_usection_2D(LAF_File fd, char *Array, int ArrayIndex, int StartIndex, 
			     int u0, int u1, int DataLen0, int DataLen1, 
			     int elemsize, int headersize, 
			     int icla_size_0, int ocla_size_0);
int passion_write_usection_2D(LAF_File fd, char *Array, int ArrayIndex, int StartIndex, 
			     int u0,int u1, int DataLen0, int DataLen1, 
                             int elemsize, int headersize, 
                             int icla_rowsize, int ocla_rowsize);
/*
int passion_read_usection_2D(int fd, char *Array, int Index0, int Index1, 
														 int StartIndex0, int StartIndex1, 
														 int EndIndex0, int EndIndex1, int elemsize,
														 int headersize, int ocla_rowsize,int icla_rowsize);
PREFETCH *passion_pread_usection_2D(int fd, char *Array, int Index0, int Index1,
														 int StartIndex0, int StartIndex1, 
														 int EndIndex0, int EndIndex1, int elemsize,
														 int headersize, int ocla_rowsize,int icla_rowsize);
int passion_write_usection_2D(int fd, char *Array, int Index0, int Index1, 
														 int StartIndex0, int StartIndex1, 
														 int EndIndex0, int EndIndex1, int elemsize,
														 int headersize, int ocla_rowsize,int icla_rowsize);
*/
/* strided sections */
int passion_read_block_section_2D(LAF_File fd, char *Array, int Index, int StartIndex, 
				  int u0, int u1, int DataLen0, int DataLen1, 
				  int elemsize, int headersize, int icla_size, 
                                  int icla_rowsize, int ocla_rowsize);
int passion_write_block_section_2D(LAF_File fd, char *Array, int Index, int StartIndex, 
				  int u0, int u1, int DataLen0, int DataLen1, 
				  int elemsize, int headersize, int icla_size, 
                                  int icla_rowsize, int ocla_rowsize,
				  int OldFile);
PREFETCH *passion_pread_block_section_2D(LAF_File fd, char *Array, int Index, int StartIndex, 
				  int u0, int u1, int DataLen0, int DataLen1, 
				  int elemsize, int headersize, int icla_size, 
                                  int icla_rowsize, int ocla_rowsize);
/*
int passion_read_block_section_2D(int fd, char *Array, unsigned int Index0, 
													 unsigned int Index1, int StartIndex0, int
													 StartIndex1, int EndIndex0, int EndIndex1, 
													 int stride0, int stride1, int block_size0,
													 int block_size1, int elemsize, int headersize,
													 int icla_size, int icla_rowsize, int ocla_rowsize);
int passion_read_block_section_2D_reuse(REUSE *REUSEp, char *Array, int *Index, 
                                        int AccessArray[][4]);
PREFETCH *passion_pread_section_2D(int fd, char *Array, unsigned int Index0, 
					unsigned int Index1, int StartIndex0, int
					StartIndex1, int EndIndex0, int EndIndex1, 
					int BlockSize0, int BlockSize1, int stride0, 
					int stride1,
					int elemsize, int headersize, int icla_size,
					int icla_rowsize, int ocla_rowsize);
int passion_write_block_section_2D(int fd, char *Array, unsigned int Index0, 
					unsigned int Index1, int StartIndex0, int
					StartIndex1, int EndIndex0, int EndIndex1, 
					int stride0, int stride1,
					int block_size0, int block_size1,
					int elemsize, int headersize, int icla_size,
					int icla_rowsize, int ocla_rowsize, int OldFile);
int passion_read_block_section_2D_reuse(REUSE *REUSEp, char *Array, int *Index, 
                                        int AccessArray[][4]);

*/
/* 3-D routines */
/* unstrided sections */
int passion_read_usection_3D(LAF_File fd, char *Array, int ArrayIndex, int StartIndex, 
			     int u0, int u1, int u2,
                             int DataLen0, int DataLen1, int DataLen2,
			     int elemsize, int headersize, 
                             int icla_size_0, int icla_size_1,
                             int ocla_size_0, int ocla_size_1);
PREFETCH *passion_pread_usection_3D(LAF_File fd, char *Array, int ArrayIndex, int StartIndex, 
			     int u0, int u1, int u2,
                             int DataLen0, int DataLen1, int DataLen2,
			     int elemsize, int headersize, 
                             int icla_size_0, int icla_size_1,
                             int ocla_size_0, int ocla_size_1);
/*
int passion_read_usection_3D(int fd, char *Array, int Index0, int Index1, 
				int Index2, int StartIndex0, int StartIndex1, 
				int StartIndex2, int EndIndex0, int EndIndex1, 
				int EndIndex2, int elemsize, int headersize, 
				int ocla_size_2, int ocla_size_3, 
				int icla_size_2, int icla_size_3);
PREFETCH *passion_pread_usection_3D(int fd, char *Array, int Index0, int Index1,
				int Index2, int StartIndex0, int StartIndex1, 
				int StartIndex2, int EndIndex0, int EndIndex1, 
				int EndIndex2, int elemsize, int headersize, 
				int ocla_size_2, int ocla_size_3, 
				int icla_size_2, int icla_size_3);
int passion_write_usection_3D(int fd, char *Array, int Index0, int Index1, 
				int Index2, int StartIndex0, int StartIndex1, 
				int StartIndex2, int EndIndex0, int EndIndex1, 
				int EndIndex2, int elemsize, int headersize, 
				int ocla_size_2, int ocla_size_3, 
				int icla_size_2, int icla_size_3);

*/
/* strided sections */
int passion_read_block_section_3D(LAF_File fd, char *Array, int Index, int StartIndex, 
				  int u0, int u1, int u2, 
				  int DataLen0, int DataLen1, int DataLen2,
				  int elemsize, int headersize, int icla_size, 
                                  int icla_size_0, int icla_size_1,
				  int ocla_size_0, int ocla_size_1);
int passion_write_block_section_3D(LAF_File fd, char *Array, unsigned int Index,
				int StartIndex, int u0, int u1, int u2,
				int DataLen0, int DataLen1, int DataLen2,
				int elemsize, int headersize, int icla_size, 
				int icla_size_0, int icla_size_1,
			        int ocla_size_0, int ocla_size_1, int OldFile);
PREFETCH *passion_pread_block_section_3D(LAF_File fd, char *Array, int Index, int StartIndex, 
				  int u0, int u1, int u2, 
				  int DataLen0, int DataLen1, int DataLen2,
				  int elemsize, int headersize, int icla_size, 
                                  int icla_size_0, int icla_size_1,
				  int ocla_size_0, int ocla_size_1);
/*
int passion_read_block_section_3D(int fd, char *Array, unsigned int Index0, 
													 unsigned int Index1, unsigned int Index2,
													 int StartIndex0, int StartIndex1, int
													 StartIndex2, int EndIndex0, int EndIndex1, int
													 EndIndex2, int stride0, int stride1, int
													 stride2, int block_size0, int block_size1, 
													 int block_size2, int elemsize, int headersize, 
													 int icla_size, int ocla_size_2, int ocla_size_3,
			                     int icla_size_2, int icla_size_3);
PREFETCH *passion_pread_section_3D(int fd, char *Array, unsigned int Index0, 
					unsigned int Index1, unsigned int Index2,
					int StartIndex0, int StartIndex1, int
					StartIndex2, int EndIndex0, int EndIndex1, int
					EndIndex2, int BlockSize0, int BlockSize1, int
					BlockSize2, int stride0, int stride1, int
					stride2, int elemsize, int headersize, 
					int icla_size, int ocla_size_2, int ocla_size_3,
			                int icla_size_2, int icla_size_3);
int passion_read_block_section_3D_reuse(REUSE *REUSEp, char *Array, int *Index, 
                                        int AccessArray[][4]);
int passion_write_block_section_3D(int fd, char *Array, unsigned int Index0, 
					unsigned int Index1, unsigned int Index2,
					int StartIndex0, int StartIndex1, int
					StartIndex2, int EndIndex0, int EndIndex1, int
					EndIndex2, int stride0, int stride1, int
					stride2, int block_size0, int block_size1, int
					block_size2, int elemsize, int headersize, 
					int icla_size, int ocla_size_2, int ocla_size_3,
			                int icla_size_2, int icla_size_3, int OldFile);
*/

/*
int PASSION_global_read1D( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_write1D( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_read2D( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_write2D( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_read2Dcol( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_write2Dcol( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_read3D( PFILE *PFilePtr, GAD *GADp, char *A, 
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_write3D( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_read3Dcol( PFILE *PFilePtr, GAD *GADp, char *A, 
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_write3Dcol( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_read4D( PFILE *PFilePtr, GAD *GADp, char *A, 
int *index, int AccessArray[][4], int nprocs);
int PASSION_global_write4D( PFILE *PFilePtr, GAD *GADp, char *A,
int *index, int AccessArray[][4], int nprocs);
int ret_no_elements(int FAD_Begin, int FDAT_Begin, int FDAT_End, int Block,
                                                        int Stride);
int passion_mynode();
int passion_numnodes();
void passion_gsync();
void passion_send(int mynod, int TAG, char *start, int size, int dest);
void passion_recv(int dest, char *start, int size);

void passion_sieve_1d(char *dest, char *source, int nelems, int stride, 
											int bl_size, int elemsize);
void passion_sieve_2d(char *dest, char *source, int nelems0, int nelems1, 
											int stride0, int stride1, int bl_size0, int bl_size1,
											int elemsize, int src_rowsize, int des_rowsize);
void passion_sieve_3d(char *dest, char *source, int nelems0, int nelems1, 
										  int nelems2, int stride0, int stride1, int stride2,
											int bl_size0, int bl_size1, int bl_size2, int elemsize, 
											int src_size_1, int src_size_2, int des_size_1, 
											int des_size_2);
*/
#ifdef PASSION_CCPLUSPLUS
}
#endif

#endif /* PASSION_BASE_H */
