/*
$Id: pfile.h,v 1.5 1995/11/05 18:00:31 ssmore Exp $
*/

#ifndef PASSION_PFILE_H
#define PASSION_PFILE_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_MPIO
#include "mpio.h"
#endif

#define PASSION_NEW 1
#define PASSION_OLD 0

#define COLUMN_MAJOR ((int)0)
#define ROW_MAJOR    ((int)1)

#ifdef HAVE_MPIO
typedef MPI_File  LAF_File;
#else
typedef int  LAF_File;
#endif

typedef struct _stack {
  char *filename;
  LAF_File fd;      /* system file descriptor of the LAF/global file */
  struct _stack *next;
} STACK, *PSTACK;

typedef struct share_file
{
  char *filename;
  LAF_File Fd;      /* system file descriptor of the LAF/global file */
  int Status;  /* This flag indicates whether is the file is newly created 
		              Status = NEW, or it already exists Status = OLD*/
  int storage;       /* COLUMN_MAJOR = 0, ROW_MAJOR = 1 */
  int refcount;
}SHARE_PFILE;

typedef struct pfile
{
  unsigned int HeaderSize; /* the header offset at the start of the file */
  int ocla_size[10];

  SHARE_PFILE *share;
#ifdef PASSION_TRACE
	int trace_fd;
#endif
}PFILE;

#endif  /* PASSION_PFILE_H */
