
#include <stdio.h>

#include "passion_base.h"

#ifdef AIX
#include <aio.h>
#endif

extern void *c_ad_ToPointer(int idx);
extern void c_ad_RmPointer(int idx) ;

int PASSION_prefetch_wait(PREFETCH *PREFETCHp)
{
   int i;
#ifdef HAVE_MPIO
   MPI_Status   status;
   MPIO_Request request;
   for (i = 0; i < PREFETCHp->NoOfIds; i++)
   {
	if ((PREFETCHp->Ids)[i] != (long int)-1 && 
            (PREFETCHp->Ids)[i] != (long int)0)
	{
   	   request = (MPIO_Request)c_ad_ToPointer((PREFETCHp->Ids)[i]);
   	   MPIO_Wait(&request, &status); 
	   c_ad_RmPointer((PREFETCHp->Ids)[i]);
	}
   }
#else
#ifdef AIX
   for (i = 0; i < PREFETCHp->NoOfIds; i++)
   {
	if ((PREFETCHp->Ids)[i] != (long int)-1 && 
            (PREFETCHp->Ids)[i] != (long int)0)
	{
           aio_handle_t aiocbp = (aio_handle_t)c_ad_ToPointer((PREFETCHp->Ids)[i]);
	   aio_return(aiocbp);
	   free(aiocbp);
	   c_ad_RmPointer((PREFETCHp->Ids)[i]);
	}
   }
#else
   fprintf(stderr,"PASSION : (prefetch wait) This function is currently unavailable\n");
#endif
#endif
}

