/*
$Id: seek_read.c,v 1.1 1995/06/21 15:34:49 ssmore Exp $

File Name : seek_read.c
Author    : ssmore

Entry Point(s) :

(1) passion_seek_read   prototype in passion_base.h

Modification History :

Module Description                                      Date      Author
------------------------------------------------------------------------------

Notes :

(1) Modifications to the entry points interface should be reflected in the 
    prototypes declarations.
*/

#ifndef PASSION_SEEK_READ_C
#define PASSION_SEEK_READ_C

/*
#include "passion_base.h"
*/

#include <stdio.h>

/*
  Name : passion_seek_read

  Function : This function is used to read data from the LAF. It first
	seeks to the specified offset wrt the start of the LAF and then starts
	reading the data.

  Parameters : 
    Input :
			FileDescriptor - File descriptor of the LAF
			Offset         - Offset from the start of the LAF, the read starts
											 here
			DataLen        - Amount of data in bytes
    Output :
			Buffer         - The pointer to the data buffer
    Input/Output :
      none

  Return Value : 
    0, if successful
		-1, otherwise

  Algorithm :

    seek to the offset (passion_seek)
		read the data from the LAF (passion_read_cur)

  Side Effects :
    (1) Modifies the file pointer in the LAF.

  Shortcomings :
    none

  Modifications :

  Description                                       Date          Author
  ------------------------------------------------------------------------------
*/

int passion_read(int fd, unsigned long int offset, char *buffer, 
					   unsigned int buflen)
{
  if (passion_seek(fd, offset)) {
fprintf(stderr,"passion_read: passion_seek error.\n");
	return -1;
  }
  if (passion_read_cur(fd, buffer, buflen)) return -1;
	return 0;
}

#endif  /* PASSION_SEEK_READ_C */
