#ifndef  PCRC_H
#define  PCRC_H

#include "pfile.h"

struct pcrcfDAD : public DAD {
  pcrcfDAD(void* _data, const int _elementType, const int _elementLen,
           const int _rank, const Group& _group, int _major=COLUMN_MAJOR) ;

  pcrcfDAD(const int _rank, pcrcfDAD& parent) ;

  pcrcfDAD(void* _data, pcrcfDAD& parent) ;

  ~pcrcfDAD() ;

  void addRange(const int r, Range x) ;

  void addTriplet(const int r,
		  const int lb, const int ub, const int stride,
		  pcrcfDAD& parent, const int s) ;

  void addScalar(const int u, pcrcfDAD& parent, const int s) ;

  Range  rngs [8] ;
  Stride strs [8] ;

  int elementLen ;
  int elementType ;

  int size ;

  void* memdata ;
  int   memHandle;	// stack memory handle
  PFILE *pfile;
  void* data ;		// when in-core, data=>memdata; 
			// while out-of-core, data=>pfile

  int grpHandle ;
  int rngHandles [8] ;

} ;

#endif
