
      INTEGER pcrc_integer, pcrc_real, pcrc_double, pcrc_character,     &
     &        pcrc_complex, pcrc_logical, pcrc_byte, pcrc_word

      PARAMETER(pcrc_integer   = 1,                                     &
     &          pcrc_real      = 2,                                     &
     &          pcrc_double    = 3,                                     &
     &          pcrc_character = 4,                                     &
     &          pcrc_complex   = 5,                                     &
     &          pcrc_logical   = 6,                                     &
     &          pcrc_byte      = 7,                                     &
     &          pcrc_word      = 8)

      INTEGER pcrc_size_integer, pcrc_size_real, pcrc_size_double,      &
     &        pcrc_size_character, pcrc_size_complex, pcrc_size_logical,&
     &        pcrc_size_byte, pcrc_size_word

      PARAMETER(pcrc_size_integer   = 4,                                &
     &          pcrc_size_real      = 4,                                &
     &          pcrc_size_double    = 8,                                &
     &          pcrc_size_complex   = 8,                                &
     &          pcrc_size_logical   = 4,                                &
     &          pcrc_size_character = 1,                                &
     &          pcrc_size_byte      = 1,                                &
     &          pcrc_size_word      = 2)

      INTEGER pcrc_block, pcrc_cyclic, pcrc_genblock

      PARAMETER(pcrc_block = 1, pcrc_cyclic = 2, pcrc_genblock = 3)

      INTEGER pcrc_grp_glob, pcrc_grp_root, pcrc_grp_io

      PARAMETER(pcrc_grp_glob = 1,                                      &
     &          pcrc_grp_root = 2,                                      &
     &          pcrc_grp_io   = 3)

      INTEGER COLUMN_MAJOR, ROW_MAJOR

      PARAMETER(COLUMN_MAJOR = 0,                                       &
     &          ROW_MAJOR    = 1)


      INTERFACE
        INTEGER FUNCTION pcrc_new_group_grid(rank, shape)
          INTEGER rank
          INTEGER shape(rank)
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_sub_group_grid(rank, l, u, s, grp_grid)
          INTEGER rank
          INTEGER l(*)
          INTEGER u(*)
          INTEGER s(*)
          INTEGER grp_grid
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_delete_group(grp)
          INTEGER grp
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_new_range_distribute(g_lb, g_ub,          &
     &                                             distribution,        &
     &                                             grp_grid, dim)
          INTEGER g_lb, g_ub
          INTEGER grp_grid
          INTEGER dim
          INTEGER distribution
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_collapse(g_lb, g_ub)
          INTEGER g_lb, g_ub
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_align(g_lb, g_ub,               &
     &                                    offset, stride, rng_parent)
          INTEGER rng_parent
          INTEGER offset, stride
          INTEGER g_lb, g_ub
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_copy(rng_parent)
          INTEGER rng_parent
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_loop(g_lb, g_ub, g_stride,      &
     &                                   offset, stride, rng_parent)
          INTEGER rng_parent
          INTEGER g_lb, g_ub, g_stride
          INTEGER offset, stride
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_delete_range(rng)
          INTEGER rng
        END
      END INTERFACE


!     INTERFACE
!       INTEGER FUNCTION pcrc_new_array_data(data,                       &
!    &                                       element_type, element_size, &
!    &                                       rank, majority, grp)
!         choice  data(...)
!         INTEGER element_type
!         INTEGER element_size
!         INTEGER rank
!         INTEGER majority
!         INTEGER grp
!       END
!     END INTERFACE

      INTEGER pcrc_new_array_data

      INTERFACE
        SUBROUTINE pcrc_set_array_distribute(dad, dim, g_lb, g_ub,      &
     &                                       distribution,              &
     &                                       grp_grid, dim_grid)
          INTEGER dad
          INTEGER dim, dim_grid
          INTEGER g_lb, g_ub
          INTEGER grp_grid
          INTEGER distribution
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_collapse(dad, dim, g_lb, g_ub)
          INTEGER dad
          INTEGER dim
          INTEGER g_lb, g_ub
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_align(dad, dim, g_lb, g_ub,           &
     &                              offset, stride, gl, gu, rng_parent)
          INTEGER dad
          INTEGER dim
          INTEGER g_lb, g_ub
          INTEGER offset, stride
          INTEGER gl, gu
          INTEGER rng_parent
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_copy(dad, dim, rng_parent)
          INTEGER dad
          INTEGER dim
          INTEGER rng_parent
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_new_array_section(rank, dad_parent)
          INTEGER rank
          INTEGER dad_parent
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_triplet(dad, dim,
     &                                    lb, ub, stride,               &
     &                                    dad_parent, dim_parent)
          INTEGER dad, dad_parent
          INTEGER dim, dim_parent
          INTEGER lb, ub, stride
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_scalar(dad, i, dad_parent, dim_parent)
          INTEGER dad, dad_parent
          INTEGER dim_parent
          INTEGER i
        END
      END INTERFACE


!     INTERFACE
!       INTEGER FUNCTION pcrc_new_array_copy(data, dad_parent)
!         choice  data(...)
!         INTEGER dad_parent
!       END
!     END INTERFACE

      INTEGER pcrc_new_array_copy


      INTERFACE
        SUBROUTINE pcrc_delete_array(dad)
          INTEGER dad
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_group(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_range(dad, dim)
          INTEGER dad
          INTEGER dim
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_size(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_stride(dad, dim)
          INTEGER dad
          INTEGER dim
        END
      END INTERFACE


      INTERFACE
        LOGICAL FUNCTION pcrc_on(grp)
          INTEGER grp
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_reset_array_bounds(dad, dim,                    &
     &      lb, ub, stride, lb_parent, ub_parent, stride_parent)
          INTEGER dad
          INTEGER dim
          INTEGER lb, ub, stride, lb_parent, ub_parent, stride_parent
        END
      END INTERFACE

!      INTERFACE
!        SUBROUTINE pcrc_reset_array_base(dad, data)
!          INTEGER dad
!          choice data(...)
!        END
!      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_local_size(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_glob(rng, l_i)
          INTEGER rng
          INTEGER l_i
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_loc(rng, g_i)
          INTEGER rng
          INTEGER g_i
        END
      END INTERFACE


      INTERFACE
        SUBROUTINE pcrc_loop_bounds(rng, l_lb, l_ub, l_stride)
          INTEGER rng
          INTEGER l_lb, l_ub, l_stride
        END
      END INTERFACE


      INTERFACE
        SUBROUTINE pcrc_shift(dad, dad_source, dim, amount)
          INTEGER dad, dad_source
          INTEGER dim, amount
        END
      END INTERFACE

!     INTERFACE
!       SUBROUTINE pcrc_tshift(data, dad_source, dim, amount)
!         choice  data(...)
!         INTEGER dad_source
!         INTEGER dim, amount
!       END
!     END INTERFACE


      INTERFACE
        SUBROUTINE pcrc_remap(dad, dad_source)
          INTEGER dad, dad_source
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_number_of_processors()
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_distcode(dad, dim)
          INTEGER dad
          INTEGER dim
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_communication_detection(dad, dad_src,     &
     &                                         dim, l0, u0, s0, index0, &
     &                                              l1, u1, s1, index1, &
     &                                         amount )
          INTEGER dad, dad_src
          INTEGER dim
          INTEGER l0(7), u0(7), s0(7), index0(7)
          INTEGER l1(7), u1(7), s1(7), index1(7)
          INTEGER amount(7)
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION  pcrc_is_outofcore(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION  pcrc_in_core_size(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION  pcrc_oc_prefetch_read(dad, array, start,      &
     &                                           stride , number)
          INTEGER dad
          INTEGER array
          INTEGER start, stride, number
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_integer_index(dad)
          INTEGER dad
        END
        INTEGER FUNCTION pcrc_real_index(dad)
          INTEGER dad
        END
        INTEGER FUNCTION pcrc_double_index(dad)
          INTEGER dad
        END
        INTEGER FUNCTION pcrc_complex_index(dad)
          INTEGER dad
        END
        INTEGER FUNCTION pcrc_logical_index(dad)
          INTEGER dad
        END
        INTEGER FUNCTION pcrc_byte_index(dad)
          INTEGER dad
        END
        INTEGER FUNCTION pcrc_word_index(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE  pcrc_mem_init(stacksize,heapsize)
          INTEGER stacksize, heapsize
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION  pcrc_byte_stack_alloc(size,mhandle)
          INTEGER size, mhandle
        END
        INTEGER FUNCTION  pcrc_word_stack_alloc(size,mhandle)
          INTEGER size, mhandle
        END
        INTEGER FUNCTION pcrc_integer_stack_alloc(size, mhandle)
          INTEGER size, mhandle
        END
        INTEGER FUNCTION pcrc_real_stack_alloc(size, mhandle)
          INTEGER size ,mhandle
        END
        INTEGER FUNCTION pcrc_double_stack_alloc(size, mhandle)
          INTEGER size, mhandle
        END
        INTEGER FUNCTION pcrc_complex_stack_alloc(size, mhandle)
          INTEGER size, mhandle
        END
        INTEGER FUNCTION pcrc_logical_stack_alloc(size, mhandle)
          INTEGER size, mhandle
        END
      END INTERFACE


!      INCLUDE 'pcrc_stack.inc'

!2345678901234567890123456789012345678901234567890123456789012345678901234567890
!    &                                                                  &
