/* pcrc_clock.C	-- Guansong Zhang Tue Apr 22 1997
 * Time-stamp: <97/05/19 15:27:37 zgs>
 */

extern "C" {

#include <stdio.h>

#include <stdlib.h>

#include <unistd.h>

#include <sys/times.h>

#include <unistd.h>
#include <limits.h>
}

#include "mpi.h"

#include "extname.h"

//int gethostname(char *name, int namelen);
//extern int AdlibLocId();
extern "C" int MPI_Initialized(...);
extern "C" int MPI_Comm_rank(...);

#define MAXNUM 5 

extern "C" void pcrc_clock(int * num) ;

void pcrc_clock(int * num)
{

  static long CLKTCK = sysconf(_SC_CLK_TCK);

  static struct tms actTimeBuf[MAXNUM+1];
  static clock_t wallTimeBuf[MAXNUM+1];

  static int timeNum=0;

  static char name[25];

  static int procId, flag;

  MPI_Initialized(&flag);
  if (flag) {
//	procId = AdlibLocId();
  	MPI_Comm_rank(MPI_COMM_WORLD, &procId) ;
  }
  else
	procId = 0;

  // printf("....%p %d\n", num, (*num));

  if ((*num) == 0 ) {
    gethostname (name, 25);
    timeNum=0;
    wallTimeBuf[timeNum]=times(& actTimeBuf[timeNum]);  
  } 
  else {
    timeNum++;

    if (timeNum > MAXNUM ) {
      printf("Maximum time is %d\n", (timeNum-1));
      exit(1);
    }

    wallTimeBuf[timeNum]=times(& actTimeBuf[timeNum]);

    //printf (" %d - %d \n",timeNum, timeNum-(*num) );
    
    //printf ( " %ld ----- %ld \n", wallTimeBuf[timeNum], wallTimeBuf[timeNum-(*num)] );
    
    //printf ( " %ld -- \n", CLKTCK);

    //printf ( " %ld -- %ld \n", actTimeBuf[timeNum].tms_utime, actTimeBuf[timeNum].tms_stime );

    if (timeNum < (*num)) {
      printf ("%s(P%d), Rtime: %f, Utime: %f, CUtime: %f, Stime: %f, CStime: %f\n",
	      name, procId,
	      (float)(wallTimeBuf[timeNum]-wallTimeBuf[0])/CLKTCK,
	      (float)(actTimeBuf[timeNum].tms_utime-actTimeBuf[0].tms_utime)/CLKTCK,
	      (float)(actTimeBuf[timeNum].tms_cutime-actTimeBuf[0].tms_cutime)/CLKTCK,
	      (float)(actTimeBuf[timeNum].tms_stime-actTimeBuf[0].tms_stime)/CLKTCK,
	      (float)(actTimeBuf[timeNum].tms_cstime-actTimeBuf[0].tms_cstime)/CLKTCK);
    }
    else {
      printf ("%s(P%d), Rtime: %f, Utime: %f, CUtime: %f, Stime: %f, CStime: %f\n",
              name, procId,
              (float)(wallTimeBuf[timeNum]-wallTimeBuf[timeNum-(*num)])/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_utime-actTimeBuf[timeNum-(*num)].tms_utime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_cutime-actTimeBuf[timeNum-(*num)].tms_cutime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_stime-actTimeBuf[timeNum-(*num)].tms_stime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_cstime-actTimeBuf[timeNum-(*num)].tms_cstime)/CLKTCK);
    }
  }

}


