
#include "strategy.h"
#include "config.h"

#ifdef MEM_ALLOC

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                                                                     !
!  use int_mb,real_mb as the base for any array, for example          !
!                                                                     !
!  index = pcrc_int_get_index(a)                                      !
!  int_mb(index) is equivanlent to a                                  !
!                                                                     !
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

      INTEGER FUNCTION  pcrc_integer_index(dad)
        IMPLICIT NONE
        INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_int_space_index
        
        pcrc_integer_index = pcrc_int_space_index(dad,int_mb(1))
      END 

      INTEGER FUNCTION  pcrc_real_index(dad)
        IMPLICIT NONE
	INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_int_space_index
        
        pcrc_real_index = pcrc_int_space_index(dad,real_mb(1))
      END 

      INTEGER FUNCTION  pcrc_double_index(dad)
        IMPLICIT NONE
	INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_double_space_index
        
        pcrc_double_index=pcrc_double_space_index(dad,dbl_mb(1))
      END 

      INTEGER FUNCTION  pcrc_complex_index(dad)
        IMPLICIT NONE
	INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_double_space_index
        
        pcrc_complex_index=pcrc_double_space_index(dad,scpl_mb(1))
      END 

      INTEGER FUNCTION  pcrc_logical_index(dad)
        IMPLICIT NONE
	INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_int_space_index
        
        pcrc_logical_index = pcrc_int_space_index(dad,log_mb(1))
      END 

      INTEGER FUNCTION  pcrc_byte_index(dad)
        IMPLICIT NONE
	INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_byte_space_index
        
        pcrc_byte_index = pcrc_byte_space_index(dad,byte_mb(1))
      END 

      INTEGER FUNCTION  pcrc_word_index(dad)
        IMPLICIT NONE
	INTEGER dad

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_word_space_index
        
        pcrc_word_index = pcrc_word_space_index(dad,word_mb(1))
      END 
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                                                                     !
!  Stack management.      new strategy                                !
!                                                                     !
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
      SUBROUTINE  pcrc_mem_init(stacksize,heapsize)
        IMPLICIT NONE
        INTEGER  stacksize
        INTEGER  heapsize

	INCLUDE 'mafdecls.inc'

        LOGICAL ok

	ok = MA_init(MT_BYTE , stacksize,heapsize)
	if ( .not. ok ) then
	     print *, "Error: MA_init failed , program halt."
	     call exit()
	endif

      END

      INTEGER FUNCTION pcrc_byte_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_push_get(MT_BYTE,size, 'stack byte block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_byte_stack_alloc failed , program hal&
     &t."
	     call exit()
	endif
	pcrc_byte_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_word_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_push_get(MT_WORD,size, 'stack word block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_word_stack_alloc failed , program hal&
     &t."
	     call exit()
	endif
	pcrc_word_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_integer_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_push_get(MT_INT,size , 'stack int block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_integer_stack_alloc failed , program &
     &halt."
	     call exit()
	endif
	pcrc_integer_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_character_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_push_get(MT_CHAR,size,'stack char block',mhandle,index)
	if ( .not. ok ) then
	     print *,"Error: pcrc_character_stack_alloc failed , program&
     &halt."
	     call exit()
	endif
	pcrc_character_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_real_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_push_get(MT_REAL,size , 'stack real block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_real_stack_alloc failed , program hal&
     &t."
	     call exit()
	endif
	pcrc_real_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_double_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_push_get(MT_DBL,size , 'stack double block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_double_stack_alloc failed , program h&
     &alt."
	     call exit()
	endif
	pcrc_double_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_complex_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok=MA_push_get(MT_SCPL,size,'stack complex block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_complex_stack_alloc failed , program &
     &halt."
	     call exit()
	endif
	pcrc_complex_stack_alloc = index
      END

      INTEGER FUNCTION pcrc_logical_stack_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok=MA_push_get(MT_LOG,size,'stack logical block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_logical_stack_alloc failed , program &
     &halt."
	     call exit()
	endif
	pcrc_logical_stack_alloc = index
      END

      SUBROUTINE pcrc_stack_free(mhandle)
        IMPLICIT NONE
        INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok

	ok = MA_pop_stack(mhandle)
      END


! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                                                                     !
!  Heap management.      new strategy                                !
!                                                                     !
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

      INTEGER FUNCTION pcrc_byte_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_alloc_get(MT_BYTE,size, 'heap byte block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_byte_heap_alloc failed , program halt&
     &."
	     call exit()
	endif
	pcrc_byte_heap_alloc = index
      END

      INTEGER FUNCTION pcrc_word_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_alloc_get(MT_WORD,size, 'heap word block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_word_heap_alloc failed , program halt&
     &."
	     call exit()
	endif
	pcrc_word_heap_alloc = index
      END

      INTEGER FUNCTION pcrc_integer_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_alloc_get(MT_INT,size , 'heap int block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_integer_heap_alloc failed , program h&
     &alt."
	     call exit()
	endif
	pcrc_integer_heap_alloc = index
      END

      INTEGER FUNCTION pcrc_real_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_alloc_get(MT_REAL,size ,'heap real block',mhandle,index)
	if ( .not. ok ) then
	     print *,"Error: pcrc_real_heap_alloc failed , program halt."
	     call exit()
	endif
	pcrc_real_heap_alloc = index
      END

      INTEGER FUNCTION pcrc_double_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok = MA_alloc_get(MT_DBL,size,'heap double block',mhandle,index)
	if ( .not. ok ) then
	     print *,"Error: pcrc_double_heap_alloc failed , program hal&
     &t."
	     call exit()
	endif
	pcrc_double_heap_alloc = index
      END

      INTEGER FUNCTION pcrc_complex_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok=MA_alloc_get(MT_SCPL,size,'heap complex block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_complex_heap_alloc failed , program h&
     &alt."
	     call exit()
	endif
	pcrc_complex_heap_alloc = index
      END

      INTEGER FUNCTION pcrc_logical_heap_alloc(size,mhandle)
        IMPLICIT NONE
	INTEGER size
	INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok
	INTEGER index

	ok=MA_alloc_get(MT_LOG,size ,'heap logical block',mhandle,index)
	if ( .not. ok ) then
	     print *, "Error: pcrc_logical_heap_alloc failed , program h&
     &alt."
	     call exit()
	endif
	pcrc_logical_heap_alloc = index
      END

      SUBROUTINE pcrc_heap_free(mhandle)
        IMPLICIT NONE
        INTEGER mhandle

	INCLUDE 'mafdecls.inc'

	LOGICAL ok

	ok = MA_free_heap(mhandle)
      END

      
! combine pcrc_stack_free & pcrc_heap_free togather
      SUBROUTINE pcrc_mem_free(mhandle)
        IMPLICIT NONE
        INTEGER  mhandle

	INCLUDE 'mafdecls.inc'
	LOGICAL ok, free_ok

        ok = MA_set_error_print(.false.)
        free_ok = MA_pop_stack(mhandle)
        ok = MA_set_error_print(.true.)
        if (.not. free_ok)  free_ok = MA_free_heap(mhandle)
      END

! free memory mem data
      SUBROUTINE pcrc_array_free(dad)
        IMPLICIT NONE
        INTEGER  dad, mhandle

	INCLUDE 'mafdecls.inc'
	INTEGER pcrc_array_memdata

	LOGICAL ok

        mhandle = pcrc_array_memdata(dad)
        if (mhandle .ne. -1) call pcrc_mem_free(mhandle)
      END

#else

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                                                                     !
!  Stack management.                                                  !
!                                                                     !
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

      INTEGER FUNCTION pcrc_integer_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

        base = pcrc_stack_ptr
        pcrc_stack_ptr = base + size
        CALL pcrc_check_stack()

        pcrc_integer_alloc = base
      END
        
      SUBROUTINE pcrc_integer_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        pcrc_stack_ptr = base
      END

      INTEGER FUNCTION pcrc_real_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

        base = pcrc_stack_ptr
        pcrc_stack_ptr = base + size
        CALL pcrc_check_stack()

        pcrc_real_alloc = base
      END
        
      SUBROUTINE pcrc_real_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        pcrc_stack_ptr = base
      END

      INTEGER FUNCTION pcrc_double_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

!       Complications because must be double-word aligned.

        INTEGER object_size
        PARAMETER(object_size = 2)

        base = pcrc_stack_ptr / object_size + 1
        pcrc_stack(object_size * base - 1) = pcrc_stack_ptr
        pcrc_stack_ptr = object_size * (base + size)
        CALL pcrc_check_stack()

        pcrc_double_alloc = base
      END
        
      SUBROUTINE pcrc_double_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        INTEGER object_size
        PARAMETER(object_size = 2)

        pcrc_stack_ptr = pcrc_stack(object_size * base - 1)
      END

      INTEGER FUNCTION pcrc_complex_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

!       Complications because must be double-word aligned.

        INTEGER object_size
        PARAMETER(object_size = 2)

        base = pcrc_stack_ptr / object_size + 1
        pcrc_stack(object_size * base - 1) = pcrc_stack_ptr
        pcrc_stack_ptr = object_size * (base + size)
        CALL pcrc_check_stack()

        pcrc_complex_alloc = base
      END
        
      SUBROUTINE pcrc_complex_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        INTEGER object_size
        PARAMETER(object_size = 2)

        pcrc_stack_ptr = pcrc_stack(object_size * base - 1)
      END

      INTEGER FUNCTION pcrc_logical_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

        base = pcrc_stack_ptr
        pcrc_stack_ptr = base + size
        CALL pcrc_check_stack()

        pcrc_logical_alloc = base
      END
        
      SUBROUTINE pcrc_logical_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        pcrc_stack_ptr = base
      END


      SUBROUTINE pcrc_check_stack()
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        IF(pcrc_stack_ptr .GT. pcrc_stack_size) THEN
          STOP '*** PCRC runtime error.  Stack exhausted. ***'
        ENDIF
      END


      BLOCK DATA
        IMPLICIT NONE
        INCLUDE 'pcrc_stack.inc'
        
        DATA pcrc_stack_ptr /0/
      END

#endif

!2345678901234567890123456789012345678901234567890123456789012345678901234567890
!    &                                                                  &
