/** to translate forall statement into for structure literally,that is**/
/** there is no dependence analysis whether this transformationis legal**/
/** in fact,the dependence analysis is done after this transformation**/
/** If there is no data dependence ocuured,then we can use this literal**/
/** tansformation.Otherwise,we can not **/ 

#include "compilerApi.h"

//this version will point *ppSgStmt to the new for stmt
int ForallToFor(SgStatement **ppSgStmt)
{
    SgStatement *pBody,*pTemp,*pTemp1,*pParent;
    SgLogIfStmt *pLogIf;
    SgForallStmt *pSgForall;
    SgForStmt *pTheLoop;
    SgControlEndStmt *pControlEnd;	
    SgSymbol *doVar;
     SgTripletExp *pTriplet;
    SgExpression *pMask,*pIndex,*pStart,*pEnd,*pStep,*pExp;
    int numOfIndices,nStartL,nEndL;
    int *pBool;

    if(NULL==(pSgForall=isSgForallStmt(*ppSgStmt)))
    {
       printf("error:not a forall statement\n");
       return -1;
    }
    nStartL=pSgForall->lineNumber();
    nEndL=pSgForall->lastNodeOfStmt()->lineNumber();

    pBody=pSgForall->childList1(0);
    if(pBody!=NULL) pBody=pBody->copyPtr();
    pBody->setlineNumber(nStartL); 
    pControlEnd=new SgControlEndStmt;
    pMask=pSgForall->getMask();
    if(pMask!=NULL)
    {
	 pMask=pMask->copyPtr();
         pLogIf=new SgLogIfStmt(*pMask,*pBody);
	 pLogIf->lexNext()->lexNext()->setLexNext(*pControlEnd);
 	 pBody=pLogIf;
    }
    else
	pBody->setLexNext(*pControlEnd);	

    numOfIndices=pSgForall->indexNumber();
  
    int i;
    for(i=numOfIndices-1;i>=0;i--)
    {
        doVar=pSgForall->getIndexName(i);
        pIndex=pSgForall->getIndex(i);
        pExp=pIndex->operand(2);
        if(NULL==(pTriplet=isSgTripletExp(pExp)))
        {
          printf("error\n");
          return -1;
        }
        pStart=pTriplet->item(0);
        if(pStart!=NULL) pStart=pStart->copyPtr();
        pEnd=pTriplet->item(1);
        if(pEnd!=NULL) pEnd=pEnd->copyPtr();
        pStep=pTriplet->item(2); 
        if(pStep!=NULL) pStep=pStep->copyPtr();
	
	pTheLoop=new SgForStmt(doVar,pStart,pEnd,pStep,pBody);
        pBody=pTheLoop;
    }
    printf("in FORALLTOFOR: pTheloop is \n");
    pTheLoop->unparsestdout();
    printf("FORALL STMT's control parentis \n");
    pParent=pSgForall->controlParent();	
    pTemp=pSgForall->lexPrev();
    pTemp1=pSgForall->lastNodeOfStmt()->lexNext();

    
    //pSgForall->replaceWithStmt(*pTheLoop);
    pTemp->insertStmtAfter(*pTheLoop,*pParent);
    pSgForall->deleteStmt();

    pTheLoop->lastNodeOfStmt()->setLexNext(*pTemp1);

    printf("after replace,FORALL STMT's control parent is \n");
    pParent->unparsestdout();	
    delete pSgForall;
    pTheLoop->setlineNumber(nStartL);
    pTheLoop->lastNodeOfStmt()->setlineNumber(nEndL); 
    (*ppSgStmt)=pTheLoop;
    return 0;
}

#if 0

//this version cares not about pSgStmt's value after return

 
int ForallToFor(SgStatement *pSgStmt)
{
    SgStatement *pBody;
    SgLogIfStmt *pLogIf;
    SgForallStmt *pSgForall;
    SgForStmt *pTheLoop;
    SgSymbol *doVar;
    SgTripletExp *pTriplet;
    SgExpression *pMask,*pIndex,*pStart,*pEnd,*pStep,*pExp;
    int numOfIndices;

    if(NULL==(pSgForall=isSgForallStmt(pSgStmt)))
    {
       printf("error:not a forall statement\n");
       return -1;
    }
    printf("Forall line number is %d\n",pSgForall->lineNumber()); 
    pBody=pSgForall->childList1(0);
    if(pBody!=NULL) pBody=pBody->copyPtr();
    pMask=pSgForall->getMask();
    if(pMask!=NULL)
    {
	 pMask=pMask->copyPtr();
         pLogIf=new SgLogIfStmt(*pMask,*pBody);
 	 pBody=pLogIf;
    }
    int i;
    for(i=numOfIndices-1;i>=0;i--)
    {
        doVar=pSgForall->getIndexName(i);
        pIndex=pSgForall->getIndex(i);
        pExp=pIndex->operand(2);
        if(NULL==(pTriplet=isSgTripletExp(pExp)))
        {
          printf("error\n");
          return -1;
        }
        pStart=pTriplet->item(0);
        if(pStart!=NULL) pStart=pStart->copyPtr();
        pEnd=pTriplet->item(1);
        if(pEnd!=NULL) pEnd=pEnd->copyPtr();
        pStep=pTriplet->item(2); 
        if(pStep!=NULL) pStep=pStep->copyPtr();
	pTheLoop=new SgForStmt(doVar,pStart,pEnd,pStep,pBody);
        pBody=pTheLoop;
    }
    pSgForall->replaceWithStmt(*pTheLoop);
    delete pSgForall;
     
    return 0;
}

#endif

/*change forall construct statement to do loop,this is a intuitive transformation,aiming at getting the dependence relationships */

extern SgStatement **ppSgForallConstruct;

int ForallConstructToFor(SgStatement **ppSgStmt)
{
    SgStatement *pBody,*pChild,*pTemp,*pParent,*pTemp1,*pTemp2;
    SgIfStmt *pIf;
    SgStatement *pSgForallConstruct;
    SgExprListExp *pSgList;
    SgForStmt *pTheLoop;
    SgControlEndStmt *pControlEnd;	
    SgSymbol *doVar;
    SgTripletExp *pTriplet;
    SgExpression *pMask,*pIndex,*pStart,*pEnd,*pStep,*pExp;
    int numOfIndices,nStartL,nEndL;
    static int N=0;

    printf("######################forallconstructtofor called %d times\n",++N);
    printf("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n");
    
    pSgForallConstruct=*ppSgStmt;
    ASSERT(pSgForallConstruct);
    if(pSgForallConstruct->variant()!=FORALL_CONSTRUCT_STMT)
    {
       printf("error:not a forall construct statement\n");
       return -1;
    }

    nStartL=pSgForallConstruct->lineNumber();
    nEndL=pSgForallConstruct->lastNodeOfStmt()->lineNumber();

    pBody=pSgForallConstruct->childList1(0);
    if(pBody!=NULL) pBody=pBody->copyOnePtr();
    pBody->setlineNumber(nStartL); 

    //numOfIndices=pSgForallConstruct->indexNumber();
    pSgList=(SgExprListExp*) (pSgForallConstruct->expr(0))->lhs();
    numOfIndices=pSgList->length();
 
    int i;
    for(i=numOfIndices-1;i>=0;i--)
    {
        //doVar=pSgForallConstruct->getIndexName(i);
        doVar=pSgList->elem(i)->lhs()->symbol();

        //pIndex=pSgForallConstruct->getIndex(i);
        pIndex=pSgList->elem(i);

        pExp=pIndex->operand(2);
        if(NULL==(pTriplet=isSgTripletExp(pExp)))
        {
          printf("error\n");
          return -1;
        }
        pStart=pTriplet->item(0);
        if(pStart!=NULL) pStart=pStart->copyPtr();
        pEnd=pTriplet->item(1);
        if(pEnd!=NULL) pEnd=pEnd->copyPtr();
        pStep=pTriplet->item(2); 
        if(pStep!=NULL) pStep=pStep->copyPtr();

	pControlEnd=new SgControlEndStmt();

        if(i==numOfIndices-1)
        {
            pMask=pSgForallConstruct->expr(1);
	    if(pMask==NULL)
	    {
	       pChild=pSgForallConstruct->childList1(0);
               ASSERT(pChild);
	       pTemp=pChild->copyBlockPtr();

	       printf("The BLOCK::::::::::::::::\n");	
	       for(pTemp2=pChild,pTemp1=pTemp;(pTemp2->variant()!=CONTROL_END || pTemp2->controlParent()!=pSgForallConstruct) ;pTemp2=pTemp2->lexNext(),pTemp1=pTemp1->lexNext())
	        {
			if(pTemp1->lexNext()->variant()==FORALL_CONSTRUCT_STMT)
			{
				printf("FOUND\n");
				break;
			}
			//printf("variant is %d \n",pTemp1->variant());
			pTemp1->unparsestdout();
		}
	       pTemp1->setLexNext(*pControlEnd);//PPPPPP
	       pTheLoop=new SgForStmt(doVar,pStart,pEnd,pStep,pTemp);
 	    }
            else
	    {
	       pChild=pSgForallConstruct->childList1(0);
               ASSERT(pChild);
	       pTemp=pChild->copyBlockPtr();
	       for(pTemp2=pChild,pTemp1=pTemp;(pTemp2->variant()!=CONTROL_END || pTemp2->controlParent()!=pSgForallConstruct) ;pTemp2=pTemp2->lexNext(),pTemp1=pTemp1->lexNext())
	        {
			if(pTemp1->lexNext()->variant()==FORALL_CONSTRUCT_STMT)
				break;
		}
	       pTemp1->setLexNext(*pControlEnd);//PPPPPP
	       pIf=new SgIfStmt(*pMask,*pTemp);
	       pTheLoop= new SgForStmt(doVar,pStart,pEnd,pStep,pIf);
	    } 
	    pBody=pTheLoop;	
        }
        else
        { 
	    pTheLoop=new SgForStmt(doVar,pStart,pEnd,pStep,pBody);
            pBody=pTheLoop;
        }
	printf("unparse the %d inner loop\n",i);
	pTheLoop->unparsestdout();
    }


    printf("in FORALLCONSTRUCT TO FOR : Before replace\n");
    pTemp=pSgForallConstruct->lexPrev();
    pTemp1=pSgForallConstruct->lastNodeOfStmt()->lexNext();
    //pTemp->unparsestdout();
    pParent=pSgForallConstruct->controlParent();
    pTemp->insertStmtAfter(*pTheLoop,*pParent);
    pSgForallConstruct->deleteStmt();

    printf("after insert,pTheloop's Next is \n");
    pTheLoop->lastNodeOfStmt()->lexNext()->unparsestdout();
    pTheLoop->lastNodeOfStmt()->setLexNext(*pTemp1);

#if 0  
    printf("unparse the construct's CP,after replace\n");
    pParent->unparsestdout();
#endif

#if 0
    printf("Lets see the bitch's BLOCK:>>>>>>>>>>>>>>>>>\n");
    for(pTemp1=pParent->childList1(0);pTemp1->variant()!=CONTROL_END;pTemp1=pTemp1->lexNext())
    {
	if(pTemp1->variant()==FORALL_CONSTRUCT_STMT)
	{
		printf("FOUND\n");
	}
	//printf("variant is %d \n",pTemp1->variant());
	pTemp1->unparsestdout();
    }
    //printf("in FORALLCONSTRUCT TO FOR : After replace\n");
#endif

    delete pSgForallConstruct;
    pTheLoop->setlineNumber(nStartL);
    pTheLoop->lastNodeOfStmt()->setlineNumber(nEndL); 

   (*ppSgStmt)=pTheLoop;
    return 0;
}

