#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/CascadeB.h>
#include <Xm/ScrolledW.h>
#include <Xm/RowColumn.h>
#include <Xm/Separator.h>
#include <Xm/DrawingA.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>
#include <Xm/ToggleB.h>

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>

#include "compilerApi.h"
#include "../depInterface.h"
#include "Vdep.h"

#define N 30
#define FORALL_TMP_FILE ".forall.tmp.txt"
#define FORALL_CONSTRUCT_TMP_FILE ".forallconstruct.tmp.txt"
#define FOR_TMP_FILE	".for.tmp.txt"
#define INDEPENDENT_TMP_FILE ".independent.tmp.txt" 

char *getListFileName(char *depFileName);
int  loadProgTree(char *depFile);
int modifyForallList(void);
int modifyForallConstructList(void);
int initColors(Widget w);
int dispTreeView(Widget treeView_wid);
int dispNodeAndChildren(Widget parentWid,SgStatement *pSgStmt,SgStatement *pSgNewStmt, int nLevel,int *pnthButton,int nParentWidID);
int getTextPositions(char *pText,int nStartL,int nEndLine,XmTextPosition *startPosi,XmTextPosition *endPosi);
void clearUpResources(void);
void clearUpTreeWid(void);
void initResources(void);
Widget createErrDialog(char *pErrMessage);
Widget createMessageOKDialog(Widget w,char *pMessage);


SgProject	*pTheProject=NULL,*pNewProject=NULL;
SgFile		*pTheFile=NULL,*pNewFile=NULL;
SgStatement 	**ppSgForall=NULL,**ppSgForallConstruct=NULL;
int 		nForallCount=0,nForallConstructCount=0; /** how many forall and forallconstruct stmt**/ 
SgStatement	**ppSgFor=NULL;
int		nForCount=0; 
int		nForall=0,nForallConstruct=0;
int		nFor=0;
Widget	 	prog_wid;	/**the wid to show the list file**/ 
Widget		top_wid,mainwin_wid,drawArea_wid; 
Widget		form_wid,tree_wid;
char 		*pText;		/**for to contain the list file**/
Widget		buttonSelected=NULL;	/**to the selected button**/
Pixel		normalForeground,selectForeground,forallForeground,forForeground,independentForeground,forallConstructForeground;
Pixel		restoreForeground;	
int		bSelected=0;     //at beginig,no button was selected
int 		bFilter=0;

/**call backs**/
void pushed_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void pushedfor_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void pushedindependent_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);	//not used now
void pushedforall_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void pushedforallconstruct_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void destroy_fn(Widget w,XtPointer client_data,
		XmAnyCallbackStruct *cbs);
void openDep_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void exit_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs);
void filtertoggle_fn(Widget w, XtPointer client_data,
               XmAnyCallbackStruct *cbs);
void fileSelActivated_fn(Widget w,caddr_t,
                          XmFileSelectionBoxCallbackStruct *cbs);
void fileSelCanceled_fn(Widget w,caddr_t,
                          XmFileSelectionBoxCallbackStruct *cbs);

main(int argc,char **argv)
{
  Widget menubar_wid,filepulldown_wid,option_wid;
  Widget filecascade_wid,optioncascade_wid;
  Widget openButton,exitButton,filterButton;
  XtAppContext app;
  XmString labelText;
  Arg args[N];
  int n;
  
  top_wid=XtVaAppInitialize(&app,"depAnalyser",NULL,0,
				&argc,argv,NULL,NULL);

  //XtAddCallback(top_wid,XmNdestroyCallback,destroy_fn,NULL);
  
  mainwin_wid=XtVaCreateManagedWidget("main_window",
        xmMainWindowWidgetClass,top_wid,NULL);
  
  initColors(mainwin_wid);

  XtAddCallback(mainwin_wid,XmNdestroyCallback,destroy_fn,NULL);
  /***create meuus***/
  menubar_wid=XmCreateMenuBar(mainwin_wid,"depAnalyser menubar",NULL,0);
  XtManageChild(menubar_wid);
  filepulldown_wid=XmCreatePulldownMenu(menubar_wid,"filemenu",NULL,0);

  n = 0;
  labelText=XmStringCreateSimple("File");
  XtSetArg(args[n],XmNlabelString,labelText);n++;
  XtSetArg(args[n],XmNsubMenuId,filepulldown_wid); n++;
  XtSetArg(args[n],XmNmnemonic,'F');n++;
  filecascade_wid=XmCreateCascadeButton(menubar_wid,"filecascade",args,n);
  XtManageChild(filecascade_wid);
  XmStringFree(labelText);

  n = 0;
  labelText=XmStringCreateSimple("Open");
  XtSetArg(args[n],XmNlabelString,labelText);n++;
  XtSetArg(args[n],XmNmnemonic,'O');n++;
  openButton=XmCreatePushButton(filepulldown_wid,"openbutton", args,n);
  XtManageChild (openButton);
  XmStringFree(labelText);
  XtAddCallback(openButton,XmNactivateCallback,openDep_fn,NULL);

  n = 0;
  labelText=XmStringCreateSimple("Exit");
  XtSetArg(args[n],XmNlabelString,labelText);n++;
  XtSetArg(args[n],XmNmnemonic,'E');n++;
  exitButton=XmCreatePushButton(filepulldown_wid,"exitbutton",args,n);
  XtManageChild (exitButton);
  XmStringFree(labelText);
  XtAddCallback(exitButton,XmNactivateCallback,exit_fn,NULL);

  option_wid=XmCreatePulldownMenu(menubar_wid,"optionmenu",NULL,0);

  n = 0;
  labelText=XmStringCreateSimple("Options");
  XtSetArg(args[n],XmNlabelString,labelText);n++;
  XtSetArg(args[n],XmNsubMenuId,option_wid); n++;
  XtSetArg(args[n],XmNmnemonic,'O');n++;
  optioncascade_wid=XmCreateCascadeButton(menubar_wid,"opcascade",args,n);
  XtManageChild(optioncascade_wid);
  XmStringFree(labelText);

  n = 0;
  labelText=XmStringCreateSimple("filter forallstmt");
  XtSetArg(args[n],XmNlabelString,labelText);n++;
  XtSetArg(args[n],XmNmnemonic,'f');n++;
  filterButton=XmCreateToggleButton(option_wid,"filterbutton", args,n);
  XtManageChild (filterButton);
  XmStringFree(labelText);

  XtAddCallback(filterButton,XmNarmCallback,filtertoggle_fn,NULL);

  form_wid=XtVaCreateManagedWidget("form",xmFormWidgetClass,mainwin_wid,NULL);
  
  n=0;
  XtSetArg(args[n],XmNscrollingPolicy,XmAUTOMATIC);n++;
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_POSITION);n++;
  XtSetArg(args[n],XmNrightPosition,50);n++;
  tree_wid=XmCreateScrolledWindow(form_wid,"TreeView",args,n);
  XtManageChild(tree_wid);
  
  drawArea_wid=XmCreateDrawingArea(tree_wid,"DrawArea",NULL,0);
  XtManageChild(drawArea_wid);

  /***********************CORE PROCESSING OPERATIONS*****************/
  if(argc==2)
  {
     if(loadProgTree(argv[1])==0) /*load program succeed*/
     {

        dispTreeView(drawArea_wid);
        modifyForallList();
        modifyForallConstructList();
        doDependenceAnalysisOnTheFullFile(pNewFile,0,0,0);
     }
  }
  /***********************END CORE PROCESSING************************/

  n=0;
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_POSITION);n++;
  XtSetArg(args[n],XmNleftPosition,51);n++;
  XtSetArg(args[n],XmNeditMode,XmMULTI_LINE_EDIT);n++;
  XtSetArg(args[n],XmNrows,25);n++;
  XtSetArg(args[n],XmNcolumns,50);n++;
  XtSetArg(args[n],XmNeditable,True);n++;
 
  prog_wid=XmCreateScrolledText(form_wid,"ProgView",args,n);
  pText=readFile(getListFileName(argv[1]));
  XmTextSetString(prog_wid,pText);
  XtManageChild(prog_wid);
  
  XtRealizeWidget(top_wid); 
  XtAppMainLoop(app); 

}

/*---------------------funcs about motif and widgets----------------*/
/***load the dep file and make it into Sg classes*****/
/**We see that the SgFile has a public member :PTR_FILE filept;
   PTR_FILE is defined in the file :typedef.h;
   and in this struct we can get the number of total BIFs in the file.**/ 

int loadProgTree(char *depFile)
{
   char *args[2];
   SgStatement *pSgStmt;

   args[1]=depFile; 
   pTheProject= new SgProject("",2,args);
   pNewProject= new SgProject("",2,args);	//make a copy
   /**while the above may seem silly,it is a historical problem**/
   /**I will not try to make it straight**/

   if(pTheProject==NULL || pNewProject==NULL)
   {
      Widget err_w;
      err_w=createErrDialog("Error:invalid project");
      XtManageChild(err_w);
      return(-1);
   }
   pTheFile=&(pTheProject->file(0));
   pNewFile=&(pNewProject->file(0));

   pSgStmt=pTheFile->firstStatement();
   while(pSgStmt)
   {
     if((pSgStmt->variant())==FORALL_STMT) nForallCount++;
     else
	if((pSgStmt->variant())==FOR_NODE) nForCount++; 
     else
	if((pSgStmt->variant())==FORALL_CONSTRUCT_STMT) nForallConstructCount++;

     pSgStmt=pSgStmt->lexNext();
   }
   ppSgForall =new SgStatement *[nForallCount];
   ppSgForallConstruct =new SgStatement *[nForallConstructCount];
   ppSgFor=new SgStatement *[nForCount]; 
  
   return (0);
}


int initColors(Widget w)
{	
    XColor theColor;
    Colormap theMap;

    theColor.red=65535;
    theColor.green=65535;
    theColor.blue=0;
    theMap=DefaultColormapOfScreen(XtScreen(w));    
    XAllocColor(XtDisplay(w), theMap, &theColor);
    selectForeground=theColor.pixel;
    
    theColor.red=0;
    theColor.green=0;
    theColor.blue=0;
    XAllocColor(XtDisplay(w), theMap, &theColor);
    normalForeground=theColor.pixel;

    theColor.red=0;
    theColor.green=65535;
    theColor.blue=65535;
    XAllocColor(XtDisplay(w), theMap, &theColor);
    forForeground=theColor.pixel;

    theColor.red=0;
    theColor.green=0;
    theColor.blue=65535;
    XAllocColor(XtDisplay(w), theMap, &theColor);
    forallForeground=theColor.pixel;

    theColor.red=65535;
    theColor.green=0;
    theColor.blue=0;
    XAllocColor(XtDisplay(w), theMap, &theColor);
    forallConstructForeground=theColor.pixel;

    theColor.red=65535;
    theColor.green=0;
    theColor.blue=65535;
    XAllocColor(XtDisplay(w), theMap, &theColor);
    independentForeground=theColor.pixel;
    return 0;
}

/***display the program tree into the widget***/
int dispTreeView(Widget treeView_wid)
{
    SgStatement *pSgStmt,*pSgNewStmt;
    int nButtons=0;
    
    ASSERT(pTheFile); 	//pTheFile is a global
    pSgStmt=pTheFile->firstStatement();
    pSgNewStmt=pNewFile->firstStatement();
    nForall=0;
    nForallConstruct=0;
    nFor=0;
    dispNodeAndChildren(treeView_wid,pSgStmt,pSgNewStmt,0,&nButtons,0); 
} 

int dispNodeAndChildren(Widget parent_wid,SgStatement *pSgStmt,SgStatement *pSgNewStmt,int nLevel,int *pnthButton,int nParentWidID)
{
   const int nBLength=80,
	     nBHeight=30,
	     nBaseX=20,
	     nBaseY=20,	
	     nVLineLength=20,
 	     nHLineLength=40;

   char *tag[1000];
   #include "../tools/Vdump/tag.h"/**assign tag,such astag[VAR_DECL]="VAR_DECL"**/

   SgForallStmt *pSgForall;
   SgStatement *pSgForallConstruct;
   SgForStmt *pSgFor;
   //SgIndependentStmt *pSgIndependent;
   SgStatement *pTempStmt,*pTempNew;

   int lineX,lineY,buttonX,buttonY;
   Widget button_wid,line_wid;
   Arg args[N];
   char *buttonTag;
   XmString buttonText;
   int i,nMyID,n=0;

   nMyID=*pnthButton;
   
   buttonX=nLevel*(nBLength/2+nHLineLength)+nBaseX;
   buttonY=nMyID*(nBHeight/2+nVLineLength)+nBaseY;

   //printf("(buttonX,buttonY) is (%d,%d)",buttonX,buttonY);

   buttonTag=tag[pSgStmt->variant()];
   //printf("button %s has a ID of %d\n",buttonTag,pSgStmt->id());
   buttonText=XmStringCreateSimple(buttonTag);
   XtSetArg(args[n],XmNlabelString,buttonText);n++;
   XtSetArg(args[n],XmNwidth,nBLength);n++;
   XtSetArg(args[n],XmNheight,nBHeight);n++;
   XtSetArg(args[n],XmNx,buttonX);n++;
   XtSetArg(args[n],XmNy,buttonY);n++;
   switch(pSgStmt->variant()){
	case FORALL_STMT:
   	    if(NULL!=(pSgForall=isSgForallStmt(pSgStmt)))
   	    {
       	     XtSetArg(args[n],XmNforeground,forallForeground);n++; 
             button_wid=XmCreatePushButton(parent_wid,"BifButton",args,n);
             ppSgForall[nForall]=pSgNewStmt; 
             XtAddCallback(button_wid,XmNactivateCallback,pushedforall_fn,(XtPointer)&(ppSgForall[nForall]));
             nForall++;
            }
	    break;
	case FORALL_CONSTRUCT_STMT:
   	    if(NULL!=(pSgForallConstruct=pSgStmt))
   	    {
       	     XtSetArg(args[n],XmNforeground,forallConstructForeground);n++; 
             button_wid=XmCreatePushButton(parent_wid,"BifButton",args,n);
             ppSgForallConstruct[nForallConstruct]=pSgNewStmt; 
             XtAddCallback(button_wid,XmNactivateCallback,pushedforallconstruct_fn,(XtPointer)&(ppSgForallConstruct[nForallConstruct]));
             nForallConstruct++;
            }
	    break;
	case FOR_NODE:
   	    if(NULL!=(pSgFor=isSgForStmt(pSgStmt)))
   	    {
       	     XtSetArg(args[n],XmNforeground,forForeground);n++; 
             button_wid=XmCreatePushButton(parent_wid,"BifButton",args,n);
             ppSgFor[nFor]=pSgNewStmt; 
             XtAddCallback(button_wid,XmNactivateCallback,pushedfor_fn,(XtPointer)&(ppSgFor[nFor]));
             nFor++;
            }
	    break;
	default:
            XtSetArg(args[n],XmNforeground,normalForeground);n++; 
            button_wid=XmCreatePushButton(parent_wid,"BifButton",args,n);
   	    XtAddCallback(button_wid,XmNactivateCallback,pushed_fn,(XtPointer)pSgStmt);
   }

   XtManageChild(button_wid);

   lineY=buttonY+nBHeight/2;
   lineX=buttonX-nHLineLength;

   if(*pnthButton!=0)
   {
      n=0;
      XtSetArg(args[n],XmNorientation,XmHORIZONTAL);n++;
      XtSetArg(args[n],XmNwidth,nHLineLength);n++;
      XtSetArg(args[n],XmNx,lineX);n++;
      XtSetArg(args[n],XmNy,lineY);n++;
      line_wid=XmCreateSeparator(parent_wid,"Separaror",args,n);
      XtManageChild(line_wid);
   }
  
   (*pnthButton)++;

   if(pSgStmt->controlParent())
   {  
      if(pSgStmt->variant()==CONTROL_END || pSgStmt==(pSgStmt->controlParent()->lastNodeOfStmt()))
      {
         /**draw the vertical separator line**/
         lineX=buttonX-nHLineLength;
         lineY=buttonY+nBHeight/2-(nMyID-nParentWidID)*(nVLineLength+nBHeight/2);
         //printf("(lineonX,lineonY) is (%d,%d)",lineX,lineY);
         //printf("%s-parent is %s\n",tag[pSgStmt->variant()],tag[pSgStmt->controlParent()->variant()]);
        
	 n=0;
         XtSetArg(args[n],XmNorientation,XmVERTICAL);n++;
         XtSetArg(args[n],XmNheight,(nBHeight/2+nVLineLength)*(nMyID-nParentWidID));n++;
         XtSetArg(args[n],XmNx,lineX);n++;
         XtSetArg(args[n],XmNy,lineY);n++;
         line_wid=XmCreateSeparator(parent_wid,"Separaror",args,n);
         XtManageChild(line_wid);
      }
   }

   for(i=0;i<pSgStmt->numberOfChildrenList1();i++)
   { 
      pTempStmt=pSgStmt->childList1(i);
      pTempNew=pSgNewStmt->childList1(i);
      dispNodeAndChildren(parent_wid,pTempStmt,pTempNew,nLevel+1,pnthButton,nMyID);
   }
   for(i=0;i<pSgStmt->numberOfChildrenList2();i++)
   { 
      pTempStmt=pSgStmt->childList2(i);
      pTempNew=pSgNewStmt->childList2(i);
      dispNodeAndChildren(parent_wid,pTempStmt,pTempNew,nLevel+1,pnthButton,nMyID);
   }
}

/***********create an messagebox with only OK button*********/   
Widget createMessageOKBox(Widget parent,char *pMessage)
{
    Widget wid,remove_wid;
    XmString msgString;
    Arg args[N];
    int n=0;
    
    msgString=XmStringCreateSimple(pMessage);
    XtSetArg(args[n],XmNmessageString,msgString);n++;
    wid=XmCreateMessageBox(parent,"MsgDialog",args,n);
    remove_wid=XmMessageBoxGetChild(wid,XmDIALOG_HELP_BUTTON);
    XtUnmanageChild(remove_wid);
    remove_wid=XmMessageBoxGetChild(wid,XmDIALOG_CANCEL_BUTTON);
    XtUnmanageChild(remove_wid);  
   
    XmStringFree(msgString);
    return wid;
}

/**create an error messagebox  with only OK button**/
Widget createErrDialog(char *pErrMessage)
{
     Widget errDialog_wid,remove_wid;
     XmString errString;
     Arg args[N];
     int n=0;

     errString=XmStringCreateSimple(pErrMessage);
     XtSetArg(args[n],XmNmessageString,errString);n++;
     errDialog_wid=XmCreateErrorDialog(top_wid,"ErrorDialog",args,n);
     remove_wid=XmMessageBoxGetChild(errDialog_wid,XmDIALOG_HELP_BUTTON);
     XtUnmanageChild(remove_wid);
     remove_wid=XmMessageBoxGetChild(errDialog_wid,XmDIALOG_CANCEL_BUTTON);
     XtUnmanageChild(remove_wid);  
     XmStringFree(errString);

     return errDialog_wid; 
}

/**++++++++++++++++++call back functions+++++++++++++++++++++*/
void openDep_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
    Widget dialog, remove;
    XmString mask;
    Arg args[N];
    int n;
       
    /* Create the FileSelectionDialog */     
    mask  = XmStringCreateSimple("*.dep");
    n=0;
    XtSetArg(args[n], XmNdirMask, mask);n++;
    XtSetArg(args[n],XmNautoUnmanage,True);n++;

    dialog = XmCreateFileSelectionDialog(top_wid,"FileSelectDialog", args, n); 
    XmStringFree(mask);  
    XtAddCallback(dialog, XmNokCallback, fileSelActivated_fn,NULL); 
    XtAddCallback(dialog, XmNcancelCallback, fileSelCanceled_fn,NULL);

    remove = XmFileSelectionBoxGetChild(dialog,XmDIALOG_HELP_BUTTON); 
    XtUnmanageChild(remove); /* delete HELP BUTTON */

    XtManageChild(dialog);
    //XtPopup(XtParent(dialog), XtGrabNone); 
}

void fileSelActivated_fn(Widget w,caddr_t,
                          XmFileSelectionBoxCallbackStruct *cbs)
{
     char *pFileName,listFileName[256];

     memset(listFileName,0,256);
     XmStringGetLtoR(cbs->value,XmSTRING_DEFAULT_CHARSET,
			 &pFileName);
     clearUpResources();
     initResources();
     if(loadProgTree(pFileName)==0) /*load program succeed*/
     {
        clearUpTreeWid(); 
        dispTreeView(drawArea_wid);
        modifyForallList();
        modifyForallConstructList();
        doDependenceAnalysisOnTheFullFile(pNewFile,0,0,0);
        strcpy(listFileName,getListFileName(pFileName)); 
        pText=readFile(listFileName);
        XmTextSetString(prog_wid,pText);
     }
     else
     {
        Widget err_w;
        err_w=createErrDialog("Error:error in the dep file");
        XtManageChild(err_w);
     } 
    XtDestroyWidget(w);
    return; 
}

void fileSelCanceled_fn(Widget w,caddr_t,
                          XmFileSelectionBoxCallbackStruct *cbs)
{
   XtDestroyWidget(w);
   return;
}

void exit_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
    clearUpResources();
    exit(0); 
}

void filtertoggle_fn(Widget w, XtPointer client_data,
               XmAnyCallbackStruct *cbs)
{
	if(bFilter==0) bFilter=1;
	else	bFilter=0;

}
void pushed_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
  SgStatement *pSgStmt,*pTempStmt;
  XmTextPosition startP,endP;
  int nStartL,nEndL;
  Arg args[N];
  int n=0;

  pTheFile->unparsestdout();
  pNewFile->unparsestdout();

  if(bSelected)
  {
    /**restore the fomer slected button's foreground text into original color**/
    XtSetArg(args[n],XmNforeground,restoreForeground);n++;
    XtSetValues(buttonSelected,args,n);
  }
  else
  {
  	bSelected=1;  
  }
  /**set the current widget's fore ground text into selection color**/
  buttonSelected=w;
  restoreForeground=normalForeground;
  XtVaSetValues(w,XmNforeground,selectForeground,NULL);

  pSgStmt=(SgStatement *)client_data;
  //pSgStmt->unparsestdout();
  nStartL=pSgStmt->lineNumber();
  pTempStmt=pSgStmt->lastNodeOfStmt();
  nEndL=pTempStmt->lineNumber();

  //set the selection to the text widget
  getTextPositions(pText,nStartL,nEndL,&startP,&endP);
  XmTextSetSelection(prog_wid,startP,endP,0);

  
  /***********Now about dependence***************/
/*
  depGraph *pTheDepG;
  Widget dlg_wid;
  pTheDepG=(depGraph*)(pSgStmt->attributeValue(0,DEPGRAPH_ATTRIBUTE));
  if(pTheDepG==NULL)
  {
     //printf("null depgraph\n");
     Widget errDialog_wid;
     errDialog_wid=createErrDialog("Error:Null dependence graph");
     XtManageChild(errDialog_wid);
     return;
  }
  else
  {
      FILE *pFile;
      if(NULL==(pFile=fopen(FOR_TMP_FILE,"w")))
         return;
      else
      {
          pTheDepG->outToFile(pFile);
          fclose(pFile);	 
          dlg_wid=create_Forall_dlg(top_wid,FOR_TMP_FILE);
          ASSERT(dlg_wid);
          XtManageChild(dlg_wid);
      }
  }
*/
}

#if 0
void pushedindependent_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
  SgStatement *pSgStmt,*pTempStmt;
  XmTextPosition startP,endP;
  int nStartL,nEndL;
  Arg args[N];
  int n=0;

  if(bSelected)
  {
    /**restore the fomer slected button's foreground text into original color**/
    XtSetArg(args[n],XmNforeground,restoreForeground);n++;
    XtSetValues(buttonSelected,args,n);
  }
  else
  {
  	bSelected=1;  
  }
  /**set the current widget's fore ground text into selection color**/
  buttonSelected=w;
  restoreForeground=independentForeground;
  XtVaSetValues(w,XmNforeground,selectForeground,NULL);

  pSgStmt=(SgStatement *)client_data;
  nStartL=pSgStmt->lineNumber();
  pTempStmt=pSgStmt->lastNodeOfStmt();
  nEndL=pTempStmt->lineNumber();

  //set the selection to the text widget
  getTextPositions(pText,nStartL,nEndL,&startP,&endP);
  XmTextSetSelection(prog_wid,startP,endP,0);

  
  /***********Now about dependence***************/
  depGraph *pTheDepG;
  Widget dlg_wid;
  pTheDepG=(depGraph*)(pSgStmt->attributeValue(0,DEPGRAPH_ATTRIBUTE));
  if(pTheDepG==NULL)
  {
     //printf("null depgraph\n");
     Widget errDialog_wid;
     errDialog_wid=createErrDialog("Error:Null dependence graph");
     XtManageChild(errDialog_wid);
     return;
  }
  else
  {
      FILE *pFile;
      if(NULL==(pFile=fopen(FOR_TMP_FILE,"w")))
         return;
      else
      {
          pTheDepG->outToFile(pFile);
          fclose(pFile);	 
          dlg_wid=create_Forall_dlg(top_wid,FOR_TMP_FILE);
          ASSERT(dlg_wid);
          XtManageChild(dlg_wid);
      }
  }
}

#endif

void pushedfor_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
  SgStatement *pSgStmt,*pTempStmt;
  XmTextPosition startP,endP;
  int nStartL,nEndL;
  Arg args[N];
  int n=0;

  if(bSelected)
  {
    /**restore the fomer slected button's foreground text into original color**/
    XtSetArg(args[n],XmNforeground,restoreForeground);n++;
    XtSetValues(buttonSelected,args,n);
  }
  else
  {
  	bSelected=1;  
  }
  /**set the current widget's fore ground text into selection color**/
  buttonSelected=w;
  restoreForeground=forForeground;
  XtVaSetValues(w,XmNforeground,selectForeground,NULL);

  pSgStmt=*((SgStatement **)client_data);
  nStartL=pSgStmt->lineNumber();
  pTempStmt=pSgStmt->lastNodeOfStmt();
  nEndL=pTempStmt->lineNumber();

  //set the selection to the text widget
  getTextPositions(pText,nStartL,nEndL,&startP,&endP);
  XmTextSetSelection(prog_wid,startP,endP,0);

  
  /***********Now about dependence***************/
  depGraph *pTheDepG;
  Widget dlg_wid;
   pTheDepG=(depGraph*)(pSgStmt->attributeValue(0,DEPGRAPH_ATTRIBUTE));
  if(pTheDepG==NULL)
  {
     //printf("null depgraph\n");
     Widget errDialog_wid;
     errDialog_wid=createErrDialog("Error:Null dependence graph");
     XtManageChild(errDialog_wid);
     return;
  }
  else
  {
      if(bFilter)
      	pTheDepG->filterOutForallStmt();

      if(pTheDepG->numberOfNodes()==0)
      {
	Widget infoDialog_wid;
        infoDialog_wid=createMessageOKDialog(top_wid,"No data dependence detected");
        XtManageChild(infoDialog_wid);
      }
      else
      {
         FILE *pFile;
         if(NULL==(pFile=fopen(FOR_TMP_FILE,"w")))
            return;
         else
         {
            pTheDepG->outToFile(pFile);
            fclose(pFile);	 
            dlg_wid=create_For_dlg(top_wid,FOR_TMP_FILE);
            ASSERT(dlg_wid);
            XtManageChild(dlg_wid);
         }
      }
  }
}

void pushedforall_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
  Widget dlg_wid;
  SgStatement *pSgStmt,*pTempStmt;
  depGraph *pTheDepG;
  XmTextPosition startP,endP;
  int nStartL,nEndL;
  Arg args[N];
  int n=0;

  if(bSelected)
  {
    /**restore the fomer slected button's foreground text into original color**/
    XtSetArg(args[n],XmNforeground,restoreForeground);n++;
    XtSetValues(buttonSelected,args,n);
  }
  else
  {
    bSelected=1;
  }  
  /**set the current widget's fore ground text into selection color**/
  buttonSelected=w;
  restoreForeground=forallForeground;
  XtVaSetValues(w,XmNforeground,selectForeground,NULL);

  pSgStmt=*((SgStatement **)client_data);
  //pSgStmt->unparsestdout();
  nStartL=pSgStmt->lineNumber();
  pTempStmt=pSgStmt->lastNodeOfStmt();
  nEndL=pTempStmt->lineNumber();
  //printf("(startL,endL)==(%d,%d)\n",nStartL,nEndL );
  //set the selection to the text widget
  getTextPositions(pText,nStartL,nEndL,&startP,&endP);
  XmTextSetSelection(prog_wid,startP,endP,0);

  /***********Now about dependence***************/
  pTheDepG=(depGraph*)(pSgStmt->attributeValue(0,DEPGRAPH_ATTRIBUTE));
  if(pTheDepG==NULL)
  {
     printf("null depgraph\n");
     return;
  }
  else
  {
      if(pTheDepG->numberOfNodes()==0)
      {
        Widget infoDialog_wid;
        infoDialog_wid=createMessageOKDialog(top_wid,"No data dependence detected");
        XtManageChild(infoDialog_wid);
      }
      else
      {
         FILE *pFile;
         if(NULL==(pFile=fopen(FORALL_TMP_FILE,"w")))
              return;
         else{
		pSgStmt->funparse(pFile);
      		pTheDepG->outToFile(pFile);
                fclose(pFile);
      		dlg_wid=create_Forall_dlg(top_wid,FORALL_TMP_FILE);
      		ASSERT(dlg_wid);
      		XtManageChild(dlg_wid);
           }
       }
  }
}

void pushedforallconstruct_fn(Widget w, XtPointer client_data,
               XmPushButtonCallbackStruct *cbs)
{
  Widget dlg_wid;
  SgStatement *pSgStmt,*pTempStmt;
  depGraph *pTheDepG;
  XmTextPosition startP,endP;
  int nStartL,nEndL;
  Arg args[N];
  int n=0;

  if(bSelected)
  {
    /**restore the fomer slected button's foreground text into original color**/
    XtSetArg(args[n],XmNforeground,restoreForeground);n++;
    XtSetValues(buttonSelected,args,n);
  }
  else
  {
    bSelected=1;
  }  
  /**set the current widget's fore ground text into selection color**/
  buttonSelected=w;
  restoreForeground=forallConstructForeground;
  XtVaSetValues(w,XmNforeground,selectForeground,NULL);

  pSgStmt=*((SgStatement **)client_data);
  pSgStmt->unparsestdout();
  nStartL=pSgStmt->lineNumber();
  pTempStmt=pSgStmt->lastNodeOfStmt();
  nEndL=pTempStmt->lineNumber();
  //printf("(startL,endL)==(%d,%d)\n",nStartL,nEndL );
  //set the selection to the text widget
  getTextPositions(pText,nStartL,nEndL,&startP,&endP);
  XmTextSetSelection(prog_wid,startP,endP,0);

  /***********Now about dependence***************/
  pTheDepG=(depGraph*)(pSgStmt->attributeValue(0,DEPGRAPH_ATTRIBUTE));
  if(pTheDepG==NULL)
  {
     printf("null depgraph\n");
     return;
  }
  else
  {
      if(pTheDepG->numberOfNodes()==0)
      {
        Widget infoDialog_wid;
        infoDialog_wid=createMessageOKDialog(top_wid,"No data dependence detected");
        XtManageChild(infoDialog_wid);
      }
      else
      {
         FILE *pFile;
         if(NULL==(pFile=fopen(FORALL_CONSTRUCT_TMP_FILE,"w")))
              return;
         else{
		pSgStmt->funparse(pFile);
      		pTheDepG->outToFile(pFile);
                fclose(pFile);
      		dlg_wid=create_ForallConstruct_dlg(top_wid,FORALL_CONSTRUCT_TMP_FILE);
      		ASSERT(dlg_wid);
      		XtManageChild(dlg_wid);
           }
       }
    }
}

void destroy_fn(Widget w,XtPointer client_data,
		XmAnyCallbackStruct *cbs)
{
     clearUpResources();
     //printf("func destroy called\n");
}


/*++++++++++++++++++++++dependencies  +++++++++++++++++++++++++++++*/


/*++++++++++++++++++++++destruction+++++++++++++++++++++++++++++*/
void clearUpResources(void)
{

    if(pText)   
	XtFree(pText);
/*
    if(pTheProject)
 	delete pTheProject;  

    if(pNewProject)
	delete pNewProject;

    if(pTheFile)
	delete pTheFile;
 
    if(pNewFile)
	delete pNewFile;
*/
    if(ppSgForall) 
	delete ppSgForall;

    if(ppSgForallConstruct) 
	delete ppSgForallConstruct;

    if(ppSgFor)
	delete ppSgFor;


}

void clearUpTreeWid(void)
{
    if(drawArea_wid!=NULL) XtDestroyWidget(drawArea_wid);
    drawArea_wid=XmCreateDrawingArea(tree_wid,"DrawArea",NULL,0);
    XtManageChild(drawArea_wid);
}

/*+++++++++++++++++++++initialization+++++++++++++++++++++++*/
void initResources(void)
{
    pText=NULL;
    pTheProject=NULL;
    pNewProject=NULL;
    pTheFile=NULL;
    pNewFile=NULL;
    ppSgForall=NULL;
    ppSgForallConstruct=NULL;
    ppSgFor=NULL;
    buttonSelected=NULL;

    nForallCount=0;
    nForallConstructCount=0;
    nForCount=0;
    nFor=0;
    nForall=0;
    nForallConstruct=0;
    bSelected=0;
   
}

/*+++++++++++++++++++++Auxilaries+++++++++++++++++++++++*/
/**input the startline and endline number to get the corresponding positions**/
int getTextPositions(char *pText,int nStartL,int nEndL,XmTextPosition *startPosi,XmTextPosition *endPosi)
{
    char *pS,*pE,*pTemp;
    int n=1;

    *startPosi=0;
    *endPosi=0;

    if(nStartL<1) return(-1);	
    if(nStartL>nEndL) nEndL=nStartL;

    if(pText==NULL) return -1;

    pS=pText;
    pTemp=pS;
    while(n!=nStartL)
    {
       pTemp=strchr(pS,'\n');
       ASSERT(pTemp);
       pS=pTemp+1;
       n++;
    }
    *startPosi=pS-pText;

    n=1;
    pE=pText;
    pTemp=pE;
    while(n!=nEndL)
    {
       pTemp=strchr(pE,'\n');
       ASSERT(pTemp);
       pE=pTemp+1;
       n++;
    }
    pE=strchr(pE,'\n');
    *endPosi=pE-pText;

    return 0;
}

/***get the list file name***/
/***e.g.,if the input is test.dep,the output filename should be test.lst***/

char *getListFileName(char *depFileName)
{
   char *pDot,pTemp[256],pWork[256];

   if(depFileName==NULL) return NULL;

   memset(pTemp,0,256);
   memset(pWork,0,256);

   //printf("dep file is %s\n",depFileName);
   strcpy(pWork,depFileName);
   pDot=strstr(pWork,".dep");
   if (pDot==NULL) return NULL;
   else
   {
      *pDot=0; 
      sprintf(pTemp,"%s.lst",pWork);
      //printf("dep file is %s\n",pTemp);
      return pTemp;
   }
}

#if 0

/** transform FORALL_STMT into for stmt;and forall construct into for stmt **/ 
int modifyProgTree(SgFile *pSgFile)
{
   SgForallStmt *pSgForall;
   SgForallConstructStmt *pSgForallConstruct;
   SgStatement *pSgStmt;

   pSgStmt=pSgFile->firstStatement();
   while(pSgStmt)
   {
      if(NULL!=(pSgForall=isSgForallStmt(pSgStmt)))
         ForallToFor(pSgForall);

      if(NULL!=(pSgForallConstruct=isSgForallConstructStmt(pSgStmt)))
         ForallConstructToFor(pSgForallConstruct);
	
      pSgStmt=pSgStmt->lexNext();
   }
   return 0;
}

#endif


/** modify all the forall statements in the ppSgForall[] into for statement **/
int modifyForallList(void)
{
    int i;

    ASSERT(ppSgForall) ;
    for(i=0;i<nForallCount;i++)
    {
       ForallToFor(&(ppSgForall[i]));
    }
}

/** modify all the forall construct statements in the ppSgForallConstruct[] into for statement **/
/* this is proceeding from first transforming the deepest nested forall construct then to the less nested forall construct**/
int modifyForallConstructList(void)
{
    int i,j,n=0,nNestedLevelMax=0;
    SgStatement *pTemp;	
    int *pnLevel;

    ASSERT(ppSgForallConstruct) ;
    pnLevel= new int [nForallConstructCount];
    for(i=0;i<nForallConstructCount;i++)
    {
	pTemp=ppSgForallConstruct[i];
	while(pTemp->controlParent()!=NULL)
	{
		pTemp=pTemp->controlParent();
		n++; 
	}
	pnLevel[i]=n;
	if(n>nNestedLevelMax) nNestedLevelMax=n;
    } 

    for(j=nNestedLevelMax;j>0;j--)
    {
        for(i=0;i<nForallConstructCount;i++)
		if(pnLevel[i]==j)
       			ForallConstructToFor(&(ppSgForallConstruct[i]));
    }
    delete pnLevel;
}
