     module integer_list
        type node
            integer::value
            type(node),pointer::next
        end type node
        type list
            type(node),pointer::first
        end type list
     end module integer_list
    
     program list_insert
        implicit none
        use integer_list
        type(list)::l
        integer::number,ios
        open(unit=10,file='data_1')
        l=init()
        do
            read(10,*,iostat=ios) number
            if(ios<0) exit
            call insert(l,number)
         end do
         call print_list(l)
  
 
     contains  
        function init() result(init_result)
            implicit none
            use integer_list
            type(list)::init_result
            allocate(init_result%first)
            nullify(init_result%first%next)
       end function 

        subroutine insert(l1,number1)
           implicit none
           use integer_list
           type(list),intent(inout)::l1
           integer,intent(in)::number1
           type(node),pointer::trail1,tmp1
           trail1=>l%first
           tmp1=>trail1%next
           do
              if(.not. associated(tmp1))  exit
              if(number1<tmp1%value)       exit
              trail1=>tmp1
              tmp1=>tmp1%next
           end do
           allocate(trail1%next)
           trail1%next%value=number1
           trail1%next%next=>tmp1
        end subroutine 

        subroutine delete(l2,number2,found)
            implicit none
            use integer_list
            type(list),intent(inout)::l2
            integer,intent(in)::number2
            logical,intent(out)::found
            type(node),pointer::trail2,tmp2
            trail2=>l2%first
            tmp2=>trail2%next
            do
               if(.not. associated(tmp2))    then
                     found=.false.
                     exit
               else  if(number2==tmp2%value)    then
                      found=.true.
                      exit
               else 
                      trail2=>tmp2
                      tmp2=>tmp2%next
               end if
            end do
            if(found) then
                trail2%next=>tmp2%next
                deallocate(tmp2)
             end if
          end subroutine 

          subroutine  print_list(l3)
               implicit none
               use integer_list
               type(list),intent(in)::l3
               type(node),pointer::tmp3
               tmp3=>l3%first%next
               do 
                  if(.not. associated(tmp3))   exit
                   print*,tmp3%value
                  tmp3=>tmp3%next
               end do
           end subroutine

        end program 
      
         
