
/**@name Passes in tof77
Module tof77 contains passes that perform: 
\begin{itemize}
\item process variable decalration statements
\item use DATA statement to assign initial value to variable.
\item transform control statement which are in Fortran90 syntax.
\end{itemize}
@memo - passes performed in tof77
*/
//@{
/**  enum to define pass types. This module will perform the transformation
that eliminate Fortran90 syntax to corresponding Fortran77 statements. If we
have no Fortran90 compiler, this pass is necessary.
*/
enum PassType { 
/// process declaration statement that cannot be recognized by Fortran77 compiler.
		DECLARATION_PASS,	\
		FUNCTION_HEDR_PASS,	\
/// transform DO-WHILE statement to do-loop.
		DO_WHILE_PASS,      \
/// transform CASE statement to nested IF statements.
                CASE_STMT_PASS,	\
/// transform RECORD declarations.
		RECORD_PASS,	\
/// transforam forall statement to do-loop , for test to generate sequence file.
		SERIALIZE_PASS
};
//@}

#define  ARG_ADD   10

enum Flag { off, on };

extern char * mixstring;

extern Flag in_main_program ;
extern Flag in_procedure ;
extern Flag in_function;

extern PassType passtype;

extern int silentFlag;

