//
//	DataTable.h
//		define CDataTable, a class can hold a table of number
//		summary and display them in a list Widget, or as bar/pie
//		chart.
//		used in StmtUI.cc to display statement summery and individual
//		statement infomation
//

#ifndef _DATATABLE_H
#define _DATATABLE_H

enum
{
	chart_bar,
	chart_pie,
	chart_radar
};

class CDataTable
{
public:
	vector <int> m_aData;
	vector <int> m_aWidth;
	int m_nColumn;

public:
	CDataTable(int nColumn);

public:
	BOOL SetShape(int nColumn);
	BOOL SetWidth(int nScale, int *aWidth);
	BOOL SetWidth(int nColumn, int nWidth=10);
	BOOL AddRow(int *aData);
	BOOL DeleteRows(int nStart, int nCount=1);
	BOOL RemoveAll();
	BOOL SetData(int nRow, int nCol, int nVal);
	int GetData(int nRow, int nCol)
	{	if (nRow*m_nColumn+nCol>=m_aData.size())
			return 0;
		else return m_aData[nRow*m_nColumn+nCol]; };

	BOOL Sort(int nCol, BOOL bAsc=TRUE);

	BOOL Display(Widget w, BOOL bSummary=TRUE);
	BOOL DisplayMerge(Widget w, int nStart=1, int nStride=2);
	BOOL DisplayChart(Widget drawArea,
		vector <int> &aDispCols, int nAnnoCol, int nType, CRect &rcChart);
	BOOL DrawBarChart(Widget drawArea, char *lpszAxis, int nAnnoCol,
		vector <int> &aDispCols, double dfUp, double dfLow, CRect &rcChart);
	BOOL DrawPieChart(Widget drawArea, char *lpszAxis, 
		int nAnnoCol, int nDataCol, double dfTotal, CRect &rcChart);
	BOOL DrawRadarChart(Widget drawArea, char *lpszAxis, 
		int nAnnoCol, int nDataCol, 
		double dfAvg, double dfMax, CRect &rcChart);

	BOOL DrawCommChart(Widget drawArea, int nRow, CRect &rcChart);

	int RowCount() { return m_aData.size()/m_nColumn; };

	//	helper function to automatically return a color
	int GetColColor(CDC *pDC, int nCol);
};
	
#endif
