//
//	Prof.h
//		Define datas and functions used for performance visualization
//

#ifndef _PROFP_H
#define _PROFP_H

////////////////////////////////////////////////////////////
//	data
extern CProcInfo *apProcInfo[MAX_PROC];
extern int nProcNum;
extern int nMaxProc;

///////////////////////////////////////////////////////////
//	function
extern "C" 
{
	//	in Profile.cc
	int LoadProfInfo(char *lpszProfFile);
	int CloseProfInfo();
	int IsProfInfoLoaded();

	//	in StmtUI.cc
	int PrepareStmtList();
	int ShowStmtList();
	int ProfSelBFND(int nStmtID);

	int PrepareStmtDetail(int nStmtID);
	int ShowStmtDetail(int nStmtID);

	int PrepareGeneralInfo();
	int ShowGeneralInfo();

	int PrepareCommGraph(int nStmtID);
	int ShowCommGraph(int nStmtID);

	//	in EventUI.cc
	int PrepareEventGraph();
	int ShowEventGraph(int bAnnimate);

	//	in DataUI.cc
	int PrepareDataLayout();
	int ShowDataLayout(int nSymbolID);
	int PrepareDataComm();
	int ShowDataComm(int nSymbolID, int nStmtID);
}

/////////////////////////////////////////////////////////////////////////
//	private definition and functions
CProcInfo * GetProc(int nID);
int GetMaxTime();

#endif
