//
//	Prof.cc
//		Implement performance visualization part of Vdumpdep
//

#define _CPP
#define _PROCINFO
#include "headers.h"

#include "ProfP.h"

////////////////////////////////////////////////////////
//	static member
static CProcInfo aProcs[MAX_PROC];


////////////////////////////////////////////////////////
//	public members
CProcInfo *apProcInfo[MAX_PROC];
int nProcNum=0;
int nMaxProc=-1;

///////////////////////////////////////////////////////
//	public functions
int LoadProfInfo(char *lpszProfFile)
{	//	read in profile data, prepare for visualization
	
	CloseProfInfo();

	FILE *fp=fopen(lpszProfFile, "r");
	
	if (fp==NULL)
		return FALSE;

	while (!feof(fp))
	{
		if (aProcs[nProcNum].Read(fp))
		{
			apProcInfo[aProcs[nProcNum].m_nProcID]=&aProcs[nProcNum];
			nMaxProc=max(nMaxProc, aProcs[nProcNum].m_nProcID);
			nProcNum++;
		}
		else break;
	}
	return IsProfInfoLoaded();
}

int CloseProfInfo()
{
	nProcNum=0;
	nMaxProc=-1;
	for (int i=0; i<MAX_PROC; i++)
	{
		apProcInfo[i]=NULL;
	}
	return TRUE;
}

int IsProfInfoLoaded()
{
	return (nProcNum>0);
}

///////////////////////////////////////////////////////////////
//	functions accesiable only to performance visualiztion part
CProcInfo * GetProc(int nID)
{
	assert(nID>=0 && nID<MAX_PROC);
	return apProcInfo[nID];
}

int GetMaxTime()
{
	int nMaxTime=0;

	for (int i=0; i<MAX_PROC; i++)
	{
		if (apProcInfo[i]!=NULL)
			nMaxTime=max(nMaxTime, apProcInfo[i]->m_nElapseSystem);
	}
	return nMaxTime;
}
