/*****************************************************************************
        Visualization tool of AST 

    author:  Zheng Gengbin
                            Peking Univ. P.R.C
*****************************************************************************/

/*------------------------------------------------------*
 *							*
 *	This is a program that can dump BIF graph	*
 *	into human readable from:			*
 *							*
 *	Usage:						*
 *		Vdumpdep <dep_filename>			*
 *							*
 *------------------------------------------------------*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include "Xapp.h"

#include "process.h"

#ifdef NEED_PROFILE
#include "Prof.h"
#endif


int	debug;

PTR_FILE  ptr_file=NULL;


static void
usage()
{
	fprintf(stderr,"Usage: Vdumpdep [-o file] [-p profile] dep_file\n");
	exit(1);
}


main(argc, argv )
    int	  argc;
    char *argv[];
/*    char *envp[]; */
{
        int    ac;
        char   **av;
	Cursor cursor;

#ifdef NEED_PROFILE
	char szProf[80];

	strcpy(szProf, "");
#endif

        ac=argc;
        av=argv;
	argv++; argc--;
/*
	if (!argc)
		usage();
*/
/*	zheng gb code, commented by LY
	if (argc>0 && **argv == '-')
		if ((*argv)[1] == 'd') {
			argv++;
			debug = atoi(*argv++);
			printf("debug = %d\n",debug);
                } 
        init_app(ac,av); 
*/

	while (argc>0 && (*argv)!=NULL && **argv == '-')
	{
		argc--;
		if ((*(argv+1))==NULL || (*argv)[1] == '?') {
			/*	print usage information and return   */
			usage();
			return 0;
		}
/*	-d used by X
		if ((*argv)[1] == 'd') {
			argv++;
			debug = atoi(*argv++);
			argc--;
			printf("debug = %d\n",debug);
        } 
*/
#ifdef NEED_PROFILE
		if ((*argv)[1] == 'p') {
			argv++;
			strcpy(szProf, *argv);
			argv++;
			argc--;
        } 
#endif
	}

    init_app(ac,av); 

		/* create a small font to display the gadget button */
/*	create_small_font(); */
	if (!(*argv) || (*argv)[0]=='\0') {
		curBFND=-1;
                cur_g_line=-2;
		TestMenu(); 
	}
	else begin_session(*argv);

#ifdef NEED_PROFILE
	if (strcmp(szProf, ""))
	{	/*	load profile info 	*/
		LoadProfInfo(szProf);
    	PrepareGeneralInfo();
    	PrepareStmtList();
    	PrepareEventGraph();
    	PrepareDataLayout();
    	PrepareDataComm();
	}
#endif

	XtMainLoop();
}



int begin_session(name)
char *name;
{
	FILE *fd;
	PTR_FILE  f;
	Arg    wargs[5];
	char   title[100],msg[100];

	if((fd=fopen(name, "rb")) == NULL) {
		sprintf(msg,"Cannot open file %s", name);
		ReportError(msg);
		return;
	}
	if ((f = (PTR_FILE) calloc(1, sizeof(struct file_obj))) == NULL) {
		sprintf(msg, "main -- No more space");
		ReportError(msg);
		return(1);
	}
	f->fid = fd;

	if (readNodes(f) >= 0) {
		if (ptr_file)  free_old_ptr_file(ptr_file);
		f->global_bfnd->control_parent = NULL;

         	preprocess(f);
                ptr_file=f;

		if (ReadListFile(name)!=SUCCESS)
			ReportError("Can not open list file!");
		curBFND=-1;
		cur_g_line=-2;

		strcpy(title,"Vdumpdep : ");
		XtSetArg(wargs[0],XmNtitle,strcat(title,name));
		XtSetValues(topLevel,wargs,1);
	        show_tree();
        	global_info();
        	TestMenu();

        	XmTextSetString(scrollText, fileBuf);
	}
	else {
		free(f);
		ReportError("Invalid .dep file !");
	}
	return 0;
}



free_old_ptr_file(lfi)
PTR_FILE lfi;
{
	if (!lfi)  return;
	if (lfi->head_blob) free(lfi->head_blob);
	if (lfi->head_bfnd) free(lfi->head_bfnd);
	if (lfi->head_llnd) free(lfi->head_llnd);
	if (lfi->head_symb) free(lfi->head_symb);
	if (lfi->head_type) free(lfi->head_type);
	if (lfi->head_dep) free(lfi->head_dep);
	if (lfi->head_lab) free(lfi->head_lab);
	if (lfi->head_cmnt) free(lfi->head_cmnt);
	if (lfi->head_file) free(lfi->head_file);
	free(lfi);
}

