/*****************************************************************************
        Visualization tool of AST 

    author:  Zheng Gengbin
                            Peking Univ. P.R.C
*****************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include "Xapp.h"
#include "XSimUtil.h"


#include "process.h"

#ifdef NEED_PROFILE
#include "Prof.h"
#endif

#define  MAXLETTER 17

Widget topLevel,mainWindow,notifyText,scrollWin,drawArea=NULL,scrollText,menuBar;
Widget hScroll, vScroll, workWin, arrow;
Widget notify_sym,notify_llnd,notify_label;
Widget menu_exp,menu_expall,menu_col,menu_llnd,menu_sym,menu_label,menu_cmnt,
		menu_info,menu_bfnd;

char    *tag[1000];                /*610*/
int      nBIF_show,               /* the Number of Button ----BIF node  */
	 nBIF_line;               /* the Number of Line drawn           */
int     *t_cb;            /* array of callback struct           */

int     curBFND=-1;               /* current BFND button  */

unsigned long      interval;


/************************** Menu Function Header ****************************/
void Exit();
void openFile();               void new_session();    /*  Callback */

void global_info();

void button_click();
void TestMenu();
void SetCurBFND();
void SetCurLine();

void incCurBFND();
void decCurBFND();
void incCurBFNDDepth();
void decCurBFNDDepth();
void Expand();
void ChangeExpandMode();
void ExpandSubBFND();
void ExpandAllSubBFND();
void CollapseSubBFND();
void searchBIF();               void search_callback(); 
	 			void CloseDlg();              /*  Callback  */
void searchsym();
void changemode();

void UnmanageDlg();


#ifdef NEED_PROFILE
void LoadProfFile();
void LoadProfFileOK();

void ShowProfInfo();

void PopupStmtList();

void PopupEventGraph();

void PopupDataLayout();
#endif

/************************** Actions *****************************/
static XtActionsRec actionsTab[]=
{
	{"ChangeExpandMode",ChangeExpandMode},
	{"incCurBFND",incCurBFND},
	{"incCurBFNDDepth",incCurBFNDDepth},
	{"decCurBFND",decCurBFND},
	{"decCurBFNDDepth",decCurBFNDDepth},
};
static char translations[]="Shift<Btn3Up>(2+):ChangeExpandMode(\"One\")  \n\
			    <Btn3Up>(2+):ChangeExpandMode(\"All\")  \n\
			    Shift<Key>Down:incCurBFND()  \n\
			    Shift<Key>Right:incCurBFNDDepth()  \n\
			    Shift<Key>Left:decCurBFNDDepth()  \n\
			    Shift<Key>Up :decCurBFND()";

static XtTranslations translationTable;

static XtActionsRec action_hotKey[]=
{
	{"open",openFile},
	{"searchBIF",searchBIF},
	{"searchsym",searchsym},
};
static char hot_trans[]="<Key>F3  : open() \n   \
			 Ctrl<Key>F1 : searchBIF() \n   \
			 Ctrl<Key>F2 : searchsym() ";
static XtTranslations hot_translationTable;

	/* font resource   96 . 4.26 zheng.gb */
typedef struct {
  char *fontpattern;
  int   maxfont ;    /* number max of font to be displayed */
  int   maxlen ;     /* max length of font name to be displayed */
  Boolean   usegadget ;
} ApplicationData, *ApplicationDataPtr;
/*
#define XtNfontPattern "fontPattern"
#define XtCFontPattern "FontPattern"
#define XtNmaxFont     "maxFont"
#define XtCMaxFont     "MaxFont"
#define XtNmaxLen      "maxLen"
#define XtCMaxLen      "MaxLen"
#define XtNuseGadget   "useGadget"
#define XtCUseGadget   "UseGadget"

static XtResource resources[] = {
  { XtNfontPattern, XtCFontPattern, XmRString, sizeof(String),
    XtOffset(ApplicationDataPtr, fontpattern), XmRString, "*" },
  { XtNmaxFont, XtCMaxFont, XmRInt, sizeof(int),
    XtOffset(ApplicationDataPtr, maxfont), XmRImmediate, (caddr_t) 1000 },
  { XtNmaxLen, XtCMaxLen, XmRInt, sizeof(int),
    XtOffset(ApplicationDataPtr, maxlen), XmRImmediate, (caddr_t) 10 },
  { XtNuseGadget, XtCUseGadget, XmRBoolean, sizeof (Boolean),
    XtOffset(ApplicationDataPtr, usegadget), XmRImmediate, (caddr_t) TRUE }
};

ApplicationData AppData;
*/
/************************** Implementation ******************************/
void show_tree()
{
 Arg     wargs[5],wargs_b[10],wargs_l[10];
 int     i,j,n,n0;
 int     num_b,num_l;
 int     x,y,xp,yp;
 XmString  xmstr;
 int     parent;
Widget  *btn,                     /* array of buttons                   */
	*lines;                   /* array of line -Separators          */
 int index;
 char name[40];
 int   max_depth=0;
 
#include "tag.h"                      /*   assign TAG array   */

	if (drawArea!=NULL) XtDestroyWidget(drawArea);
	drawArea=XtCreateManagedWidget("draw",xmDrawingAreaWidgetClass,
		scrollWin,NULL,0);
/*
	n=0;
	XtSetArg(wargs[n], XmNworkWindow, drawArea); n++;
	XtSetValues(scrollWin,wargs,n);
*/
        XtOverrideTranslations(drawArea,translationTable);
        XtOverrideTranslations(drawArea,hot_translationTable);

	n=0;
	XtSetArg(wargs[n],XmNarrowDirection,XmARROW_LEFT);  n++;
	/* change to Widget on Linux LessTif zheng.gb */
#ifdef LESSTIF_VERSION
 	arrow=XmCreateArrowButton(drawArea,"arrow", wargs, n);
#else
 	arrow=XtCreateWidget("arrow",xmArrowButtonGadgetClass,drawArea,
	                     wargs, n);
#endif

 nBIF_show=0; nBIF_line=0;
 for (i=0;i<nBIF;i++) 
      if (b_tree[i].show)  {
	    nBIF_show++;
	    if (b_tree[i].parent!=-1) {
	   nBIF_line++;
	   if (b_tree[i].younger==-1) nBIF_line++;
	    }
      }

 btn=(Widget *)calloc(nBIF_show,sizeof(Widget*));          /*   Alloc buttons */
 lines=(Widget *)calloc(nBIF_line,sizeof(Widget*));        /*   Alloc lines */

 n=0;
 XtSetArg(wargs_b[n],XmNwidth,BT_WIDTH);n++;
 XtSetArg(wargs_b[n],XmNheight,BT_HEIGHT);n++;
 XtSetArg(wargs_b[n],XmNmultiClick,XmMULTICLICK_KEEP);n++;
 /*XtSetArg(wargs_b[n],XmNfontList , fontlist); n++;*/
 n0=n;
 num_l=0;  num_b=0;
 for (i=0;i<nBIF;i++) 
   if (b_tree[i].show) {
                        /*  readjust DrawArea's  width   */
      if (b_tree[i].depth>max_depth) max_depth=b_tree[i].depth;   
      n=n0;
      x=GetXByDepth(b_tree[i].depth);
      y=GetYByHeight(b_tree[i].height);
      XtSetArg(wargs_b[n],XmNx,x); n++;
      XtSetArg(wargs_b[n],XmNy,y); n++;
      strncpy(name, tag[b_tree[i].bfnd->variant], sizeof(name)-4);
      if (b_tree[i].son>=0 && !b_tree[b_tree[i].son].show) 
      {
	if (strlen(name)+3 > MAXLETTER ) name[MAXLETTER-3]='\0';
	strcat(name, " ..");
      }
		/* have to change to Widget on Linux Lesstif */
#ifdef LESSTIF_VERSION
      btn[num_b]=XtCreateWidget(name,
	              xmPushButtonWidgetClass,drawArea, wargs_b,n);
#else
      btn[num_b]=XtCreateWidget(name,
	              xmPushButtonGadgetClass,drawArea, wargs_b,n);
#endif
/*
      XtAddCallback(btn[num_b],XmNactivateCallback,SetCurBFND,(caddr_t)i);
*/
      XtAddCallback(btn[num_b],XmNactivateCallback,button_click,(caddr_t)i);
      num_b++;

      parent=b_tree[i].parent;
      if (parent!=-1) {
	   x=GetXByDepth(b_tree[i].depth);
	   y= GetYByHeight(b_tree[i].height)+BT_HEIGHT/2;
	   xp=GetXByDepth(b_tree[parent].depth)+LINEMARGIN_X;
	   yp=GetYByHeight(b_tree[parent].height)+BT_HEIGHT-1;

	   if (b_tree[i].younger==-1) {                 /* the longest line */
	     j=0;
	     XtSetArg(wargs_l[j],XmNx,xp);j++;
	     XtSetArg(wargs_l[j],XmNy,yp);j++;
	     XtSetArg(wargs_l[j],XmNheight,y-yp+1);j++;
	     XtSetArg(wargs_l[j],XmNorientation,XmVERTICAL);j++;
#ifdef LESSTIF_VERSION
	     lines[num_l]=(Widget)XmCreateSeparator(drawArea,"", wargs_l,j);
#else
	     lines[num_l]=XtCreateWidget(" ",xmSeparatorGadgetClass,drawArea,
	                         wargs_l,j);
#endif
	     num_l++;
	   }

	   j=0;
	   XtSetArg(wargs_l[j],XmNx,xp);j++;
	   XtSetArg(wargs_l[j],XmNy,y);j++;
	   XtSetArg(wargs_l[j],XmNwidth,x-xp+1);j++;
	   XtSetArg(wargs_l[j],XmNorientation,XmHORIZONTAL);j++;
#ifdef LESSTIF_VERSION
	   lines[num_l]=(Widget)XmCreateSeparator(drawArea,"", wargs_l,j);
#else
	   lines[num_l]=XtCreateWidget(" ",xmSeparatorGadgetClass,drawArea,
	                         wargs_l,j);
#endif
	   num_l++;
      }
   }

 XtManageChildren(lines,nBIF_line);                   
 XtManageChildren(btn,nBIF_show);                   

 index=curBFND;
 curBFND=-1;
 SetCurBFND(NULL, index, NULL);

 free(btn);
 free(lines);
} 

static MenuButtonsStruct fileButtons[]=
{      {"Open...    F3 ", 'O', openFile,NULL, NULL, 0, NULL, NULL},
       {"Exit          ", 'E', Exit, NULL, NULL, 0, NULL, NULL}
};

static MenuButtonsStruct chartButtons[]=
{       
	{"BFND Detail   ",'D',show_BFND_dlg1, (caddr_t)&curBFND, 
			NULL,0,NULL,&menu_bfnd},
	{"Symbol          ",'S',show_SYM_dlg1,(caddr_t)&curBFND,
			NULL,0,NULL,&menu_sym},
	{"Low Level Tree  ",'L',show_multi_LLND_dlg1,(caddr_t)&curBFND,
			NULL,0,NULL,&menu_llnd},
	{"Label           ",'a',show_LABEL_dlg2,(caddr_t)&curBFND,
			NULL,0,NULL,&menu_label},
	{"Comment         ",'C',show_CMNT_dlg1,(caddr_t)&curBFND,
			NULL,0,NULL,&menu_cmnt},
};

static MenuButtonsStruct viewButtons[]=
{       
	{"Global Info   ",'G',global_info, NULL, NULL, 0, NULL, &menu_info},
	{"Expand        ",'E', ExpandSubBFND, NULL, NULL, 0, NULL,&menu_exp},
	{"Expand all    ",'a', ExpandAllSubBFND,NULL,NULL,0,NULL,&menu_expall},
	{"Collapse      ",'C', CollapseSubBFND, NULL, NULL, 0, NULL,&menu_col},
};

#ifdef NEED_PROFILE
static MenuButtonsStruct performanceButtons[]=
{
        {"Load Performance Log... ",'L', LoadProfFile, NULL, NULL, 0, NULL,NULL},
        {NULL, '0', NULL, NULL, NULL, 0, NULL,NULL},
        {"General Info",'I', ShowProfInfo, NULL, NULL, 0, NULL,NULL},
        {"Statement List",'S', PopupStmtList, NULL, NULL, 0, NULL,NULL},
        {"Event Graph",'E', PopupEventGraph, NULL, NULL, 0, NULL,NULL},
        {"Data Layout",'D', PopupDataLayout, NULL, NULL, 0, NULL,NULL},
};
#endif

static MenuButtonsStruct searchButtons[]=
{       
	{"Search BIF      Ctrl-F1",'B', searchBIF, NULL, NULL, 0, NULL,NULL},
	{"Search symbol  Ctrl-F2",'s', searchsym, NULL, NULL, 0, NULL,NULL},
};

static MenuButtonsStruct helpButtons[]=
{       
	{"Introduction",'I', help_callback, NULL, NULL, 0, NULL,NULL},
};

static MenuButtonsStruct menuBarButtons[]=
{       {"File", 'F', NULL , NULL, fileButtons,
	XtNumber(fileButtons), NULL, NULL},
	{"View", 'V', NULL,  NULL, viewButtons,
	XtNumber(viewButtons), NULL, NULL},
	{"Search", 'S', NULL,  NULL, searchButtons,
	XtNumber(searchButtons), NULL, NULL},
	{"Chart", 'C', NULL,  NULL, chartButtons,
	XtNumber(chartButtons), NULL, NULL},
#ifdef NEED_PROFILE
	{"Profile", 'P', NULL,  NULL, performanceButtons,
	XtNumber(performanceButtons), NULL, NULL},
#endif
	{"Help", 'H', NULL , NULL, helpButtons , XtNumber(helpButtons), 
			NULL, NULL}
};

static MenuButtonsStruct modeButtons[]=
{       {"by ID     ", 'I', changemode,(caddr_t)1,NULL, 0, NULL, NULL},
        {"by Global ", 'G', changemode,(caddr_t)2,NULL, 0, NULL, NULL},
};

static MenuButtonsStruct searchmodeButtons[]=
{       {"Search Modes:", 'S', NULL , NULL, modeButtons,
	XtNumber(modeButtons), NULL, NULL},
};

int init_app(ac,av)
int ac;
char **av;
{
 int    n=0;
 int    i;
 Arg    args[MAXARGS];
 Widget form, notifyForm;
 XtAppContext    app_context;                    /* 96.4.26 zheng.gb */
 int MARGIN=3, BUTTON_WID=90, EDIT_WID=300, x;

	topLevel=XtInitialize(av[0],"Vdumpdep",NULL,0,&ac,av);

/*
	topLevel=XtAppInitialize(&app_context, "Vdumpdep", NULL, 0,
                            &ac, av, NULL, NULL, 0);
	XtGetApplicationResources(topLevel,
                              (XtPointer)&AppData,
                              resources,
                              XtNumber(resources),
                              NULL,
                              0);
*/

	XtAddActions(actionsTab, XtNumber(actionsTab));
	translationTable=XtParseTranslationTable(translations); 
	XtAddActions(action_hotKey, XtNumber(action_hotKey));
	hot_translationTable=XtParseTranslationTable(hot_trans); 

	n=0;
	XtSetArg(args[n],XmNwidth,900); n++; 
	XtSetArg(args[n],XmNheight,550); n++; 
	mainWindow=XmCreateMainWindow(topLevel,"DeskMainWin",args, n);
	XtManageChild(mainWindow);

	XtSetArg(args[0],XmNaccelerators,hot_translationTable);
	menuBar=XmCreateMenuBar(mainWindow, "menuBar", args, 1);
	XuCreateMenuButtons( NULL, menuBar, menuBarButtons,
		XtNumber(menuBarButtons) );
	XtManageChild(menuBar);

	n=0;
	XtSetArg(args[n],XmNwidth,900); n++; 
	XtSetArg(args[n],XmNheight,550); n++; 
	form=XmCreateForm(mainWindow,"form",args,n);
	XtManageChild(form);

	n=0;
	XtSetArg(args[n], XmNheight,45); n++; 
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);  n++;
	XtSetArg(args[n], XmNrightOffset, MARGIN);  n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n++;
	XtSetArg(args[n], XmNleftOffset, MARGIN);  n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);  n++;
	XtSetArg(args[n], XmNbottomOffset, MARGIN);  n++;
	notifyForm=XmCreateForm(form,"notifyForm",args, n);
	XtManageChild(notifyForm);

	n=0;
	XtSetArg(args[n], XmNwidth,300); n++; 
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);     n++;
	XtSetArg(args[n], XmNtopOffset, MARGIN);     n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET);  n++;
	XtSetArg(args[n], XmNbottomWidget, notifyForm);  n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);   n++;
	XtSetArg(args[n], XmNleftOffset, 1); n++;
	XtSetArg(args[n],XmNscrollingPolicy,XmAUTOMATIC); n++;
	scrollWin=XtCreateManagedWidget("scrollWin",
		xmScrolledWindowWidgetClass, form, args,n);

	n=0;
	XtSetArg(args[n], XmNhorizontalScrollBar, &hScroll); n++;
	XtSetArg(args[n], XmNverticalScrollBar, &vScroll); n++;
	XtGetValues(scrollWin, args, n);

	drawArea=XtCreateManagedWidget("draw",xmDrawingAreaWidgetClass,
		scrollWin,NULL,0);
/*
	n=0;
	XtSetArg(args[n], XmNworkWindow, drawArea); n++;
	XtSetValues(scrollWin,args,n);
*/

	n=0;
	XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
	XtSetArg(args[n], XmNeditable, FALSE); n++;
	scrollText=XmCreateScrolledText(form, "scrollText", args, n);
	XtAddCallback(scrollText,XmNmotionVerifyCallback,SetCurLine,NULL);
	n=0;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);     n++;
	XtSetArg(args[n], XmNtopOffset, MARGIN);     n++;
/*
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET);  n++;
	XtSetArg(args[n], XmNbottomWidget, notifyForm);  n++;
*/
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_OPPOSITE_WIDGET);  n++;
	XtSetArg(args[n], XmNbottomWidget, scrollWin);  n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);	n++;
	XtSetArg(args[n], XmNleftWidget, scrollWin);	n++;
	XtSetArg(args[n], XmNleftOffset, MARGIN);	n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);   n++;
	XtSetArg(args[n], XmNrightOffset, MARGIN); n++;
	XtSetValues(XtParent(scrollText),args,n);
	XtManageChild(scrollText);

	n=0;
	XtSetArg(args[n], XmNwidth, BUTTON_WID);	n++;
	XtSetArg(args[n], XmNheight, 20);	n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);     n++;
	XtSetArg(args[n], XmNtopOffset, MARGIN);     n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);  n++;
	XtSetArg(args[n], XmNbottomOffset, MARGIN);  n++;

	x=MARGIN;
	n=6;
	XtSetArg(args[n], XmNx, x);		n++;
	notify_sym=XtCreateManagedWidget("SYMBOL",
	    xmPushButtonGadgetClass,notifyForm, args, n);
	XtAddCallback(notify_sym,XmNactivateCallback,show_SYM_dlg1,&curBFND);

	x+=BUTTON_WID;
	n=6;
	XtSetArg(args[n], XmNx, x);		n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);	n++;
	XtSetArg(args[n], XmNleftWidget, notify_sym);	n++;
	notify_llnd=XtCreateManagedWidget(" LLND ",
	    xmPushButtonGadgetClass,notifyForm, args, n);
	XtAddCallback(notify_llnd,XmNactivateCallback,show_multi_LLND_dlg1,&curBFND);

	x+=BUTTON_WID;
	n=6;
	XtSetArg(args[n], XmNx, x);		n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);	n++;
	XtSetArg(args[n], XmNleftWidget, notify_llnd);	n++;
	notify_label=XtCreateManagedWidget(" LABEL ",
	    xmPushButtonGadgetClass,notifyForm, args, n);
	XtAddCallback(notify_label,XmNactivateCallback,show_LABEL_dlg2,&curBFND);

	XtSetSensitive(notify_sym,FALSE);
	XtSetSensitive(notify_llnd,FALSE);
	XtSetSensitive(notify_label,FALSE);

	x+=BUTTON_WID;
	n=0;
/*
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);    n++;
	XtSetArg(args[n], XmNleftOffset, x+2*MARGIN);    n++;
*/
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);    n++;
	XtSetArg(args[n], XmNleftWidget, notify_label);    n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);     n++;
	XtSetArg(args[n], XmNtopOffset, MARGIN);     n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);  n++;
	XtSetArg(args[n], XmNbottomOffset, MARGIN);  n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);   n++;
	XtSetArg(args[n], XmNrightOffset, 2*MARGIN); n++;
	XtSetArg(args[n], XmNeditable, False);  n++;
	notifyText=XtCreateManagedWidget("notifyText",xmTextWidgetClass,
		notifyForm, args, n);

	XmMainWindowSetAreas(mainWindow,menuBar,NULL,NULL, NULL, 
	form);

	XtRealizeWidget(topLevel);
	interval=XtGetMultiClickTime(XtDisplay(topLevel));

	{
	Cursor  cursor;
	cursor=XCreateFontCursor(XtDisplay(scrollText),XC_fleur);
	XDefineCursor(XtDisplay(scrollText),XtWindow(scrollText), cursor);
	cursor=XCreateFontCursor(XtDisplay(scrollWin),XC_gumby);
	XDefineCursor(XtDisplay(scrollWin),XtWindow(scrollWin), cursor);
	}

        XtOverrideTranslations(notifyForm,hot_translationTable);
        XtOverrideTranslations(notifyText,hot_translationTable);
/*
        XtOverrideTranslations(menuBar,hot_translationTable);
*/


}

/************************** Menu functions ***************************/
void Exit()
{
	free_small_font();
	exit(0);
}


void openFile()
{
	Widget    dlg;
	Arg    wargs[9];
	int    n=0;
	XmString dirMask;

	dirMask=XmStringCreate("*.dep",XmSTRING_DEFAULT_CHARSET);
	XtSetArg(wargs[n],XmNdirMask,dirMask); n++;
	XtSetArg(wargs[n],XmNautoUnmanage,TRUE); n++;
	XtSetArg(wargs[n],XmNselectionPolicy,XmSINGLE_SELECT);  n++;
	XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
	dlg=XmCreateFileSelectionDialog(topLevel,"File",wargs,n);
	XtAddCallback(dlg,XmNokCallback,new_session,NULL);
	XtAddCallback(dlg,XmNcancelCallback,UnmanageDlg,dlg);
	XtManageChild(dlg);
}


void global_info()
{ 
 char    ed_str[100];
 int     n1, n2, n3, n4, n5, n6, n7, n8, n9, n10;

 n1 = ptr_file->num_blobs;
 n2 = ptr_file->num_bfnds;
 n3 = ptr_file->num_llnds;
 n4 = ptr_file->num_symbs;
 n5 = ptr_file->num_types;
 n6 = ptr_file->num_label;
 n7 = ptr_file->global_bfnd->id;
 n8 = ptr_file->num_dep;
 n9 = ptr_file->num_cmnt;
 n10= ptr_file->num_files;

	 sprintf(ed_str,"#bfnd:%-4d #llnd:%-4d #symb:%-4d #type:%-4d #labl:%-4d #cmnt:%-4d", n2,n3,n4,n5,n6,n9);
	 XmTextSetString(notifyText,ed_str);
}

/************************** BFND callbacks **************************/
int cur_g_line=-2;
int last_start = -1;

void TestMenu()
{
	BOOL state1=TRUE,
	     state2=TRUE,
	     state3=TRUE,
	     state_bfnd=TRUE,
	     state_llnd=TRUE,
	     state_sym=TRUE,
	     state_label=TRUE,
	     state_cmnt=TRUE,
	     state_info=TRUE;
	int  i,start,end;
	Cursor   cursor;

	if (ptr_file==NULL)  state_info=FALSE;
	if (curBFND<0) {
		state1=FALSE;
                state2=FALSE;
                state3=FALSE;
		state_bfnd=FALSE;
		state_llnd=FALSE;
		state_sym=FALSE;
		state_label=FALSE;
		state_cmnt=FALSE;
	}
	else {
		if (b_tree[curBFND].bfnd->entry.Template.symbol==NULL) 
			state_sym=FALSE;
		if (!b_tree[curBFND].bfnd->entry.Template.ll_ptr1 &&
             	    !b_tree[curBFND].bfnd->entry.Template.ll_ptr2 &&
             	    !b_tree[curBFND].bfnd->entry.Template.ll_ptr3   ) 
			state_llnd=FALSE;
		if (b_tree[curBFND].bfnd->label==NULL) 
			state_label=FALSE;
		if (b_tree[curBFND].bfnd->entry.Template.cmnt_ptr==NULL) 
			state_cmnt=FALSE;
                if (b_tree[curBFND].son==-1) {
		    state1=FALSE;
		    state2=FALSE;
		    state3=FALSE;
	        }
	        else {
	          if (!b_tree[b_tree[curBFND].son].show) state3=FALSE;
	          if (b_tree[b_tree[curBFND].son].show==TRUE) state1=FALSE;
	          if ( (end=b_tree[curBFND].lastson)>=0) {
     	  	         start=b_tree[curBFND].son;
	                 for (i=start;i<=end;i++)
       		         {
		             if (b_tree[i].show==FALSE) break;
       		         }
		         if (i>end) state2=FALSE;
	        }
	     }
	}
	XtSetSensitive(menu_exp,state1);
	XtSetSensitive(menu_expall,state2);
	XtSetSensitive(menu_col,state3);
	XtSetSensitive(menu_bfnd,state_bfnd);
	XtSetSensitive(menu_llnd,state_llnd);
	XtSetSensitive(menu_sym,state_sym);
	XtSetSensitive(menu_label,state_label);
	XtSetSensitive(menu_cmnt,state_cmnt);
	XtSetSensitive(menu_info,state_info);
}

void button_click(w,ind,cbs)
Widget  w;
caddr_t ind;
XmPushButtonCallbackStruct *cbs;
{
	static XtIntervalId  id;
	int		tmp;

	if (cbs->click_count==1)  {
		id = XtAddTimeOut(interval/2,NULL,NULL);
		SetCurBFND(w,ind,NULL);
	}
	else if (cbs->click_count==2) {
		XtRemoveTimeOut(id);
		tmp=0;
		ChangeExpandMode(w, NULL, NULL, &tmp);
	}
}

void SetCurBFND(w,ind,call_data)
Widget  w;
caddr_t	ind;
XmAnyCallbackStruct     *call_data;
{
	int index=(int)ind;
	Arg args[2];
	char str[100];

	if (curBFND==index) return;
	if (index<0) 
	{
		XtUnmanageChild(arrow);
		XmTextSetString(notifyText,"");
		XtSetSensitive(notify_sym,FALSE);
		XtSetSensitive(notify_llnd,FALSE);
		XtSetSensitive(notify_label,FALSE);
		XtSetSensitive(menu_bfnd,FALSE);
		cur_g_line=-1;
		curBFND=-1;
		TestMenu();
		return;
	}
	if (curBFND<0 && index>=0) XtManageChild(arrow); 
	if (b_tree[index].bfnd->entry.Template.symbol) {
		XtSetSensitive(notify_sym,TRUE);
	}
	else XtSetSensitive(notify_sym,FALSE);
	if (b_tree[index].bfnd->entry.Template.ll_ptr1 || 
	    b_tree[index].bfnd->entry.Template.ll_ptr2 ||
	    b_tree[index].bfnd->entry.Template.ll_ptr3   ) {
		XtSetSensitive(notify_llnd,TRUE);
	}
	else XtSetSensitive(notify_llnd,FALSE);
	if (b_tree[index].bfnd->label) {
		XtSetSensitive(notify_label,TRUE);
	}
	else XtSetSensitive(notify_label,FALSE);
	XtSetSensitive(menu_bfnd,TRUE);
	curBFND=index;

	sprintf(str,"ID:%-4d Global line:%-4d Local line:%-4d",b_tree[index].bfnd->id,	
	    b_tree[index].bfnd->g_line,b_tree[index].bfnd->l_line);
	XmTextSetString(notifyText,str);
    
	{
	XtUnmanageChild(arrow); 
	XtSetArg(args[0], XmNx,
		GetXByDepth(b_tree[index].depth)+BT_WIDTH+MARGIN_X); 
	XtSetArg(args[1], XmNy, 
		GetYByHeight(b_tree[index].height)+MARGIN_Y); 
	XtSetValues(arrow, args, 2);
	XtManageChild(arrow); 
	}

	{	/* pane draw area to show the selected BFND */
		Arg args[2];
		int x,y,n;
		int wid, ht;
		int newX, newY;
		int hInc, hPageInc, vInc, vPageInc;
		int max,min;
		
		XmScrollBarGetValues(hScroll, &x, &wid, &hInc, &hPageInc);
		XmScrollBarGetValues(vScroll, &y, &ht, &vInc, &vPageInc);

		if (x>GetXByDepth(b_tree[index].depth))
			newX=GetXByDepth(b_tree[index].depth);
		else if (x+wid<GetXByDepth(b_tree[index].depth)+BT_WIDTH+50)
			{              /*  Add by Zheng.gb   */
			XtSetArg(args[0],XmNmaximum,&max);
			XtGetValues(hScroll,args,1);
			newX=GetXByDepth(b_tree[index].depth)+BT_WIDTH+50-wid;
			newX=newX>max-wid ? max-wid : newX;
			}
		else newX=-1;
		if (newX > max-wid) newX=-1;

		if (newX>=0)
		{
			XmScrollBarSetValues(hScroll, newX, wid, hInc, hPageInc, TRUE);
		}

		if (y>GetYByHeight(b_tree[index].height))
		        newY=GetYByHeight(b_tree[index].height);
		else if (y+ht<GetYByHeight(b_tree[index].height)+BT_HEIGHT+10)
			{              /*  Add by Zheng.gb   */
			XtSetArg(args[0],XmNminimum,&min);
			XtSetArg(args[1],XmNmaximum,&max);
                        XtGetValues(vScroll,args,2);
		        newY=GetYByHeight(b_tree[index].height)+BT_HEIGHT+10-ht;
			newY=newY<min ? min : newY;
			}
		else newY=-1;
		if (newY > max-ht) newY=-1;

		if (newY>=0)
		{
			XmScrollBarSetValues(vScroll, newY, ht, vInc, vPageInc, TRUE);
		}
	}

	{ /* Highlight line for cur BFND */
		XmTextPosition start, end;
		char *text;

		/*text = XmTextGetString(scrollText); */
		if (last_start > -1)
		{
			XmTextReplace(scrollText,last_start,last_start+1," ");
/*
			text[last_start] = ' ';
			XmTextSetString(scrollText,text);
*/
		}
		cur_g_line=b_tree[index].bfnd->g_line;
		if (GetLinePosition(b_tree[index].bfnd->g_line, &start, &end)==SUCCESS)
		{
			if (start != 0) {
				XmTextReplace(scrollText,start,start+1,">");
/*
				text[start] = '>';
				XmTextSetString(scrollText,text);
*/
				last_start = start;
			}
			XtSetArg(args[0], XmNcursorPosition, start);
			XtSetValues(scrollText, args, 1);
/*			XmTextSetHighlight(scrollText, start, end, XmHIGHLIGHT_SELECTED); */
			XmTextSetSelection(scrollText, start, end, 0);
		}
	}

#ifdef NEED_PROFILE
	/*	Profiler code	*/
	ProfSelBFND(b_tree[index].bfnd->id);
#endif

	TestMenu();                     /*  Make menu Valid or not  */
}
	
void SetCurLine(w, data, textRec)
Widget w;
caddr_t data;
XmTextVerifyPtr textRec;
{
	int ln, index;

	if (GetPositionLine(textRec->newInsert, &ln)==SUCCESS )
	{
		if ( ln!=cur_g_line ) 
		{
			if ((index=GetLineBFND(ln))!=FAILURE )
			{
				if (cur_g_line>-2) 
				{
					if (b_tree[index].show)
						SetCurBFND(w, index, textRec); 
					else
					{
#define NOTSHOWN_MSG "BFND invisible, use Expand command to show it."
						SetCurBFND(w, -1, textRec);
						XmTextSetString(notifyText, NOTSHOWN_MSG);
					}
				}
					
						/* prevent set line in the first motion event */
				else cur_g_line=-1;
			}
			else
			{
				cur_g_line=-1;
				SetCurBFND(w, (caddr_t)-1, textRec);
			}
		}
	}
}

/********************* find BFND by line ***************************/
int GetIdBFND(id)
int id;
{
	int ind;

	for (ind=0; ind<nBIF && b_tree[ind].bfnd->id<id; ind++);
	if (ind>=nBIF) return FAILURE;
	if (b_tree[ind].bfnd->id==id) return ind;
	else return FAILURE;
}

int GetLineBFND(line)
int line;
{
	int ind;

	for (ind=0; ind<nBIF && b_tree[ind].bfnd->g_line<line; ind++);
	if (ind>=nBIF) return FAILURE;
	if (b_tree[ind].bfnd->g_line==line) return ind;
	else return FAILURE;
}

int GetIdLine(id)
int id;
{
	int ind;

	for (ind=0; ind<nBIF && b_tree[ind].bfnd->id<id; ind++);
	if (ind>=nBIF) return FAILURE;
	if (b_tree[ind].bfnd->id==id) return b_tree[ind].bfnd->g_line;
	else return FAILURE;
}

/**************************** Expand Tree *************************/
void incCurBFND(w, event, params, nParams)
Widget w;
XEvent *event;
String *params;
Cardinal *nParams;
{
	int n=curBFND+1;
	while (n<=nBIF-1 && !b_tree[n].show) {
		n++;
	}
	if (n!=nBIF) SetCurBFND(NULL,n,NULL);
}

void decCurBFND(w, event, params, nParams)
Widget w;
XEvent *event;
String *params;
Cardinal *nParams;
{
	int n=curBFND-1;
	while (n>=0 && !b_tree[n].show) {
		n--;
	}
	if (n!=-1) SetCurBFND(NULL,n,NULL);
}

void incCurBFNDDepth(w, event, params, nParams)
Widget w;
XEvent *event;
String *params;
Cardinal *nParams;
{
	if (curBFND>=0)
	{
		if (b_tree[curBFND].son>=0)
			SetCurBFND(NULL,b_tree[curBFND].son,NULL);
	}
	else SetCurBFND(NULL,0,NULL);
}

void decCurBFNDDepth(w, event, params, nParams)
Widget w;
XEvent *event;
String *params;
Cardinal *nParams;
{
	if (curBFND>=0 && b_tree[curBFND].parent != -1)
		SetCurBFND(NULL,b_tree[curBFND].parent,NULL);
}

void ChangeExpandMode(w, event, params, nParams)
Widget w;
XEvent *event;
String *params;
Cardinal *nParams;
{
	if (curBFND<0) return;
	if (b_tree[curBFND].son>=0 && b_tree[b_tree[curBFND].son].show)
		CollapseSubBFND(w);
	else if (*nParams>0 && params[0][0]=='O') ExpandSubBFND();
	else ExpandAllSubBFND(w);
}

void ExpandSubBFND(w)
Widget w;
{
	int ind;

	if (curBFND<0) return;

	ind=b_tree[curBFND].son;
	if (ind<0 || b_tree[ind].show) return;

	if (nBIF_show+b_tree[curBFND].nson>MAXHEIGHT) 
	{
		ReportError("Exceed maxium BFND!");
		return;
	}
	for (; ind>=0; ind=b_tree[ind].younger)
	{
		b_tree[ind].show=TRUE;
	}
	set_height();
	show_tree();
}

void ExpandAllSubBFND(w)
Widget w;
{
	int index, ind;

	if (curBFND<0) return;

	ind=b_tree[curBFND].son;
	if (ind<0) return;

	index=GetNextNoDescendent(curBFND);
	if (nBIF_show+index-curBFND>MAXHEIGHT)
	{
		ReportError("Exceed maxium BFND!");
		return;
	}
	for (; ind>=0 && ind<index; ind++)
	{
		b_tree[ind].show=TRUE;
	}
	set_height();
	show_tree();
}

void CollapseSubBFND(w)
Widget w;
{
	int index, ind;

	if (curBFND<0) return;

	ind=b_tree[curBFND].son;
	if (ind<0 || !b_tree[ind].show) return;

	index=GetNextNoDescendent(curBFND);
	for (; ind<index; ind++)
	{
		b_tree[ind].show=FALSE;
	}
	set_height();
	show_tree();
}


int GetNextNoDescendent(index)
int index;
{
	int ind=-2;

	while (index>=0)
	{
		ind=index;
		index=b_tree[index].lastson;
	}
	return ind+1;
}

/***   Search menu  ****/

static int  sel_mode=0;

void searchBIF(menu)
Widget menu;
{
	static Widget  dlg=NULL;
	Widget option_menu;
	Arg    wargs[9];
	int    n=0;
	XmString xmstr,strID,strGLOBAL;
	void option_cb();
	void clear_text();

	if (dlg==NULL) {
	xmstr=XmStringCreateSimple("   Select by ID :");
	n=0;
        XtSetArg(wargs[n],XmNautoUnmanage,FALSE); n++;
	XtSetArg(wargs[n],XmNselectionLabelString,xmstr); n++;
        XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_MODELESS);n++;
        dlg=XmCreatePromptDialog(topLevel,
                           "Search BFND",wargs,n);
	XmStringFree(xmstr);
	XtUnmanageChild(XmSelectionBoxGetChild(dlg,XmDIALOG_HELP_BUTTON));
	XtAddCallback(dlg,XmNcancelCallback,UnmanageDlg,dlg);
	XtAddCallback(dlg,XmNokCallback,search_callback,dlg);
	XtAddCallback(dlg,XmNapplyCallback,clear_text,dlg);
	
	XtManageChild(XmSelectionBoxGetChild(dlg,XmDIALOG_APPLY_BUTTON));
	xmstr=XmStringCreateSimple("Clear");
	XtSetArg(wargs[0],XmNapplyLabelString,xmstr);
	XtSetValues(dlg,wargs,1);
	XmStringFree(xmstr);

	xmstr=XmStringCreateSimple("    Search Mode :     ");
	strID=XmStringCreateSimple(    "    by ID       ");
	strGLOBAL=XmStringCreateSimple("    by Line     ");
	option_menu=XmVaCreateSimpleOptionMenu(dlg,"Mode",
		xmstr,'S',0,option_cb,
		XmVaPUSHBUTTON,strID,'I',NULL,NULL,
		XmVaPUSHBUTTON,strGLOBAL,'L',NULL,NULL,
		NULL);
	XmStringFree(strID);
	XmStringFree(strGLOBAL);
	XmStringFree(xmstr);
	XtManageChild(option_menu);
	}

	XUnmapWindow(XtDisplay(dlg),XtWindow(XtParent(dlg)) );
	XtManageChild(dlg);
	XMapWindow(XtDisplay(dlg),XtWindow(XtParent(dlg)) );
}

void option_cb(menu_item,item_no,cbs)
Widget menu_item;
int   item_no;
XmAnyCallbackStruct *cbs;
{
	Arg   wargs[2];
	XmString  xmstr;
	Widget    w;

	sel_mode=item_no;
	switch (sel_mode) {
	case 0 :  xmstr=XmStringCreateSimple("   Select by ID :");
			break;
	case 1 :  xmstr=XmStringCreateSimple("   Select by Line :");
			break;
	}
	w=menu_item;
	while (w) {
	 if (XtIsSubclass(w,xmBulletinBoardWidgetClass)) break;
	 w=XtParent(w);
	}
	XtSetArg(wargs[0],XmNselectionLabelString,xmstr); 
	if (w) XtSetValues(w,wargs,1);
}

void changemode()
{
}

void UnmanageDlg(w,d,call_data)
Widget w;
Widget d;
XmSelectionBoxCallbackStruct *call_data;
{
	XtUnmanageChild(d);
}

void clear_text(w,d,call_data)
Widget w;
Widget d;
XmSelectionBoxCallbackStruct *call_data;
{
	Arg   wargs[5];

	XtSetArg(wargs[0],XmNtextString,NULL);
	XtSetValues(d,wargs,1);
}
	
void search_callback(w,d,call_data)
Widget w;
Widget d;
XmSelectionBoxCallbackStruct *call_data;
{
	char *str,msg[100];
	int  id,i,n;
	XmString  xmstr;

/*
	str=XmTextGetString(tw);	
*/

	XmStringGetLtoR(call_data->value,XmSTRING_DEFAULT_CHARSET,&str);
	if (str[0]=='\0') return;
	id=atoi(str);
	XtFree(str);
	if (sel_mode==0) {
	    if (id==0) return;
	    if (id < 1 || id >nBIF ){
	    	ReportError("No such BFND !");
	    	return;
	    }
	    if (b_tree[id-1].show) SetCurBFND(NULL,id-1,NULL);
	    else {
	        n=id-1;
		while (!b_tree[n].show)  n=b_tree[n].parent;
		sprintf(msg,"BFND invisible ! \n    Expand node ID: %d.",n+1);
		ReportError(msg);
	    }
	    return;
	}
	if (sel_mode==1) {
	    if (id==0) return;
	    for (i=1;i<=nBIF-1;i++) {
		if (b_tree[i].bfnd->g_line==id) break;
	    }
	    if (i==nBIF) {
		ReportError("No such BFND !");
                return;
            }
	    if (b_tree[i].show) SetCurBFND(NULL,i,NULL);
	    else {
		n=i;
		while (!b_tree[n].show)  n=b_tree[n].parent;
		sprintf(msg,"BFND invisible ! \n    Expand node ID: %d.",n+1);
		ReportError(msg);
	    }
            return;
        }
}	
	

void searchsym(menu)
Widget menu;
{
	static Widget dlg=NULL;
	Arg    wargs[9];
	int    n=0;
	XmString xmstr,strID,strGLOBAL;
	void search2_callback();
	void UnmanageDlg();

	if (dlg==NULL) {
	xmstr=XmStringCreateSimple(" Search symbol name :");
        XtSetArg(wargs[n],XmNautoUnmanage,FALSE); n++;
	XtSetArg(wargs[n],XmNselectionLabelString,xmstr); n++;
        XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_MODELESS);n++;
        dlg=XmCreatePromptDialog(topLevel,
                           "Search Symbol",wargs,n);
	XmStringFree(xmstr);
	XtAddCallback(dlg,XmNcancelCallback,UnmanageDlg,dlg);
	XtAddCallback(dlg,XmNokCallback,search2_callback,dlg);
	XtAddCallback(dlg,XmNapplyCallback,(XtCallbackProc)clear_text,dlg);
	XtUnmanageChild(XmSelectionBoxGetChild(dlg,XmDIALOG_HELP_BUTTON));
	XtManageChild(XmSelectionBoxGetChild(dlg,XmDIALOG_APPLY_BUTTON));
	xmstr=XmStringCreateSimple("Clear");
	XtSetArg(wargs[0],XmNapplyLabelString,xmstr);
	XtSetValues(dlg,wargs,1);
	XmStringFree(xmstr);
	}

	XUnmapWindow(XtDisplay(dlg),XtWindow(XtParent(dlg)) );
	XtManageChild(dlg);
	XMapWindow(XtDisplay(dlg),XtWindow(XtParent(dlg)) );

}

void search2_callback(w,d,call_data)
Widget w;
Widget d;
XmSelectionBoxCallbackStruct *call_data;
{
	char *str,msg[100];
	int  id,i,n;
	Arg  wargs[5];
	XmString   xmstr;
	PTR_SYMB   sy_ptr;

	XtSetArg(wargs[0],XmNtextString,&xmstr);
	XtGetValues(w,wargs,1);
	XmStringGetLtoR(xmstr,XmSTRING_DEFAULT_CHARSET,&str);

	for (sy_ptr = ptr_file->head_symb; sy_ptr; sy_ptr = sy_ptr->thread) {
		if (!strcasecmp(sy_ptr->ident,str)) {
			show_SYM_dlg(NULL,sy_ptr,NULL);
			break;
		}
	}
	if (sy_ptr==NULL) ReportError("Cannot find such Symbol !");
	XtFree(str);

}
/************************ Select a new dep file ***************************/
void new_session(w,d,call_data)
Widget w;
caddr_t  d;
XmFileSelectionBoxCallbackStruct *call_data;
{
	char *file;
	Cursor  cursor;
	int i;

        cursor=XCreateFontCursor(XtDisplay(topLevel),XC_watch);
        XDefineCursor(XtDisplay(topLevel),XtWindow(topLevel), cursor);

	XtUnmanageChild(w);

	if (!XmStringGetLtoR(call_data->value,XmSTRING_DEFAULT_CHARSET,&file))
		return;
	XtSetSensitive(notify_sym,FALSE);
	XtSetSensitive(notify_llnd,FALSE);
	XtSetSensitive(notify_label,FALSE);
	begin_session(file);
	XtFree(file);

	XUndefineCursor(XtDisplay(topLevel),XtWindow(topLevel));
}


/*************************  Error Handling **************************/
void CloseDlg(w)
Widget w;
{
	XtDestroyWidget(w);
}

int ReportError(msg)
char *msg;
{
        Arg args[MAXARGS];
        int n,answer=0;
        Widget dlg,shell;
        XmString xmMsg;

        xmMsg=XmStringLtoRCreate(msg,XmSTRING_DEFAULT_CHARSET);
        n=0;
        XtSetArg(args[n], XmNmessageString, xmMsg); n++;

        XtSetArg(args[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;

        dlg=XmCreateErrorDialog(topLevel, "Error", args, n);
        XtAddCallback(dlg, XmNokCallback, (XtCallbackProc)CloseDlg, NULL);
        XtUnmanageChild(XmMessageBoxGetChild(dlg, XmDIALOG_CANCEL_BUTTON));
        XtUnmanageChild(XmMessageBoxGetChild(dlg, XmDIALOG_HELP_BUTTON));
        XtManageChild(dlg);
        XmStringFree(xmMsg);
}

int BlockReportError(msg)
char *msg;
{
	Arg args[MAXARGS];
	int n,answer=0;
	Widget dlg,shell;
	XmString xmMsg;
	Atom     WM_DELETE_WINDOW;
        void     resp();

	xmMsg=XmStringLtoRCreate(msg,XmSTRING_DEFAULT_CHARSET);
	n=0;
	XtSetArg(args[n], XmNmessageString, xmMsg); n++;
        XtSetArg(args[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL );n++;
	dlg=XmCreateErrorDialog(topLevel, "Error", args, n);
	XtAddCallback(dlg, XmNokCallback, resp, &answer); 
	XtUnmanageChild(XmMessageBoxGetChild(dlg, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(dlg, XmDIALOG_HELP_BUTTON));
	XtManageChild(dlg);
	XmStringFree(xmMsg);

	shell=XtParent(dlg);
        WM_DELETE_WINDOW=XmInternAtom(XtDisplay(topLevel),"WM_DELETE_WINDOW",
                                        False);
        XmAddWMProtocolCallback(shell,WM_DELETE_WINDOW,resp,&answer);

        while (answer==0) {
                XtProcessEvent(XtIMAll);
                XFlush(XtDisplay(dlg)); 
        }
 	XtDestroyWidget(dlg); 
}

void resp(w,answer,cbs)
Widget w;
int    *answer;
XmAnyCallbackStruct  *cbs;
{
        if (cbs->reason==XmCR_OK)
                *answer=ASK_YES;
        else if (cbs->reason==XmCR_CANCEL)
                *answer=ASK_NO;
             else if (cbs->reason==XmCR_HELP)
                        *answer=ASK_CANCEL;
                  else {
                        *answer=ASK_CANCEL;
                        }
}

#ifdef NEED_PROFILE
/*	profile menu functions	*/
void LoadProfFile(
	Widget  w,
	caddr_t	ind,
	XmAnyCallbackStruct     *call_data
)
{
	Widget    dlg;
	Arg    wargs[9];
	int    n=0;
	XmString dirMask;

	dirMask=XmStringCreate("*.prf",XmSTRING_DEFAULT_CHARSET);
	XtSetArg(wargs[n],XmNdirMask,dirMask); n++;
	XtSetArg(wargs[n],XmNautoUnmanage,TRUE); n++;
	XtSetArg(wargs[n],XmNselectionPolicy,XmSINGLE_SELECT);  n++;
	XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
	dlg=XmCreateFileSelectionDialog(topLevel,"File",wargs,n);
	XtAddCallback(dlg,XmNokCallback,LoadProfFileOK,NULL);
	XtAddCallback(dlg,XmNcancelCallback,UnmanageDlg,dlg);
	XtManageChild(dlg);
}

void LoadProfFileOK(
Widget w,
caddr_t  d,
XmFileSelectionBoxCallbackStruct *call_data
)
{
	char *file;
	Cursor  cursor;
	int i;

    cursor=XCreateFontCursor(XtDisplay(topLevel),XC_watch);
    XDefineCursor(XtDisplay(topLevel),XtWindow(topLevel), cursor);

	XtUnmanageChild(w);

	if (!XmStringGetLtoR(call_data->value,XmSTRING_DEFAULT_CHARSET,&file))
		return;
	
	LoadProfInfo(file);
	PrepareGeneralInfo();
	PrepareStmtList();
	PrepareEventGraph();
	PrepareDataLayout();
	PrepareDataComm();

	XtFree(file);

	XUndefineCursor(XtDisplay(topLevel),XtWindow(topLevel));
}

void ShowProfInfo(
	Widget  w,
	caddr_t	ind,
	XmAnyCallbackStruct     *call_data
)
{
	ShowGeneralInfo();
}

void PopupStmtList(
	Widget  w,
	caddr_t	ind,
	XmAnyCallbackStruct     *call_data
)
{
	ShowStmtList();
}

void PopupEventGraph(
	Widget  w,
	caddr_t	ind,
	XmAnyCallbackStruct     *call_data
)
{
	ShowEventGraph(0);
}

void PopupDataLayout(
	Widget  w,
	caddr_t	ind,
	XmAnyCallbackStruct     *call_data
)
{
	ShowDataLayout(0);
}
#endif
