/*****************************************************************************
        Visualization tool of AST 

    author:  Zheng Gengbin
                            Peking Univ. P.R.C
*****************************************************************************/

#include "Xapp.h"
#include "XSimUtil.h"

#include "process.h"


#define  MAX_HELP_STAGES 3

char *help_text[3][10]={
	{
		"                  Vdumpdep                          ",
		"                                          ",
		"                 version 1.0                         ",
		"                                          ",
		NULL,
	},
	{
		"                Designer :                ",
		"                                          ",
		"                    Zheng Gengbin         ",
		"                    Li    Yu         ",
		NULL,
	},
	{
		"    Vdumpdep is a visualization tool developed ",
		" by PACT.             ",
		"    Vdumpdep help to visualize the AST tree of  ",
		" parallel Fortran program . ",
		"  ",
		NULL,
	},
};


void help_callback(parent,idx_incr,cbs)
Widget parent;
int   idx_incr;
XmAnyCallbackStruct   *cbs;
{
	static  Widget dialog;
	XmString  text;
	char  buf[BUFSIZ], *p;
	static  int  idx;
	int i;
	void  help_done();

	if (dialog && idx_incr==0) {
	        XUnmapWindow(XtDisplay(dialog),XtWindow(XtParent(dialog)) );
        	XtManageChild(dialog);
        	XMapWindow(XtDisplay(dialog),XtWindow(XtParent(dialog)) );
		return;
	}
	if (dialog)
		idx+=idx_incr;
	else {
		Arg args[4];
		XmString done = XmStringCreateSimple("Done");
		XmString cancel = XmStringCreateSimple("Previous");
		XmString more = XmStringCreateSimple("More Help");

		XtSetArg(args[0],XmNautoUnmanage,FALSE);
		XtSetArg(args[1],XmNokLabelString,done);
		XtSetArg(args[2],XmNcancelLabelString,cancel);
		XtSetArg(args[3],XmNhelpLabelString,more);
		dialog=XmCreateInformationDialog(topLevel,"help",args,4);

		XtAddCallback(dialog,XmNokCallback,help_done,&dialog);
		XtAddCallback(dialog,XmNcancelCallback, 
				(XtCallbackProc)help_callback, (XtPointer)-1);
		XtAddCallback(dialog,XmNhelpCallback, 
				(XtCallbackProc)help_callback, (XtPointer)1);
		XtAddCallback(dialog,XmNdestroyCallback, 
				(XtCallbackProc)help_done,&dialog);
		
		XmStringFree(done);
		XmStringFree(cancel);
		XmStringFree(more);
		idx=0;
	}
	
	for (p=buf,i=0; help_text[idx][i];i++) {
		p+=strlen(strcpy(p,help_text[idx][i]));
		*p++='\n';
	}
	*p=0;
	text=XmStringCreateLtoR(buf,XmSTRING_DEFAULT_CHARSET);	
	XtVaSetValues(dialog,XmNmessageString,text,NULL);
	XmStringFree(text);

	XtSetSensitive(XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON),
			idx>0);
	XtSetSensitive(XmMessageBoxGetChild(dialog,XmDIALOG_HELP_BUTTON),
			idx<MAX_HELP_STAGES-1);
	XtManageChild(dialog);
}


void help_done(dialog,dlg)
Widget dialog , *dlg;
{
	if (!*dlg) return;
	XtDestroyWidget(dialog);
	*dlg=NULL;
}


		
