/****************************************************************
 *								*
 *			Multiple List Header File		*
 *			   	by Li, Yu			*
 *			Version 1.0	11/29/92		*
 *								*
 ****************************************************************/

#ifndef _XMULTILIST_H
#define _XMULTILIST_H


#include "./Xutil.h"

/**************************** Macros ****************************/

/* inline functions */
/* get No.no list widget ID in a MultiList */
#define XuMListGetList(mList,no) *((mList)->lists+(no))

/* get Major list widget ID in MultiList */
#define XuMListGetMajorList(mList) *((mList)->lists+(mList)->listCount-1)

/* get scrollbar widget ID in MultiList */
#define XuMListGetScrollBar(mList) mList->vScrollBar

/* get rowcolumn widget ID in MultiList */
#define XuMListGetForm(mList) mList->form

/* constant */
#define MLISTDEFAULTWIDTH 100
#define MLISTDEFAULTHEIGHT 5
#define DEFSBARWID 15


/**************************** Types *****************************/

/* multi-list */
typedef struct
{
	XuWidgetClassCode classCode;
	Widget form;
	Widget *lists;
	int listCount;
	Widget vScrollBar;
}
MultiList, *MultiListPtr;		


/************************* Function Prototype ********************/

MultiList *XuCreateMultiList();		/* create a MultiList */

int XuMListAddCallback();		/* add a Callback to the Multi-
					   List, usually a selection Call-
					   back */
int XuMListAddItem();			/* add a item (multi-column) to
					   a MultiList */
int XuMListSetItems();			/* set items in a MultiList */

int XuMListSetPos();			/* set first visible position of a
					   Multi-List */
int XuMListSetBottomPos();		/* set last visible position of a
					   Multi-List */
int XuMListSelectPos();			/* select a position in a Multi-List */

int XuManageMultiList();		/* Manage a MultiList */
int XuUnmanageMultiList();		/* Unmanage a MultiList */
int XuDestroyMultiList();		/* destory a MultiList */

#endif
