/*
 *      XhDialog.c
 *              Define a simple interface to show and
 *      handle error or warning dialogs.
 *
 *      Author:  Zheng Gengbin
 *      Date:   11/7/95
 *
 */


#include "Xapp.h"
#include "XSimUtil.h"


static void response();

/*    
 *                   MessageBox block until response
 *
*/
int XhBlockMessageDialog(parent,message,type)
Widget parent;
char  *message;
unsigned char type;
{
	Widget dlg,shell;
	Arg    args[MAXARGS];
	int    n;
	int    answer=0;
	XmString xmstr;
	Atom   WM_DELETE_WINDOW;
	
	xmstr=XmStringCreateLtoR(message,XmSTRING_DEFAULT_CHARSET);
	n=0;
	
	XtSetArg(args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL);n++;
	XtSetArg(args[n], XmNmessageString,xmstr); n++;
	XtSetArg(args[n], XmNdeleteResponse, XmDO_NOTHING);  n++;
	switch (type)
        {
        case XmDIALOG_WORKING:
                dlg=XmCreateWorkingDialog(parent, "Message", args, n);
                break;
        case XmDIALOG_WARNING:
                dlg=XmCreateWarningDialog(parent, "Message", args, n);
                break;
        case XmDIALOG_QUESTION:
                dlg=XmCreateQuestionDialog(parent, "Message", args, n);
                break;
        case XmDIALOG_INFORMATION:
                dlg=XmCreateInformationDialog(parent, "Message", args, n);
                break;
        case XmDIALOG_ERROR:
                dlg=XmCreateErrorDialog(parent, "Message", args, n);
                break;
        default:
                dlg=XmCreateMessageDialog(parent, "Message", args, n);
                break;
        }
	
	XtAddCallback(dlg,XmNokCallback,response,&answer);
	XtAddCallback(dlg,XmNcancelCallback,response,&answer);
	
	XtManageChild(dlg);

	shell=XtParent(dlg);
	WM_DELETE_WINDOW=XmInternAtom(XtDisplay(parent),"WM_DELETE_WINDOW",
                                        False);
	XmAddWMProtocolCallback(shell,WM_DELETE_WINDOW,response,&answer);

	while (answer==0) {
                XtProcessEvent(XtIMAll);
                XSync(XtDisplay(dlg),0);
        }

	XmStringFree(xmstr);
	XtDestroyWidget(dlg);
}


static void response(w,answer,cbs)
Widget w;
int    *answer;
XmAnyCallbackStruct *cbs;
{
	Widget dialog;
	
	if (cbs->reason==XmCR_OK) 
		*answer=1;
	else if (cbs->reason==XmCR_CANCEL)
                *answer=1;

	if (cbs->reason!=XmCR_OK && cbs->reason!=XmCR_CANCEL
		&& cbs->reason!=XmCR_HELP)
		*answer=1;
}
