
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include "Xapp.h"
#include "XSimUtil.h"

#include "process.h"

extern Widget topLevel, notifyText, drawArea, scrollText, arrow;

/********************* List file processing ********************/
#define DEP_SUFFIX ".dep"
#define LST_SUFFIX ".lst"

#define MIN_CHAR    6

char *fileBuf=NULL;

int ReadListFile(depFileName)
char *depFileName;
{
	char * fileName, * suffix;
	char buf[256];
	FILE *fp;

	if (fileBuf!=NULL) free(fileBuf);
	fileBuf=strdup("\n");
	if (depFileName==NULL) return FAILURE;
	fileName=strdup(depFileName);
	if ( (suffix=strstr(fileName, DEP_SUFFIX))==NULL )		
		return FAILURE;
	else 
	{	/* modify file name and readin file */
		strcpy(suffix, LST_SUFFIX);
		if ((fp=fopen(fileName, "r"))==NULL)
			return FAILURE;
		while (fgets(buf, sizeof(buf)-1, fp)!=NULL)
		{
			/*if (strlen(buf)<=MIN_CHAR) continue;*/ 
			if (buf[0]!=' ') continue; 
			fileBuf=(char *)realloc(fileBuf, strlen(fileBuf)+strlen(buf)+2);
			strcat(fileBuf, buf);
		}
	}
	return SUCCESS;
}

int GetLinePosition(lineNo, start, end)
int lineNo; 
XmTextPosition *start; 
XmTextPosition *end;
{
	int line;
	
	if (start==NULL || end==NULL) return FAILURE;
	if (lineNo<0) return FAILURE;
	for (line=0, (*start)=0; line<lineNo; (*start)++)
	{
		if (fileBuf[*start]=='\0')
			return FAILURE;
		if (fileBuf[*start]=='\n')
			line++;
	}
	for ((*end)=(*start); fileBuf[*end]!='\0' && fileBuf[*end]!='\n'; (*end)++);
	
	return SUCCESS;
}

int GetPositionLine(pos, lineNo)
XmTextPosition pos;
int *lineNo;
{
	long i;

	if (lineNo==NULL) return FAILURE;
	
	for ((*lineNo)=0, i=0; i<pos; i++)
	{
		if (fileBuf[i]=='\0') return FAILURE;
		if (fileBuf[i]=='\n') (*lineNo)++;
	}
	return SUCCESS;
}
