/*****************************************************************************
        Visualization tool of AST 

    author:  Zheng Gengbin
                            Peking Univ. P.R.C
*****************************************************************************/

#include <Xm/BulletinB.h>
#include <Xm/Label.h>

#include "Xapp.h"
#include "XSimUtil.h"

#include "process.h"

#define FOLLOW_BIF_POINTER_TO_ID(VAR) \
    (bf_ptr->entry.Template.VAR? bf_ptr-> entry.Template.VAR->id: -1)

#define FOLLOW_SYMB_POINTER_2_TO_ID(VAR) \
    (sy_ptr->entry.VAR? sy_ptr->entry.VAR->id: -1)

#define FOLLOW_TYPE_POINTER_TO_ID(VAR) \
    (ty_ptr->entry.VAR? ty_ptr->entry.VAR->id: -1)

#define MAX_TAG  900


extern void Ok_callback();
void closed();

void show_CMNT_dlg();

PTR_STACK stackp=NULL;

push(ok)
Widget ok;
{
        PTR_STACK p;

        p= (PTR_STACK) malloc(sizeof(STACK_ELE));
        p->ok=ok;  p->next=stackp;
	stackp = p;
/*
        if (stackp==NULL) {
                stackp=p;
                return;
        }
        p->next=stackp;
        stackp=p;
*/
}

int pop()
{
	if (stackp == NULL) return 0;
        stackp=stackp->next;
	return 1;
}

Widget top()
{
        return stackp->ok;
}

/*
void endcb(ok)
Widget ok;
{
        Widget dlg;
        Arg    args[3];

        XtSetArg(args[0],XmNuserData,(Widget)&dlg);
        XtGetValues(ok,args,1);
        XtCallCallbacks(ok,XmNactivateCallback,dlg);
        XuPressButton(NULL,1);
}
*/

void endcb(ok)
Widget ok;
{
        Widget dlg,ele;
        Arg    args[3];
	PTR_STACK p;
	
	if (ok == NULL ) return;

	do {
	ele= top();
	if (ele && XtWindow(ele) && XtIsRealized(ele)) {
        	XtSetArg(args[0],XmNuserData,(Widget)&dlg);
        	XtGetValues(ele,args,1);
        	XtCallCallbacks(ele,XmNactivateCallback,dlg);
	}
	if (!pop()) break;
	} while (ele != ok);
}

void closed(w,ok,event)
Widget w;
Widget ok;
XEvent *event;
{
        int  length;
        int  theKeyBufferMaxlen=64;
        char  theKeyBuffer[65];
        KeySym   theKeySym;
        XComposeStatus theComposeStatus;

        length=XLookupString((XKeyEvent *)event,theKeyBuffer,theKeyBufferMaxlen,
                                &theKeySym,&theComposeStatus);
        if (theKeySym==XK_Escape) {
                XuPressButton(ok,0);
                XFlush(XtDisplay(ok));
                XtAddTimeOut(200,(XtTimerCallbackProc)endcb,ok);
       		XuPressButton(NULL,1);
        }
}


/****************************************************************************
			BIF Dialog Block :

****************************************************************************/

Widget create_BFND_dlg(bf_ptr)
PTR_BFND    bf_ptr;
{
 Widget BFND_info_dlg;
 Widget buttons[20],labels[20];
 Widget w[20];
 int    n=0,i,m;
 Arg    wargs[MAXARGS];
 char   str[100],*s1;
 XmString  xmstr;
 int n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16, n17;
 int    lineno,no=0;

        XtSetArg(wargs[n],XmNautoUnmanage,FALSE); n++;
        XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
        BFND_info_dlg=XmCreateBulletinBoardDialog(topLevel,
                           "BFND_Node_Info",wargs,n);

	n3 = bf_ptr->control_parent ? bf_ptr->control_parent->id : -1;
	n4 = FOLLOW_BIF_POINTER_TO_ID(bf_ptr1);
	n10 = FOLLOW_BIF_POINTER_TO_ID(dep_ptr1);
	n11 = FOLLOW_BIF_POINTER_TO_ID(dep_ptr2);
	n12 = bf_ptr->label? bf_ptr->label->id: -1;
	n13 = FOLLOW_BIF_POINTER_TO_ID(lbl_ptr);
	n16 = bf_ptr->filename->id;

        lineno=0;
        XtSetArg(wargs[0],XmNx,COL_X2+100);
        XtSetArg(wargs[1],XmNy,GETY(lineno));
        XtSetArg(wargs[2],XmNwidth,100);
        XtSetArg(wargs[3],XmNheight,LABEL_HEIGHT);
        w[no++]=XtCreateWidget("Ok",xmPushButtonWidgetClass,BFND_info_dlg,
                              wargs,4);
push(w[no-1]);
        XtAddCallback(w[no-1],XmNactivateCallback,Ok_callback,BFND_info_dlg);
        lineno++;

	w[no++]=create_label1(BFND_info_dlg,COL_X1,lineno,"ID");
	n1 = bf_ptr->id;
	switch (bf_ptr->checked) {
	case SOFT :     	sprintf(str,"%5d     SOFT",n1); break;
	case HARD:      	sprintf(str,"%5d     HARD",n1); break;
	case VIRTUAL_BFND:      sprintf(str,"%5d     VIRTUAL",n1); break;
	}
	w[no++]=create_label2(BFND_info_dlg,COL_X2,lineno,str);
	lineno++;


	w[no++]=create_label1(BFND_info_dlg,COL_X1,lineno,"Variant");
	w[no++]=create_label2(BFND_info_dlg,COL_X2,lineno,tag[bf_ptr->variant]);
	lineno++;

	w[no++]=create_label1(BFND_info_dlg,COL_X1,lineno,"Global");
	n14 = bf_ptr->g_line;
        sprintf(str,"%5d",n14);
	w[no++]=create_label2(BFND_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_label1(BFND_info_dlg,COL_X1,lineno,"Local");
	n15 = bf_ptr->l_line;
        sprintf(str,"%5d",n15);
	w[no++]=create_label2(BFND_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Label");
	XtAddCallback(w[no-1],XmNactivateCallback,show_LABEL_dlg,
                                             bf_ptr->label);
	if (bf_ptr->label==NULL) XtSetSensitive(w[no-1],FALSE);
	lineno++;

	switch (bf_ptr->variant) {
	case USE_STMT:
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,
							"Use Only (1)");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                   bf_ptr->entry.use_stmt.useonly_expr);
		if (bf_ptr->entry.use_stmt.useonly_expr==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,
							"Use Rename (2)");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                 bf_ptr->entry.use_stmt.userename_expr);
		if (bf_ptr->entry.use_stmt.userename_expr==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		break;
	case VAR_DECL:	
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Entities");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                       bf_ptr->entry.var_decl.entities);
		if (bf_ptr->entry.var_decl.entities==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;

		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Type");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                       bf_ptr->entry.var_decl.type);
		if (bf_ptr->entry.var_decl.type==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;

		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Attributes");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                    bf_ptr->entry.var_decl.attributes);
		if (bf_ptr->entry.var_decl.attributes==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		break;
	case ASSIGN_STAT:
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"l_value");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                       bf_ptr->entry.assign_s.l_value);
		if (bf_ptr->entry.assign_s.l_value==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;

		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"r_value");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                       bf_ptr->entry.assign_s.r_value);
		if (bf_ptr->entry.assign_s.r_value==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		break;
	case COMGOTO_NODE:
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"label_list");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                bf_ptr->entry.computed_goto.label_list);
		if (bf_ptr->entry.computed_goto.label_list==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,
							"Goto expression");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                bf_ptr->entry.computed_goto.goto_expr);
		if (bf_ptr->entry.computed_goto.goto_expr==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		break;
	case PROG_HEDR:
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,
							"Next Program");
		XtAddCallback(w[no-1],XmNactivateCallback,show_BFND_dlg,
	                                   bf_ptr->entry.prog_stmt.next_prog);
		if (bf_ptr->entry.prog_stmt.next_prog==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;

		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Prog Symbol");
		XtAddCallback(w[no-1],XmNactivateCallback,show_SYM_dlg,
	                                bf_ptr->entry.prog_stmt.prog_symb);
		if (bf_ptr->entry.prog_stmt.prog_symb==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
		break;
	default:
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Symbol");
		XtAddCallback(w[no-1],XmNactivateCallback,show_SYM_dlg,
	                                         bf_ptr->entry.Template.symbol);
		if (bf_ptr->entry.Template.symbol==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
	
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Do Label");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LABEL_dlg,
	                                   bf_ptr->entry.Template.lbl_ptr);
		if (bf_ptr->entry.Template.lbl_ptr==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
	
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"ll_ptr1");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                    bf_ptr->entry.Template.ll_ptr1);
		if (bf_ptr->entry.Template.ll_ptr1==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
	
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"ll_ptr2");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                    bf_ptr->entry.Template.ll_ptr2);
		if (bf_ptr->entry.Template.ll_ptr2==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
	
		w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"ll_ptr3");
		XtAddCallback(w[no-1],XmNactivateCallback,show_LLND_dlg,
	                                    bf_ptr->entry.Template.ll_ptr3);
		if (bf_ptr->entry.Template.ll_ptr3==NULL) 
				XtSetSensitive(w[no-1],FALSE);
		lineno++;
	}
	
	w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Control Parent");
	XtAddCallback(w[no-1],XmNactivateCallback,show_BFND_dlg,
                                             bf_ptr->control_parent);
	if (bf_ptr->control_parent==NULL) XtSetSensitive(w[no-1],FALSE);
	lineno++;

	w[no++]=create_button(BFND_info_dlg,COL_X1,lineno,"Comment");
	XtAddCallback(w[no-1],XmNactivateCallback,show_CMNT_dlg,
                                      bf_ptr->entry.Template.cmnt_ptr);
	if (bf_ptr->entry.Template.cmnt_ptr==NULL)
			XtSetSensitive(w[no-1],FALSE);
	lineno++;

	for (i=0;i<no;i++)
		XtAddEventHandler(w[i],KeyPressMask,FALSE,(XtEventHandler)closed,w[0]);

	XtSetArg(wargs[0],XmNx,COL_X1);
	XtSetArg(wargs[1],XmNy,GETY(lineno));
	XtSetArg(wargs[2],XmNwidth,LABEL_WIDTH+40);
	XtSetArg(wargs[3],XmNheight,0);
	w[no++]=XtCreateManagedWidget("",xmLabelWidgetClass,
 			BFND_info_dlg,wargs,4);

	XtManageChildren(w,no);

        return BFND_info_dlg;
}


void show_BFND_dlg(w,d,call_data)
Widget     w;
PTR_BFND       d;
XmAnyCallbackStruct     *call_data;
{
	Widget dlg;
	dlg=create_BFND_dlg(d);
        if (dlg==NULL) {
             fprintf(stderr,"No more dlg !\n");
             return;
	}
	XtManageChild(dlg);
}

void show_BFND_dlg1(w,d,call_data)
Widget     w;
int        *d;
XmAnyCallbackStruct     *call_data;
{
	if (*d<0) return ;
	show_BFND_dlg(w,b_tree[*d].bfnd,call_data);
}

/**************************************************************************
                       LABEL Dialog Block
****************************************************************************/

Widget create_LABEL_dlg(lb_ptr)
PTR_LABEL      lb_ptr;
{
 Widget      LABEL_info_dlg;
 Widget buttons[20],labels[20],w[30];
 int    n=0,i;
 Arg    wargs[MAXARGS];
 char   str[20];
 XmString  xmstr;
 int     n1, n2, n3;
 int     n4, n5, n6;   /*  NEW ADDED FOR VPC */
 char buf[33];
 int     no=0,lineno;

        XtSetArg(wargs[n],XmNautoUnmanage,FALSE); n++;
        XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
        LABEL_info_dlg=XmCreateBulletinBoardDialog(topLevel,
                           "LABEL_Node_Info",wargs,n);

	lineno=0;
	XtSetArg(wargs[0],XmNx,COL_X2+110);
	XtSetArg(wargs[1],XmNy,GETY(lineno));
	XtSetArg(wargs[2],XmNwidth,100);
	XtSetArg(wargs[3],XmNheight,LABEL_HEIGHT);
        w[no++]=XtCreateWidget("Ok",xmPushButtonWidgetClass,LABEL_info_dlg,
                              wargs,4);
push(w[no-1]);
        XtAddCallback(w[no-1],XmNactivateCallback,Ok_callback,LABEL_info_dlg);
	lineno++;

	w[no++]=create_label1(LABEL_info_dlg,COL_X1,lineno,"ID");
        n1 = lb_ptr->id;
        sprintf(str,"%5d",n1);
	w[no++]=create_label2(LABEL_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_label1(LABEL_info_dlg,COL_X1,lineno,"Stmt label");
        n1 = (int)lb_ptr->stateno;
        sprintf(str,"%5d",n1);
	w[no++]=create_label2(LABEL_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_label1(LABEL_info_dlg,COL_X1,lineno,"Label type");
        n1 = (int)lb_ptr->labtype;
	switch (n1) {
	case 0:   sprintf(str,"UNKNOWN");  break;
	case 1:   sprintf(str,"EXEC");  break;
	case 2:   sprintf(str,"FORMAT");  break;
	case 3:   sprintf(str,"OTHER");  break;
	default : sprintf(str,"Unknown");  break;
	}
	w[no++]=create_label2(LABEL_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_label1(LABEL_info_dlg,COL_X1,lineno,"Label defined");
        n1 = (int)lb_ptr->labdefined;
	switch (n1) {
	case 0:   sprintf(str,"No");  break;
	case 1:   sprintf(str,"Yes");  break;
	default : sprintf(str,"Unknown");  break;
	}
	w[no++]=create_label2(LABEL_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_label1(LABEL_info_dlg,COL_X1,lineno,"Label used");
        n1 = (int)lb_ptr->labused;
	switch (n1) {
	case 0:   sprintf(str,"No");  break;
	case 1:   sprintf(str,"Yes");  break;
	default : sprintf(str,"Unknown");  break;
	}
	w[no++]=create_label2(LABEL_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_button(LABEL_info_dlg,COL_X1,lineno,"Scope");
	XtAddCallback(w[no-1],XmNactivateCallback,(XtCallbackProc)show_BFND_dlg,
			lb_ptr->scope);
	if (lb_ptr->scope==NULL) XtSetSensitive(w[no-1],FALSE);
	lineno++;

	w[no++]=create_button(LABEL_info_dlg,COL_X1,lineno,"Statement");
	XtAddCallback(w[no-1],XmNactivateCallback,(XtCallbackProc)show_BFND_dlg,
			lb_ptr->statbody);
	if (lb_ptr->statbody==NULL) XtSetSensitive(w[no-1],FALSE);
	lineno++;

	w[no++]=create_button(LABEL_info_dlg,COL_X1,lineno,"Label name");
	XtAddCallback(w[no-1],XmNactivateCallback,show_SYM_dlg,
                                             lb_ptr->label_name);
	if (lb_ptr->label_name==NULL) XtSetSensitive(w[no-1],FALSE);
	lineno++;

	w[no++]=create_button(LABEL_info_dlg,COL_X1,lineno,"Next Label");
	XtAddCallback(w[no-1],XmNactivateCallback,show_LABEL_dlg,
                                             lb_ptr->next);
	if (lb_ptr->next==NULL) XtSetSensitive(w[no-1],FALSE);
	lineno++;

	for (i=0;i<no;i++)
		XtAddEventHandler(w[i],KeyPressMask,FALSE,(XtEventHandler)closed,w[0]);

	XtSetArg(wargs[0],XmNx,COL_X1);
	XtSetArg(wargs[1],XmNy,GETY(lineno));
	XtSetArg(wargs[2],XmNwidth,LABEL_WIDTH+40);
	XtSetArg(wargs[3],XmNheight,0);
	w[no++]=XtCreateManagedWidget("",xmLabelWidgetClass,
 			LABEL_info_dlg,wargs,4);

	XtManageChildren(w,no);
	return LABEL_info_dlg;
}

void show_LABEL_dlg(w,lb_ptr,call_data)
Widget     w;
PTR_LABEL      lb_ptr;
XmAnyCallbackStruct     *call_data;
{
	char str[50];

	Widget LABEL_info_dlg;
	if (lb_ptr==NULL) {
		BlockReportError("Error: NULL Label found ! ");
		return;
	}
	if (lb_ptr->id > ptr_file->num_label || lb_ptr->id<1 )  {
		sprintf(str,"Error: Invalid TYPE id: %d !",lb_ptr->id);
		BlockReportError(str);
		return;
	}
        LABEL_info_dlg=create_LABEL_dlg(lb_ptr);
        XtManageChild(LABEL_info_dlg);
}

void show_LABEL_dlg1(w,d,call_data)
Widget     w;
caddr_t        d;
XmAnyCallbackStruct     *call_data;
{
	Arg  wargs[5];
	NODE_PTR   node_ptr;


        XtSetArg(wargs[0],XmNuserData,&node_ptr);
        XtGetValues(w,wargs,1);
	if (node_ptr->llnd->entry.label_list.lab_ptr==NULL)
		BlockReportError("Error: NULL Label ");
	else
        show_LABEL_dlg(w,node_ptr->llnd->entry.label_list.lab_ptr,call_data);
}

void show_LABEL_dlg2(w,d,call_data)
Widget     w;
int        *d;
XmAnyCallbackStruct     *call_data;
{
	show_LABEL_dlg(w,b_tree[*d].bfnd->label,call_data);
}


/**************************************************************************
                       COMMENT Dialog Block
****************************************************************************/

Widget create_CMNT_dlg(cm_ptr)
PTR_CMNT      cm_ptr;
{
 Widget      CMNT_info_dlg;
 Widget buttons[20],labels[20],w[30];
 int    n=0,i;
 Arg    wargs[MAXARGS];
 char   str[20];
 XmString  xmstr;
 int     n1, n2, n3;
 int     n4, n5, n6;   /*  NEW ADDED FOR VPC */
 char buf[33];
 int     no=0,lineno;

        XtSetArg(wargs[n],XmNautoUnmanage,FALSE); n++;
        XtSetArg(wargs[n],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);n++;
        CMNT_info_dlg=XmCreateBulletinBoardDialog(topLevel,
                           "CMNT_Node_Info",wargs,n);

	lineno=0;
	XtSetArg(wargs[0],XmNx,COL_X2+110);
	XtSetArg(wargs[1],XmNy,GETY(lineno));
	XtSetArg(wargs[2],XmNwidth,100);
	XtSetArg(wargs[3],XmNheight,LABEL_HEIGHT);
        w[no++]=XtCreateWidget("Ok",xmPushButtonWidgetClass,CMNT_info_dlg,
                              wargs,4);
push(w[no-1]);
        XtAddCallback(w[no-1],XmNactivateCallback,Ok_callback,CMNT_info_dlg);
	lineno++;

	w[no++]=create_label1(CMNT_info_dlg,COL_X1,lineno,"ID");
        n1 = cm_ptr->id;
        sprintf(str,"%5d",n1);
	w[no++]=create_label2(CMNT_info_dlg,COL_X2,lineno,str);
	lineno++;

	w[no++]=create_label1(CMNT_info_dlg,COL_X1,lineno,"Type");
        n1 = cm_ptr->type;
        sprintf(str,"%5d",n1);
	w[no++]=create_label2(CMNT_info_dlg,COL_X2,lineno,str);
	lineno++;
/*	
	XtSetArg(wargs[0],XmNx,COL_X1);
	XtSetArg(wargs[1],XmNy,GETY(lineno));
	XtSetArg(wargs[2],XmNwidth,LABEL_WIDTH+40);
	XtSetArg(wargs[3],XmNheight,0);
	w[no++]=XtCreateManagedWidget("",xmLabelWidgetClass,
 			CMNT_info_dlg,wargs,4);
	lineno++;
*/

	XtManageChildren(w,no);

	n=0;
	XtSetArg(wargs[n],XmNx,COL_X1); n++;
	XtSetArg(wargs[n],XmNy,GETY(lineno)); n++;
	XtSetArg(wargs[n],XmNwidth,BUTTON_WIDTH);  n++;
	XtSetArg(wargs[n],XmNeditMode,XmMULTI_LINE_EDIT);  n++;
	XtSetArg(wargs[n],XmNrows,9); n++;
	XtSetArg(wargs[n],XmNeditable,FALSE); n++;
	w[no++]=XmCreateScrolledText(CMNT_info_dlg,"comment",wargs,n);
	XtManageChild(w[no-1]);
	XmTextSetString(w[no-1], cm_ptr->string);

	return CMNT_info_dlg;
}


void show_CMNT_dlg(w,lb_ptr,call_data)
Widget     w;
PTR_CMNT      lb_ptr;
XmAnyCallbackStruct     *call_data;
{
	Widget CMNT_info_dlg;
        CMNT_info_dlg=create_CMNT_dlg(lb_ptr);
        XtManageChild(CMNT_info_dlg);
}

void show_CMNT_dlg1(w,d,call_data)
Widget     w;
int        *d;
XmAnyCallbackStruct     *call_data;
{
	show_CMNT_dlg(w,b_tree[*d].bfnd->entry.Template.cmnt_ptr,call_data);
}



