// same basic forall class
//
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include <stdio.h>

#include "compilerApi.h"

#include "anls_att.h"

void Forall_index_def::setsymbol(SgSymbol * symb)
{
  indexvar=symb;
}

SgSymbol * Forall_index_def::getsymbol()
{
  return indexvar;
}

void Forall_index_def::setlb(SgSymbol * symb)
{
  lb=symb;
}

SgSymbol * Forall_index_def::getlb()
{
  return lb;
}
void Forall_index_def::setub(SgSymbol * symb)
{
  ub=symb;
}

SgSymbol * Forall_index_def::getub()
{
  return ub;
}
void Forall_index_def::setstep(SgSymbol * symb)
{
  step=symb;
}

SgSymbol * Forall_index_def::getstep()
{
  return step;
}

//--------------------------;

Forall_header_def::Forall_header_def(void)
{
  number=0;
  condition=NULL;
  for (int i=0; i<MAX_INDEX_DIM; i++) 
    for (int j=0; j<3; j++)
      index[i].indextriple[j]=NULL;
}

int Forall_header_def::getindexnumber(void)
{
  return number;
}

void Forall_header_def::setindexsymb(SgSymbol * s)
{
  number++;
  index[number-1].indexvar=s;
}

SgSymbol * Forall_header_def::getindexsymb(int i)
{
  return index[i].indexvar;
}

void Forall_header_def::setindextriple(int i, SgExpression * e)
{
  index[number-1].indextriple[i]=e;
}

SgExpression * Forall_header_def::getindextriple(int i, int j)
{
  return index[i].indextriple[j];
}

void Forall_header_def::setcondition(SgExpression * e)
{
  condition=e;
}

SgExpression * Forall_header_def::getcondition(void)
{
  return condition;
}

void Forall_header_def::show(void)
{
  for (int i=0; i<number; i++)
    printf("The %dth index is %s\n", i, index[i].indexvar->identifier());
}


int Forall_header_def::evaluatable_index(int i)
{
  if (i>=number)
    printf("No such index!");

  for (int j=0; j<3; j++) {
    if (index[i].indextriple[j]!=NULL)
      if (!index[i].indextriple[j]->isInteger())
	return(0);
  }  
  return (1);
}

// ------------------

forall_reference::forall_reference (Position s)
{
  int i;
  side=s;

  for (i=0; i<MAX_ALIGN_DIM; i++) 
    for (int j=0; j<MAX_INDEX_DIM; j++)
    {
      index_level[i][j]=0;
      stride[i][j]=NULL;
      offset[i][j]=NULL;
    }

  status = NONE;

  // hold some special information on communication.
  comm_tag = 0;
 
  sameAs = -1;

  for (i=0; i< MAX_ALIGN_DIM ; i++)
	 amount[i]=0;
}

int forall_reference::getposition()
{
  return side;
}

void forall_reference::setExpr(SgExpression * e)
{
  expr=e;
  arraysymb = expr->symbol();
}

SgExpression * forall_reference::getexpression()
{
  return expr;
}

SgSymbol * forall_reference::getarraysymbol()
{
  return arraysymb;
}

void forall_reference::setIndex(int arraydim, int indexdim,int IL)
{
  index_level[arraydim][indexdim]=IL;
}

int forall_reference::getIndex(int arraydim, int indexdim)
{
  return index_level[arraydim][indexdim];
}

void forall_reference::setstride(int arraydim, int indexdim, SgExpression * expr)
{
  stride[arraydim][indexdim]=expr;
}

SgExpression * forall_reference::getstride(int arraydim, int indexdim)
{
  return stride[arraydim][indexdim];
}

void forall_reference::setoffset(int arraydim, int indexdim, SgExpression * expr)
{
  offset[arraydim][indexdim]=expr;
}

SgExpression * forall_reference::getoffset(int arraydim, int indexdim)
{
  return offset[arraydim][indexdim];
}

void forall_reference::setCommunication(Communication com)
{
  status=com;
}

Communication forall_reference::getCommunication()
{
  return status;
}

void forall_reference::setIShift()
{
  comm_tag = 1;
}

int  forall_reference::isIShift()
{
  return comm_tag==1? 1:0;
}

void forall_reference::setShadow(Shadow_def * _sdef)
{
  sdef = _sdef;
}

Shadow_def * forall_reference::getShadow()
{
  return sdef;
}

int forall_reference::checkRegular()
{
  switch (expr->variant()) {
  case VAR_REF: 
    return (1);
    break;
  case ARRAY_REF:
    {
      SgArrayRefExp * array = (SgArrayRefExp *) expr;

      for (int i=0; i<array->numberOfSubscripts(); i++) {
	int indexcounter = 0;
	for (int j=0; j<MAX_INDEX_DIM; j++)
	  if (index_level[i][j]!=0)
	    if (index_level[i][j]!=1)
	      return 0;
	    else
	      indexcounter++;
	if (indexcounter>1)
	  return 0;
      }
	// check for a(i,i)
      for (int j=0; j<MAX_INDEX_DIM; j++) {
	int indexcounter = 0;
     	for (int i=0; i<array->numberOfSubscripts(); i++) 
	  if (index_level[i][j]!=0)
	      indexcounter++;
	if (indexcounter>1)
	  return 0;
      }

      return 1;
      break;
    };
  default:
    printf("Not touched forall reference!\n");
  }
  return 0;
}

void forall_reference::setAmount(int i, int a)
{
  amount[i]=a;
}

int forall_reference::getAmount(int i)
{
  return amount[i];
}

int forall_reference::scalarDim(int dim)
{
// zheng.gb
  if (indexNumberOnDim(dim) == -1 ) return 1;
  return 0;
}

int forall_reference::tripletDim(int i)
{
// zheng.gb
/*
  if (expr->variant() != ARRAY_REF ) return 0;
  SgArrayType *type = (SgArrayType *)expr->symbol()->type();
  SgExpression *thedim = type->sizeInDim(i);
  return (thedim->lhs()->variant() == DDOT) ? 1:0;
*/
  return 1;
}

int forall_reference::hasScalarDim()
{
// zheng.gb
  SgArrayRefExp *array = isSgArrayRefExp(expr);
  ASSERT(array);
  int rank = array->numberOfSubscripts();
  for (int i=0; i<rank; i++) 
	if (indexNumberOnDim(i) == -1) return 1;
  return 0;
}

int forall_reference::isScalar()
{
  for (int i=0; i<MAX_ALIGN_DIM; i++) 
    for (int j=0; j<MAX_INDEX_DIM; j++)
    {
      if (index_level[i][j]!=0) return 0;
    }
  return 1;
}

int forall_reference::indexNumberOnDim(int dim)
{
  for (int i=0; i<MAX_INDEX_DIM; i++)
    if (index_level[dim][i]!=0)
      return i;
  // return the first one;
//  printf("indexNumberOnDim:This is a scalar dim.\n");
  return -1;
}

int forall_reference::dimNumberOnIndex(int dim)
{
  for (int i=0; i<MAX_ALIGN_DIM; i++)
    if (index_level[i][dim]!=0)
      return i;
  // return the first one;
//  printf("indexNumberOnDim:This is a scalar dim.\n");
  return -1;
}

int forall_reference::numberOfIndex()
{
  int sum=0;
  for (int i=0; i<MAX_ALIGN_DIM; i++) 
   for (int j=0; j<MAX_INDEX_DIM; j++)
    if (index_level[i][j]!=0) sum++;
  return sum;
}

int forall_reference::numberOfDiffIndex()
{
  int sum=0;
  for (int j=0; j<MAX_INDEX_DIM; j++)
  {
   int i;
   for (i=0; i<MAX_ALIGN_DIM; i++) 
    	if (index_level[i][j]!=0) break;
   if (i<MAX_ALIGN_DIM) sum++;
  }
  return sum;
}

int forall_reference::refered(int index)
{
   int i;
   for (i=0; i<MAX_ALIGN_DIM; i++) 
    	if (index_level[i][index]!=0) break;
   if (i==MAX_ALIGN_DIM) return 0;
   return 1;
}

int forall_reference::evaluatable()
{
  for (int i=0; i<MAX_ALIGN_DIM; i++) {
    for (int j=0; j<MAX_INDEX_DIM; j++) {
      if (stride[i][j]!=NULL)
	if(!stride[i][j]->isInteger()) {
	  return(0);
	};

      if (offset[i][j]!=NULL)
	if(!stride[i][j]->isInteger()) {
	  return(0);
	}
	  
    }
  }
  return (1);
}

void forall_reference::show()
{
  printf(" FR exp: % 3d is on %d side with index level: \n", expr->id(), int(side));
  for (int i=0; i< MAX_ALIGN_DIM; i++) {
    printf("      ");
    for (int j=0; j< MAX_INDEX_DIM; j++)
      printf("% 2d", index_level[i][j]);
    printf("\n");
  }

  printf("comm code :%d\n", status);

}


expression_reference::expression_reference(SgExpression *exp1)
{
	exp=exp1;
	same_exp=NULL;
}

expression_reference::expression_reference(SgExpression *exp_,SgExpression *same_exp_)
{
	exp=exp_;
	same_exp=same_exp_;
}

void expression_reference::insert(SgStatement *s,int attr)
{
	for (int i=0; i<s->numberOfAttributes(attr); i++) 
	{
       		expression_reference *pre_exp_ref = (expression_reference *)(s->attributeValue(i,attr));
		if ( *(pre_exp_ref->get_expression()) == *exp ) {
			same_exp = pre_exp_ref->get_expression();
			break;
		}
	}
	s->addAttribute(attr,this,sizeof(this) );
}


SgExpression * expression_reference::get_expression()
{
	return exp;
}

SgExpression * expression_reference::get_same_expression()
{
	return same_exp;
}
