/****************************************************************************/

/**                 OUT OF CORE ARRAYEMENT TRANSFORMATION                  **/

/**************************** VERSION 1.0 ***********************************/

/******************** Designed By Du Zhihui and Shi Lixia ******************/

/****** Coded By  Du Zhihui : OUT OF CORE ARRAY IN FORALL STATEMENT      ****/

/****** Coded By  Shi Lixia : OUT OF CORE ARRAY IN READ/WRITE STATEMENT  ****/
/******                     : LOOP TILING                                ****/

/****** Coded By  Huang Qijun : SCALAR OUT OF CORE ARRAY REFERENCE       ****/
/******                         SCALAR OUT OF CORE ARRAY UPDADE          ****/

/*************    Technologn Supported By : Zheng Gengbin   **************/

/********************************   1998.3.7  ****************************/

/****************************************************************************/

/********************         PREFETCH READ        **************************/

/********        optimization for the overlap of IO and computation  ********/

/*****************************   1998.4.5  *******************************/

/****************************************************************************/
/****************************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include <stdio.h>

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"
#include "depInterfaceExt.h"

extern "C" double cbrt(double);

//add by huang
#include "indep.h"
//add finished

int change_to_tiled_index(SgStatement * s ,SgStatement * indexStmt);
SgStatement * get_first_inner(int index_number,SgStatement *inner);
SgStatement  *get_forall_assign_stmt(int index_num,SgStatement  *inner);
SgStatement  *get_body_assign_stmt(int index_num,SgStatement  *inner);
//SgStatement  *get_forall_assign_stmt(SgStatement  *inner);
SgExpression * creat_read_num(SgStatement  *innerloop,int looplevel);
int first_appear_in_RHS(int i,SgStatement *body);

int contain_out_of_core_array(SgStatement *s);
SgStatement * get_out_loop_stmt(SgStatement * inner);
int index_appear_in_array(int k,forall_reference * fref,SgArrayType * arrayType);

SgExpression * get_exp_in_exp(SgExpression * sourceExp,SgExpression *objectExp);
int replace_exp_with_exp(SgStatement * assignmaskStmt,SgExpression *oldExp,SgExpression *newExp);
void calculateTileSize(SgStatement* s,int numofloop,SgExpression * size[]);
SgAssignStmt * make_stride_assign_special(SgStatement *s,SgSymbol * arraySym,char * stride ,int var_num,int i_dim1,int i_dim2,int t);

SgExpression * get_LHS(SgStatement *assignmaskStmt);
SgStatement * loop_tile(SgStatement *s,int loop_num=0);
int not_conflict_with_lhs(SgStatement * s,int i);

  // added by Zheng Gengbin
// for PREFETCH READ
extern int check_prefetch(SgStatement *s);
extern int prefetch_ok(SgStatement *body, int counter);
extern SgSymbol *get_next_loop_index(SgStatement *s, SgStatement *innerloop, SgStatement *firstloop, int looplevel);
extern int modify_sdx(SgStatement *s);
extern int modify_mem_base(SgStatement *s, SgStatement *firstloop,SgSymbol *dad, int counter);
extern int modify_number(SgStatement *s, SgExpression *numberExp, int counter, int index, int loop);
extern int get_previous_number(SgStatement *s, SgExpression *numberExp);
extern int add_first_prefetch_read(SgStatement *s, SgStatement *outloopStmt);

extern void combine_same_if(SgStatement *s);

int  numberOfNestedLoop(SgForStmt *s)
{
    int i;
    int org_numberOfChildren=s->numberOfChildrenList1();
    SgStatement * * children = new SgStatement * [org_numberOfChildren];
    int  counter=1;

    for (i=0; i<org_numberOfChildren; i++)
        children[i]=s->childList1(i);

    for (i=0; i<org_numberOfChildren; i++)
     switch(children[i]->variant())
    {
     case ASSIGN_STAT:
     case ENDDO_STMT:
     case CONTROL_END:
     case LOGIF_NODE:
          break;

     case FOR_NODE:
         return numberOfNestedLoop((SgForStmt *)children[i])+1;
     }

    delete [ ] children;
    return counter;
}

void make_do_perfect(SgStatement *s)
{
    int i;
    int org_numberOfChildren=s->numberOfChildrenList1();
    SgStatement * * children = new SgStatement * [org_numberOfChildren];

    for (i=0; i<org_numberOfChildren; i++)
        children[i]=s->childList1(i);

    for (i=0; i<org_numberOfChildren; i++)
     switch(children[i]->variant())
    {
     case ASSIGN_STAT:
          if(children[i]->expr(0)->variant()==VAR_REF)
                  children[i]->deleteStmt();
          break;

     case ENDDO_STMT:
     case CONTROL_END:
          break;

     case FOR_NODE:
          make_do_perfect(children[i]);
          break;
     }

    delete [ ] children;
}

//detect whether there is outofcore
//1 : outofcore
//0 : none
int loop_tile_assign(SgStatement *s)
{
      int i;
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
        children[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
        switch(children[i]->variant())
        {
         case ASSIGN_STAT:
              if (children[i]->expr(0)->variant()==ARRAY_REF)
               if (children[i]->expr(0)->symbol()->numberOfAttributes(Outofcore_Def) >0) 
                 return (1);
              break;
         case FOR_NODE:
              if (loop_tile_assign(children[i])==1) return (1);
              break; 
        }

      delete [ ] children;
      return (0);
}

SgStatement * loop_tile(SgStatement *s,int loop_num)
{
    SgStatement *transStmt=NULL;
    switch(s->variant()) 
    {
      case LOGIF_NODE:
      {
        int i;
        int org_numberOfChildren1=s->numberOfChildrenList1();
        SgStatement * * children1 = new SgStatement * [org_numberOfChildren1];
        for (i=0; i<org_numberOfChildren1; i++) children1[i]=s->childList1(i);
        for (i=0; i<org_numberOfChildren1; i++) {
		if (transStmt=loop_tile(children1[i]))
			return transStmt;
	}
        delete [] children1;
	ASSERT(0);
        break;
      }// end of LOGIF_NODE

      case FOR_NODE:
      {
        int i,j;
        SgStatement *func=s->getScopeForDeclare();
	int numofloop;
        if(!loop_num) numofloop=numberOfNestedLoop((SgForStmt *)s);
        else numofloop=loop_num;  //modified by huang
        SgExpression *size[7],*PT[8],*ITE_NUM[7];
	SgExpression *TOTAL_SIZE = get_in_core_size(s);
//add by huang
        if(s->numberOfAttributes(COLLAPSE_NUM)>0){
                TOTAL_SIZE=&(*TOTAL_SIZE/(*(SgExpression *)s->attributeValue(0,COLLAPSE_NUM)));
        }
//add finished!
        SgStatement * out_loop_stmt = get_out_loop_stmt(s);
        SgExpression *tmpExp;
    
        for (i=0;i<8;i++) PT[i]=new SgValueExp(1);
        for (i=0;i<numofloop;i++)
        {
           ITE_NUM[i]=creat_read_num(out_loop_stmt,i+1) ;
           ITE_NUM[i]=calculateExp(ITE_NUM[i]);
        }
        for (i=numofloop-1;i>=0;i--)
        {  
             SgSymbol * minSym= s->getSymbolInCurrentScope("min");
             SgSymbol * maxSym= s->getSymbolInCurrentScope("max");
             SgFunctionRefExp * minExp = new SgFunctionRefExp (*minSym);
             SgFunctionRefExp * maxExp = new SgFunctionRefExp (*maxSym);
             tmpExp= & ( (* TOTAL_SIZE) / (* PT[i+1]) );
             tmpExp=calculateExp(tmpExp);
             minExp->addArg(*tmpExp);
             minExp->addArg(* ITE_NUM[i]);
             size[i]=minExp;
             SgSymbol * tileSym= s->getSymbolInCurrentScope(mixstring,"ST",NULL,i);
             SgExpression * tileExp=new SgVarRefExp(*tileSym);
             size[i]=calculateExp(size[i]);
             maxExp->addArg(* size[i]);
             maxExp->addArg(* new SgValueExp(1));
             size[i]=maxExp;
             SgAssignStmt * assignStmt = new SgAssignStmt(*tileExp->copyPtr(), *size[i]->copyPtr());
             out_loop_stmt->insertStmtBefore(*assignStmt,*out_loop_stmt->controlParent());
             size[i]=tileExp;
             PT[i]= &((*PT[i+1]) * (*size[i]));
        }  
        transStmt=forall_loopTiling(func,s,size,numofloop);
	ASSERT(transStmt);
/*
        if (transStmt!=NULL)
             printf("Loop from FORALL has been Tiled successfully!\n");
*/
        break;
   
      }//end of case  FOR_NODE   
 }    
return(transStmt);

}

//add by huang
void array2stack(SgStatement * s,SgExpression * oldExp,int i){
	SgSymbol * arraySym=oldExp->symbol();
        SgSymbol * memsym;
        SgArrayRefExp * memExp;
        SgSymbol * indexsym;
        SgVarRefExp * indexexp;
#ifdef MEM_ALLOC
 	       memsym= s->getSymbolInCurrentScope(stackNameOfType(arraySym->type()),"mb", NULL);
#else
               memsym=s->getSymbolInCurrentScope(allocNameOfType(arraySym->type()));
#endif
        SgVariableSymb  *array_name=(SgVariableSymb *)memsym;
        memExp=new SgArrayRefExp (*array_name);
        indexsym=s->getSymbolInCurrentScope(mixstring, "tbs",NULL,i);
        indexexp=new SgVarRefExp(indexsym);
	if(oldExp->variant()==ARRAY_REF){
		SgExpression * oldsub=((SgArrayRefExp *)oldExp)->subscript(0)->copyPtr();
        	memExp->setSubscripts(*(new SgExpression(EXPR_LIST,&(*indexexp+*oldsub),NULL,NULL)));
	}
	else{
        	memExp->setSubscripts(*(new SgExpression(EXPR_LIST,indexexp,NULL,NULL)));
	}
	oldExp->replace(*memExp);
}

void add_index_stmt(SgStatement *s,SgSymbol * arraySym,int i,SgStatement *insert_place){
        SgSymbol *dad=s->getSymbolInCurrentScope(mixstring, "dad",arraySym->identifier());
        SgSymbol *indexsym=s->getSymbolInCurrentScope(mixstring, "tbs",NULL,i);
        SgStatement *index_stmt = make_index(s, indexsym, dad,arraySym->type());
        insert_place->insertStmtBefore(*index_stmt, * insert_place->controlParent());
}
//add finished!


// calclate the stride expression in RHS
void calculate_Rhs_strideExp(SgStatement *s, SgStatement *outloopStmt, 
		 forall_reference *lhsfref, forall_reference *fref, int sameAsi)
{
	if (fref->sameAs != -1) return;
      	SgArrayRefExp *array = (SgArrayRefExp *) fref->getexpression();
      	SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
      	SgArrayType * arrayType=(SgArrayType *)arraySym->type();

	SgSymbol * lhsarraySym=(SgSymbol *) lhsfref->getarraysymbol();
	SgArrayType * lhsarrayType=(SgArrayType *)lhsarraySym->type();

	int j;
	int counterdim=0;
        switch ( fref->getCommunication() )
	{
	case UNKNOW:
          {
		int dimension = arrayType->dimension();
		if (is_out_of_core(lhsarraySym))
		for (j=0;j< dimension; j++)
                   // for each dimension calculate stride
                   // true branch  REMAP
		{    
                        if   (fref->scalarDim(j)==TRUE)
                        {
                            //printf("\n j=%d is scalar dim",j);
                            continue;
                        }
                        SgAssignStmt * strideAssignStmttrue=make_stride_assign_special(s,arraySym,"u",0,counterdim,j,sameAsi);
                        SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                        SgExpression * commExp= new SgVarRefExp(* commSym);
                        commExp =& (SgEqOp(*commExp ,*new SgValueExp(2)));
                        SgStatement *strideStmt = new SgIfStmt(*commExp,* strideAssignStmttrue );

                        outloopStmt->insertStmtBefore(*strideStmt, * outloopStmt->controlParent());
                        counterdim++;
		}// end of for each dimension calculate stride
        	// end of true branch

		counterdim=0;
		for (j=0;j< dimension; j++)
                   // for each dimension calculate stride
                   // false branch not REMAP
		{    
                        SgAssignStmt * strideAssignStmtfalse=make_stride_assign_special(s,arraySym,"u",sameAsi,counterdim,j,sameAsi);
                        SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                        SgExpression * commExp= new SgVarRefExp(* commSym);
                        commExp =& (SgNeqOp(*commExp ,*new SgValueExp(2)));
                        SgStatement *strideStmt=new SgIfStmt(*commExp,* strideAssignStmtfalse );

                        outloopStmt->insertStmtBefore(*strideStmt, * outloopStmt->controlParent());
                        counterdim++;
                }// end of for each dimension calculate stride
                // end of false branch
	  }
	  break;
	case REMAP:
	case IRREG:
	  {
              // not same reference,avoid duplicated assign 
              for (j=0;j<lhsarrayType->dimension(); j++)
              // for each dimension calculate stride
              {    
                   if  (lhsfref->scalarDim(j)==TRUE &&
		        fref->getCommunication()==REMAP )
                   {
                         //printf("\n j=%d is scalar dim",j);
                         continue;
                   }
		     // create stride statement according to communication
		   SgStatement *strideStmt = make_stride_assign_special(s,arraySym,"u",0,counterdim,j,sameAsi);

                   outloopStmt->insertStmtBefore(*strideStmt, * outloopStmt->controlParent());
                   counterdim++;
              }
	  }
	  break;
	default:
	  {
              // not same reference,avoid duplicated assign 
              for (j=0;j<arrayType->dimension(); j++)
              // for each dimension calculate stride
              {    
                   if (  (fref->scalarDim(j)==TRUE)
                       &&(  (fref->getCommunication()==BROADCAST_DIM)
                          ||(fref->getCommunication()==REMAP)))
                   {
                         //printf("\n j=%d is scalar dim",j);
                         continue;
                   }
		     // create stride statement according to communication
                   SgStatement *strideStmt = make_stride_assign_special(s,arraySym,"u",sameAsi,counterdim,j,sameAsi);
                   outloopStmt->insertStmtBefore(*strideStmt, * outloopStmt->controlParent());
                   counterdim++;
              }
	  }
	}  // end of switch
}

SgExpression *createIndexDimNumber(SgStatement *s, SgStatement *firstloop, forall_reference *fref, int counter, int dim)
{
  	SgStatement * body = s->childList1(0);
  	Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  	int index_num = fhdef->getindexnumber();

	SgExpression * numberExp = NULL ;
        // array subscript must contain current index
       	int looplevel=index_num-fref->indexNumberOnDim(dim);
                // looplevel's value from 1 to index_num
        if (looplevel==0)
        {  
		printf("\none index appear more than once in subscript, we can not deal with it now! ");
                exit(0);
        }
        numberExp = creat_read_num(firstloop,looplevel) ;
                // added by Zheng Gengbin
		// DO_PREFETCH
	if (prefetch_ok(body, counter))
	{
	     // number is the number of next tile
	   modify_number(s, numberExp, counter, fref->indexNumberOnDim(dim), looplevel-1);
	}
	ASSERT(numberExp);
	return numberExp;
}

void calculate_Rhs_numberExp(SgStatement *s, SgStatement *firstloop, 
		 forall_reference *lhsfref, forall_reference *fref, int counter, int sameAsi)
{
	if (fref->sameAs != -1) return;

  	SgStatement * body = s->childList1(0);
  	Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  	int index_num = fhdef->getindexnumber();

      	SgArrayRefExp *array = (SgArrayRefExp *) fref->getexpression();
      	SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
      	SgArrayType * arrayType=(SgArrayType *)arraySym->type();

	SgSymbol * lhsarraySym=(SgSymbol *) lhsfref->getarraysymbol();
	SgArrayType * lhsarrayType=(SgArrayType *)lhsarraySym->type();

	// begin calculate number for each dimension
	int j,k;
	int counterdim=0;
	switch (fref->getCommunication() )
	{
	case UNKNOW:
          {
		  // assume REMAP, if LHS is in_core, ignore
		if  (is_out_of_core(lhsarraySym))
                for (j=0;j<arrayType->dimension(); j++)
                   // when communication is REMAP
                {    
		   if    (fref->scalarDim(j)==TRUE)
                   {
                          //printf("\n j=%d is scalar dim",j);
                          continue;
                   }
		     // create number expression
                   SgExpression * numberExp = createIndexDimNumber(s, firstloop, fref, counter, j);

                     // to here we get the read number expr numberExp
                   SgAssignStmt * numberAssignStmt=make_number_assign(s,arraySym,numberExp,counterdim);

                   SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                   SgExpression * commExp= new SgVarRefExp(* commSym);
                   commExp =& (SgEqOp(*commExp ,*new SgValueExp(2)));
                   SgIfStmt* ifnumberAssignStmt=new SgIfStmt(*commExp,* numberAssignStmt);

		       // DO_PREFETCH
		   if (prefetch_ok(body, counter))
			  array->addAttribute(PREFETCH_NUM, ifnumberAssignStmt->copyPtr(), sizeof(ifnumberAssignStmt));

                   firstloop->insertStmtBefore(*ifnumberAssignStmt, * firstloop->controlParent());
                     
                   counterdim++;
		}

                counterdim=0;
                for (j=0;j<arrayType->dimension(); j++)
                   // when communication is not REMAP
                {    
                   int IndexAppear = 1 - fref->scalarDim(j);
                   SgExpression * numberExp ;
                   if (IndexAppear==TRUE)
                   	numberExp = createIndexDimNumber(s, firstloop, fref, counter, j);
                   else
                        numberExp =new SgValueExp(1);

                          // to here we get the read number expr numberExp
                   SgAssignStmt * numberAssignStmt=make_number_assign(s,arraySym,numberExp,counterdim);

                   SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                   SgExpression * commExp= new SgVarRefExp(* commSym);
                   commExp =& (SgNeqOp(*commExp ,*new SgValueExp(2)));
                   SgIfStmt* ifnumberAssignStmt=new SgIfStmt(*commExp,* numberAssignStmt);

		   // DO_PREFETCH
		   if (prefetch_ok(body, counter))
			array->addAttribute(PREFETCH_NUM, ifnumberAssignStmt->copyPtr(), sizeof(ifnumberAssignStmt));

                   firstloop->insertStmtBefore(*ifnumberAssignStmt, * firstloop->controlParent());
                     
                   counterdim++;
                }

	  }// end of calculate number for each dimension
	  break;
	case IRREG:
	  {
		for (j=0;j<lhsarrayType->dimension(); j++)
                 // for each dimension calculate number
		{    
                   int IndexAppear = 1 - lhsfref->scalarDim(j);
                   SgExpression * numberExp ;
                   if (IndexAppear==TRUE)
                   // array subscript contain current index
                   {
                         int looplevel=index_num-lhsfref->indexNumberOnDim(j);
                          // looplevel's value from 1 to index_num
                         if (looplevel==0)
                         {  printf("\none index appear more than once in subscript, we can not deal with it now! ");
                            exit(0);
                         }
                         numberExp = creat_read_num(firstloop,looplevel) ;
                         // get read number on current dimension
                   }// end of array subscript contain current index
                   else
                   // array subscript do not contain current index
                   {
                         numberExp =new SgValueExp(1);
                   }// end of array subscript do not contain current index
                   // to here we get the read number expr numberExp

                   SgAssignStmt * numberAssignStmt=make_number_assign(s,arraySym,numberExp,counterdim);
                   firstloop->insertStmtBefore(*numberAssignStmt, * firstloop->controlParent());
                   counterdim++;
		}// end of calculate number for each dimension
	  }
	  break;
	default:
	  { 
        	for (j=0;j<arrayType->dimension(); j++)
              	// for each dimension calculate number
        	{    
                   int IndexAppear = 1 - fref->scalarDim(j);
                   if (   (fref->scalarDim(j)==TRUE)
                       &&(  (fref->getCommunication()==BROADCAST_DIM)
                          ||(fref->getCommunication()==REMAP)))
                   {
                         //printf("\n j=%d is scalar dim",j);
                         continue;
                   }
                   SgExpression * numberExp ;
                   if (IndexAppear == TRUE)
                   	numberExp = createIndexDimNumber(s, firstloop, fref, counter, j);
                   else
                        numberExp =new SgValueExp(1);

                   // to here we get the read number expr numberExp

		     // add by Zheng Gengbin
		     // check if we already have one declared before.
/*
		   if (get_previous_number(s, numberExp) == 1) addNumberExp=FALSE;
		   if (addNumberExp == FALSE)
		   {
			counterdim++;
			continue;
		   }
*/
		   s->addAttribute(OC_READ_NUMBER, numberExp, sizeof(numberExp));

                   SgAssignStmt * numberAssignStmt = make_number_assign(s,arraySym,numberExp,counterdim);

                   firstloop->insertStmtBefore(*numberAssignStmt, *firstloop->controlParent());

		     // DO_PREFETCH
		   if (prefetch_ok(body, counter))
			array->addAttribute(PREFETCH_NUM, numberAssignStmt->copyPtr(), sizeof(numberAssignStmt));

                   counterdim++;
		}// end of calculate number for each dimension
	  }
	  break;
	} // end of switch
}

// insert oc_read
void insert_oc_read(SgStatement *s, SgStatement *firstloop, int counter, SgSymbol *dad, int sameAsi, 
		    SgExpression *memExp, SgExpression *startExp, 
		    SgSymbol *stridesym, SgSymbol *numbersym)
{
	// added by Zheng Gengbin
	// DO_PREFETCH , add pcrc_prefetch_wait & pcrc_oc_prefetch_read
  	SgStatement * body = s->childList1(0);
        forall_reference *fref = (forall_reference *) body->attributeValue(counter, Forall_Ref);
	SgArrayRefExp *array = (SgArrayRefExp *) fref->getexpression();

  	forall_reference *lhsfref = (forall_reference *) body->attributeValue(0, Forall_Ref);
  	SgSymbol * lhsarraySym=(SgSymbol *) lhsfref->getarraysymbol();

	SgStatement * ocreadStmt = NULL;
	SgStatement * waitStmt = NULL;
	if (prefetch_ok(body, counter))
	{
		  // modify pcrc_base; pcrc_base1 increase
		modify_mem_base(s, firstloop, dad, sameAsi);
		SgSymbol *mhSymb=s->getSymbolInCurrentScope(mixstring,"mh","fetch",sameAsi);
		waitStmt = make_prefetch_wait(s, mhSymb);
                ocreadStmt=make_oc_prefetch_read(s,mhSymb,dad,memExp,startExp,stridesym,numbersym);
		array->addAttribute(DO_PREFETCH, ocreadStmt, sizeof(ocreadStmt));
	 }
	 else
                ocreadStmt=make_oc_read(s,dad,memExp,startExp,stridesym,numbersym);

	if (  is_out_of_core(lhsarraySym) ==0  &&
              (fref->getCommunication()==UNKNOW))
        {
                SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                SgExpression * commExp= new SgVarRefExp(* commSym);
                commExp =& (SgNeqOp(*commExp ,*new SgValueExp(2)));
                SgIfStmt* ifReadStmt=new SgIfStmt(*commExp,* ocreadStmt);
                firstloop->insertStmtBefore(*ifReadStmt, * firstloop->controlParent());
		  // DO_PREFETCH
		if (waitStmt) 
                       ocreadStmt->insertStmtBefore(*waitStmt, * ocreadStmt->controlParent());
        }
        else {
		if (waitStmt)
                       firstloop->insertStmtBefore(*waitStmt, *firstloop->controlParent());
                firstloop->insertStmtBefore(*ocreadStmt, *firstloop->controlParent());
	}
        // end of insert pcrc_oc_read() statement 
        //     after the array assignment stmt
}

// generate temporary memory for array
void allocate_memory(SgStatement *s, SgStatement *outloopStmt, forall_reference *fref,
                     int counter, SgSymbol *dad)
{
	if (fref->sameAs!=-1) return;

	SgStatement * body = s->childList1(0);
	int sameAsi;
        if (fref->sameAs!=-1) sameAsi=fref->sameAs;
        else  sameAsi=counter;

      	SgArrayRefExp *array = (SgArrayRefExp *) fref->getexpression();
      	SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
      	SgArrayType * arrayType=(SgArrayType *)arraySym->type();

	 // decide if we need stack
	int need_stack = FALSE;
	int need_free_stack = TRUE;
        if ((  (first_appear_in_RHS(sameAsi,body)==FALSE)
                  &&(fref->getCommunication()!=REMAP)
                  &&(fref->getCommunication()!=BROADCAST_DIM)
                  //||(fref->getCommunication()==UNKNOW)
                  &&(fref->getCommunication()!=IRREG))
                  ||((not_conflict_with_lhs(s,counter)==FALSE)
                  &&(fref->getCommunication()!=REMAP)
                  &&(fref->getCommunication()!=BROADCAST_DIM)
                  &&(fref->getCommunication()!=IRREG)))
		need_stack = TRUE;
	else if (prefetch_ok(body, counter)) 	// DO_PREFETCH
		need_stack = TRUE;

	if (need_stack == FALSE) return;

          // use stack space as start memory position
          //    so if not remap communication , 
          //    we must first allocate 
          //    stack space for the in core array

          //  first generate the allocate space statement
          //    pcrc_tbs1=pcrc_real_stack_alloc(size,pcrc_mh1)
	SgType *type = (SgType *)arraySym->type();
	SgSymbol *mHandle;
	SgStatement * stackallocStmt;
	SgSymbol *tbssym;

	if ((fref->getCommunication()==UNKNOW))
        	tbssym=s->getSymbolInCurrentScope(mixstring,"stk_sdx",NULL,sameAsi);
        else
                tbssym=s->getSymbolInCurrentScope(mixstring,"tbs",NULL,sameAsi);

	   // DO_PREFETCH
	   // we need to alloc two of in core size to hold next tile
	if (prefetch_ok(body, counter)) {
		// in remap case, we have already allocate incore memory, so free it
		if (fref->getCommunication()==REMAP)
		{
			    // need to free the pre-allocated memory
                	SgSymbol * base; 
                        #ifdef MEM_ALLOC
                        base = s->getSymbolInCurrentScope(mixstring, "mh", NULL, sameAsi);
                        #else
                        base = s->getSymbolInCurrentScope(mixstring, "tbs", NULL, sameAsi);
                        #endif
                        SgStatement* free_stmt = make_free(s,array->type(),base);
                        outloopStmt->insertStmtBefore(*free_stmt, * outloopStmt->controlParent());
			need_free_stack = FALSE;
		}
		// allocate 2*incore memory
#ifdef MEM_ALLOC
		SgExpression *sizeexp = make_in_core_size(s, dad);
		sizeexp = &( *new SgValueExp(2) * *sizeexp );
                mHandle = s->getSymbolInCurrentScope(mixstring, "mh",NULL, sameAsi);
		stackallocStmt=make_stack_alloc_size(s,type,tbssym,sizeexp,mHandle);
#endif
	}
	else {
#ifdef MEM_ALLOC
                mHandle = s->getSymbolInCurrentScope(mixstring, "mh",NULL, sameAsi);
                stackallocStmt=make_stack_alloc(s,type,tbssym,dad,mHandle);
#else
                stackallocStmt=make_alloc(s,type,tbssym,dad);
#endif
	}
               // to here we have generate the statement
               //    pcrc_tbs1=pcrc_real_stack_alloc(size,pcrc_mh1)
               //  then we inster it before the outer loop
               //  insert this statement before out loop
	if (fref->getCommunication()==UNKNOW)
        {
                SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                SgExpression * commExp= new SgVarRefExp(* commSym);
                commExp =& (SgNeqOp(*commExp ,*new SgValueExp(2)));
                SgIfStmt *ifallocStmt=new SgIfStmt(*commExp,* stackallocStmt);
                outloopStmt->insertStmtBefore(*ifallocStmt, * outloopStmt->controlParent());
	}
	else
                outloopStmt->insertStmtBefore(*stackallocStmt, * outloopStmt->controlParent());

                //  following generate statement 
                //  call pcrc_stack_free(pcrc_mh1)
	if (need_free_stack == TRUE)
	{
		SgSymbol * base; 
                #ifdef MEM_ALLOC
		base = s->getSymbolInCurrentScope(mixstring, "mh", NULL, sameAsi);
                #else
		base = s->getSymbolInCurrentScope(mixstring, "tbs", NULL, sameAsi);
                #endif
                SgStatement* free_stmt = make_free(s,array->type(),base);
                //SgStatement* free_stmt = make_stack_free(s,mHandle);
                //  then insert this statement after out loop
                if (fref->getCommunication()==UNKNOW)
                {
                        SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                        SgExpression * commExp= new SgVarRefExp(* commSym);
                        commExp =& (SgNeqOp(*commExp ,*new SgValueExp(2)));
                        SgIfStmt *ifFreeStmt=new SgIfStmt(*commExp,* free_stmt);
                        outloopStmt->insertStmtAfter(*ifFreeStmt, * outloopStmt->controlParent());
		}else
                        outloopStmt->insertStmtAfter(*free_stmt, * outloopStmt->controlParent());
	} 
}

int oc_replace_insert(SgStatement *s,SgStatement *inner)
{

  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  SgStatement * body = s->childList1(0);
  forall_reference * fref ;
  SgArrayRefExp * array ;

  int index_num = fhdef->getindexnumber();

  SgStatement  *assignmaskStmt=get_forall_assign_stmt(index_num*2,inner);
  // if there is no mask ,assignmaskStmt==BodyAssignStmt,
  // if there is mask, assignmaskStmt is the IF statement, BodyAssignStmt
  // is the assignment statement. 
  SgStatement  *BodyAssignStmt=get_body_assign_stmt(index_num*2,inner);

  if (assignmaskStmt==NULL) 
  {   printf("\n null statement\n");
      exit(0);
  }
  
  //get the assignment statement which is transformed from 
  //      FORALL assignment statement 

  SgExpression * zeroExp = new SgValueExp(0);
  SgExpression * oneExp = new SgValueExp(1);


  SgStatement * firstloop = get_first_inner(index_num,inner);
  // firstloop is the outer DO LOOP transformed from FORALL
  if (firstloop==NULL) 
  {   printf("\n can not find first inner loop");
      exit(0);
  }
  // get the first loop statement in tiled loop 

  SgStatement * outloopStmt = get_out_loop_stmt(inner);
  // get the first statement in tiled loop

  int i,j,k,sameAsi,counterdim;
  
    // DO_PREFETCH
    // check if we can do prefetch on every array reference
  {
  check_prefetch(s);
  SgStatement *innerLoop = inner;
  if (isSgIfStmt(innerLoop)) innerLoop=innerLoop->childList1(0);
  get_next_loop_index(s, outloopStmt, firstloop, fhdef->getindexnumber()-1);
  }

    // added by Zheng Gengbin
    // DO_PREFETCH
    // modify sdx, so that pcrc_sdx will be the next tile
  modify_sdx(s);

  //printf("\nout of core num=%d",body->numberOfAttributes(INDEX_SDX));
  for (j=0;j<body->numberOfAttributes(INDEX_SDX); j++)
  {
     SgStatement  *indexStmt = (SgStatement *)body->attributeValue(j,INDEX_SDX);
     change_to_tiled_index(s,indexStmt);
     //change index expression such as
     // pcrc_sdx0=i*pcrc_u00+pcrcv00+j*pcrc_u01+pcrc_v01 
     //     to
     // pcrc_sdx0=pcrc_T_i*pcrc_u00+pcrcv00+pcrc_T_j*pcrc_u01+pcrc_v01

     firstloop->insertStmtBefore(*indexStmt, * firstloop->controlParent());
     // insert the start position statement which get the first position in
     // this tile loop

  }

  {     // if has out of core array ,insert pcrc_oci0=0 and 
	//                                  pcrc_oci0=pcrc_oci0+1
        //

        SgSymbol * ocisym = s->getSymbolInCurrentScope(mixstring, "oci", NULL, 0);
        SgExpression * ociExp = new SgVarRefExp(*ocisym);
        //SgExpression * zeroExp = new SgValueExp(0);
        SgAssignStmt * assignStmt = new SgAssignStmt(*ociExp, *zeroExp->copyPtr());

        // insert before the inner loop statement
        firstloop->insertStmtBefore(*assignStmt, * firstloop->controlParent());

        // insert pcrc_oci0=pcrc_oci0+1 after the array assignment stmt
        SgExpression * incociExp = new SgValueExp(1);
        ( incociExp )=&((*ociExp)+(* incociExp )) ;
        SgAssignStmt * incStmt= new SgAssignStmt(*ociExp, *incociExp);
        assignmaskStmt->insertStmtAfter(*incStmt, * assignmaskStmt->controlParent());
  }

  forall_reference *lhsfref = (forall_reference *) body->attributeValue(0, Forall_Ref);
  SgArrayRefExp *lhsarray = (SgArrayRefExp *) lhsfref->getexpression();
  SgSymbol * lhsarraySym=(SgSymbol *) lhsfref->getarraysymbol();
  SgArrayType * lhsarrayType=(SgArrayType *)lhsarraySym->type();

  for (i=0; i<body->numberOfAttributes(Forall_Ref); i++) 
  {
      fref = (forall_reference *) body->attributeValue(i, Forall_Ref);
      if (fref->sameAs!=-1) sameAsi=fref->sameAs;
      else  sameAsi=i;
      if ( fref->getexpression()->variant() != ARRAY_REF ) continue;
      array = (SgArrayRefExp *) fref->getexpression();
      SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
      SgArrayType * arrayType=(SgArrayType *)arraySym->type();

	// by Zheng Gengbin
        // if not perform runtime communication-detection optimization
        // treate UNKNOW as REMAP here.
      if ((opt_strategy & RUNTIMECOMM) == 0)
      {
	if (fref->getCommunication() == UNKNOW)
	  fref->setCommunication(REMAP);
      }

      // if the loop index variable does not appear in array reference,
      //       do nothing
      int IndexAppearFlag=FALSE;
      for (j=0;j<arrayType->dimension(); j++)
      // for each dimension calculate number
      {    
           for (k=0;k<index_num;k++)
           {      
                  if (fref->getIndex(j,k) >=1)
                  {  IndexAppearFlag=TRUE;
                      break;
                  }
           }
           if (IndexAppearFlag==TRUE) break;
     }
     if (IndexAppearFlag==FALSE) continue;
     // need not deal with an out of core element such as A(2,3)

      if (  is_out_of_core(arraySym) ||
            (fref->getexpression()->numberOfAttributes(Outofcore_Def) >0))
      // deal with out of core array
      {  

         if (i==0) // LHS is out of core array
         {
              int dealWithIrregular=FALSE;
              if (fref->getexpression()->numberOfAttributes(Outofcore_Def) >0)
              dealWithIrregular=TRUE;

             // replace  A(pcrc_sdx0)  with
             //          A(pcrc_oci0)
             // first generate array name 
             if (dealWithIrregular==FALSE) 
             {
                 SgArrayRefExp* newExp= new SgArrayRefExp(*arraySym);
                 SgSymbol * sdxsym=s->getSymbolInCurrentScope(mixstring,"oci",NULL,0);
                 SgExpression * sdxExp=new SgVarRefExp(*sdxsym);
                 newExp->addSubscript(*sdxExp);
                 SgArrayRefExp * oldExp=(SgArrayRefExp *)get_LHS(assignmaskStmt);
                 //SgArrayRefExp * oldExp=(SgArrayRefExp*)fref->getexpression();
                 oldExp->replace(* newExp); 
//add by huang
		 if(unknown_address(arraySym)) 
		 	array2stack(s,oldExp,sameAsi);
//add finished! 
             }
             else
             {   
                 SgArrayRefExp* newExp= new SgArrayRefExp(*array->symbol());
                 SgSymbol * sdxsym=s->getSymbolInCurrentScope(mixstring,"oci",NULL,0);
                 SgExpression * sdxExp=new SgVarRefExp(*sdxsym);
                 newExp->addSubscript(*array->lhs()->lhs()->lhs()->copyPtr()+*sdxExp);
                 //newExp->addSubscript(*sdxExp);
                 SgArrayRefExp * oldExp=(SgArrayRefExp *)get_LHS(assignmaskStmt);
                 //SgArrayRefExp * oldExp=(SgArrayRefExp *)fref->getexpression();
                 //SgArrayRefExp * oldExp=(SgArrayRefExp*)fref->getexpression();

                 oldExp->replace(* newExp);
             }

              // insert pcrc_oc_write() statement after the 
              //     array assignment stmt
              //array = (SgArrayRefExp *) fref->getexpression();
             if (dealWithIrregular==FALSE)
             {

		     // ??????????????
                   SgSymbol *dad=s->getSymbolInCurrentScope(mixstring, "sdd",NULL,0);
                   //SgSymbol *dad=s->getSymbolInCurrentScope(mixstring, "dad",arraySym->identifier());
                   SgSymbol * memsym=s->getSymbolInCurrentScope(arraySym->identifier());
                   SgExpression * memExp = new SgVarRefExp(*memsym);
                   SgSymbol * stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraySym->identifier(),sameAsi);
                   SgSymbol * numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraySym->identifier());
                   SgSymbol * startsym=s->getSymbolInCurrentScope(mixstring,"sdx",NULL,sameAsi);
                   SgExpression * startExp = new SgVarRefExp(*startsym);
//add by huang
		   if(unknown_address(arraySym))
		      array2stack(s,memExp,sameAsi);
//add finished!
                   SgStatement * ocwriteStmt=make_oc_write(s,dad,memExp,startExp,stridesym,numbersym);
                   firstloop->insertStmtAfter(*ocwriteStmt, * firstloop->controlParent());
              }
              else
              {
                   SgSymbol *dad=(SgSymbol *)fref->getexpression()->attributeValue(0,Outofcore_Def);
                   //SgSymbol *dad=fref->getexpression()->attributeValue(0,Outofcore_Def)->copyPtr();
                   SgSymbol * memsym=s->getSymbolInCurrentScope(array->symbol()->identifier());
                   SgArrayRefExp *  memExp = new SgArrayRefExp(*memsym);
                   memExp->addSubscript(*array->lhs()->lhs()->lhs()->copyPtr());
                   SgSymbol * stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraySym->identifier(),sameAsi);
                   SgSymbol * numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraySym->identifier());
                   SgSymbol * startsym=s->getSymbolInCurrentScope(mixstring,"sdx",NULL,0);
                   SgExpression * startExp = new SgVarRefExp(*startsym);
                   SgStatement * ocwriteStmt=make_oc_write(s,dad,memExp,startExp,stridesym,numbersym);
                   firstloop->insertStmtAfter(*ocwriteStmt, * firstloop->controlParent());

              }
              // end of insert pcrc_oc_write() statement after the array assignment stmt


              // insert   pcrc_oc_stride_a(1)=...
              //          pcrc_oc_stride_a(2)=...
              //          pcrc_oc_number_a(1)=...
              //          pcrc_oc_number_a(2)=...
              // before   pcrc_oc_write() statement
              counterdim=0;
              //for (j=arrayType->dimension()-1;j>=0; j--)
              for (j=0;j<arrayType->dimension(); j++)
              // for each dimension calculate stride 
              {
                       if (  (fref->scalarDim(j)==TRUE))
                       {
                           //printf("\n j=%d is scalar dim",j);
                           continue;
                       }

                       SgAssignStmt * strideAssignStmt=make_stride_assign_special(s,arraySym,"u",sameAsi,counterdim,j,sameAsi);
                       //SgAssignStmt * strideAssignStmt=make_stride_assign(s,arraySym,"u",sameAsi,counterdim);
                       outloopStmt->insertStmtBefore(*strideAssignStmt, * outloopStmt->controlParent());
                       counterdim++;
              }// end of for each dimension calculate stride


              counterdim=0;
              //for (j=arrayType->dimension()-1;j>=0; j--)
              for (j=0;j<arrayType->dimension(); j++)
              // for each dimension calculate number
              {    
                   if (   (fref->scalarDim(j)==TRUE))
                   {
                         //printf("\n j=%d is scalar dim",j);
                         continue;
                   }
                   int IndexAppear=FALSE;
                   for (k=0;k<index_num;k++)
                   {      if (fref->getIndex(j,k) >=1)
                          IndexAppear=TRUE;
                   }
                   SgExpression * numberExp ;
                   if (IndexAppear==TRUE)
                   // array subscript contain current index
                   {
                         int looplevel=index_num-fref->indexNumberOnDim(j);
                         numberExp = creat_read_num(firstloop,looplevel) ;
                   }// end of array subscript contain current index
                   else
                   // array subscript do not contain current index
                   {
                         numberExp =new SgValueExp(1);

                   }// end of array subscript do not contain current index

                   SgAssignStmt * numberAssignStmt=make_number_assign(s,arraySym,numberExp,counterdim);
                   firstloop->insertStmtAfter(*numberAssignStmt, * firstloop->controlParent());
                   counterdim++;
              }// end of calculate number for each dimension

//add by huang
	      if(unknown_address(arraySym))
		   add_index_stmt(s,arraySym,i,outloopStmt);
//add finished!

              if ( fhdef->getcondition() != NULL)
              //for MASK expression we need first read data
              {
              counterdim=0;
              //for (j=arrayType->dimension()-1;j>=0; j--)
              for (j=0;j<arrayType->dimension(); j++)
              // for each dimension calculate number
              {    
                   if (   (fref->scalarDim(j)==TRUE))
                   {
                         //printf("\n j=%d is scalar dim",j);
                         continue;
                   }
                   int IndexAppear=FALSE;
                   for (k=0;k<index_num;k++)
                   {      if (fref->getIndex(j,k) >=1)
                          IndexAppear=TRUE;
                   }
                   SgExpression * numberExp ;
                   if (IndexAppear==TRUE)
                   // array subscript contain current index
                   {
                         int looplevel=index_num-fref->indexNumberOnDim(j);
                         numberExp = creat_read_num(firstloop,looplevel) ;

                   }// end of array subscript contain current index
                   else
                   // array subscript do not contain current index
                   {
                         numberExp =new SgValueExp(1);

                   }// end of array subscript do not contain current index

                   SgAssignStmt * numberAssignStmt=make_number_assign(s,arraySym,numberExp,counterdim);
                   firstloop->insertStmtBefore(*numberAssignStmt, * firstloop->controlParent());
                   counterdim++;
              }
                   // to here insert pcrc_oc_number_A(j)=...

             if (dealWithIrregular==FALSE)
             {

                   //SgSymbol *dad=s->getSymbolInCurrentScope(mixstring, "dad",arraySym->identifier());
                   SgSymbol *dad=s->getSymbolInCurrentScope(mixstring, "sdd",NULL,0);
                   SgSymbol * memsym=s->getSymbolInCurrentScope(arraySym->identifier());
                   SgExpression * memExp = new SgVarRefExp(*memsym);
                   SgSymbol * stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraySym->identifier(),sameAsi);
                   SgSymbol * numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraySym->identifier());
                   SgSymbol * startsym=s->getSymbolInCurrentScope(mixstring,"sdx",NULL,sameAsi);
                   SgExpression * startExp = new SgVarRefExp(*startsym);
//add by huang
	      	   if(unknown_address(arraySym))
			array2stack(s,memExp,sameAsi);
//add finished!
		   SgStatement * ocReadStmt=make_oc_read(s,dad,memExp,startExp,stridesym,numbersym);
                   firstloop->insertStmtBefore(*ocReadStmt, * firstloop->controlParent());
              }
              else
              {
                   SgSymbol *dad=(SgSymbol *)fref->getexpression()->attributeValue(0,Outofcore_Def);
                   //SgSymbol *dad=fref->getexpression()->attributeValue(0,Outofcore_Def)->copyPtr();
                   SgSymbol * memsym=s->getSymbolInCurrentScope(array->symbol()->identifier());
                   SgArrayRefExp *  memExp = new SgArrayRefExp(*memsym);
                   memExp->addSubscript(*array->lhs()->lhs()->lhs()->copyPtr());
                   SgSymbol * stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraySym->identifier(),sameAsi);
                   SgSymbol * numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraySym->identifier());
                   SgSymbol * startsym=s->getSymbolInCurrentScope(mixstring,"sdx",NULL,0);
                   SgExpression * startExp = new SgVarRefExp(*startsym);
                   SgStatement * ocReadStmt=make_oc_read(s,dad,memExp,startExp,stridesym,numbersym);
                   firstloop->insertStmtBefore(*ocReadStmt, * firstloop->controlParent());

              }

              }// end of MASK expression 

         }//end of deal with LHS out of core array

////////////////////////// RHS or MASK out of core array //////////////////////
	 else
         {
	      int useArrayName = FALSE;
              int useStack=FALSE;
              int keepOneIndex=FALSE;

	        // ignore these cases
              if ( (is_out_of_core(lhsarraySym) ==0)
                  &&(  (fref->getCommunication()==REMAP)
                     ||(fref->getCommunication()==IRREG)))
              continue;

//              if ( (is_out_of_core(arraySym) ==0)) continue;

		// optimize
      	        // when LHS is out_of_core array and dimension is 1, we can assume it to be incore.
      	      int treate_lhs_as_in_core = 0;
	      if (array->numberOfAttributes(SET_INCORE) > 0)
      	      {
		   if (fref->getCommunication()==BROADCAST_DIM) continue;
		   if (fref->getCommunication()==REMAP) continue;
		   treate_lhs_as_in_core = 1;
		   lhsarraySym->deleteAllAttribute(Outofcore_Def);
      	      }

              // insert   pcrc_oc_stride_a(1)=...
              //          pcrc_oc_stride_a(2)=...
              //          pcrc_oc_number_a(1)=...
              //          pcrc_oc_number_a(2)=...
              // before   pcrc_oc_read() statement

	      // begin calculate STRIDE for each dimension
	      {
	      calculate_Rhs_strideExp(s, outloopStmt, lhsfref, fref, sameAsi);
              }// end of for each dimension calculate stride


              // begin calculate NUMBER for each dimension
	      {
              calculate_Rhs_numberExp(s, firstloop, lhsfref, fref, i, sameAsi);
              }// end of calculate number for each dimension


              // insert pcrc_oc_read() statement before the 
              //     array assignment stmt
              SgSymbol *dad;
              if (fref->sameAs==-1)
              {   
		  if ((fref->getCommunication()==REMAP)
                   ||(fref->getCommunication()==BROADCAST_DIM)
                   ||(fref->getCommunication()==UNKNOW)
                   ||(fref->getCommunication()==IRREG))
                    dad=s->getSymbolInCurrentScope(mixstring, "tdd",NULL,sameAsi);
                  else
                    dad=s->getSymbolInCurrentScope(mixstring, "dad",arraySym->identifier());
                   
                  SgExpression * memExp=NULL; 
                  SgSymbol * tbssym;
                  if (  (first_appear_in_RHS(sameAsi,body)==TRUE)
                      &&(not_conflict_with_lhs(s,i)==TRUE)
		      &&(prefetch_ok(body, i) == 0)		// added by Zheng Gengbin
                      &&(fref->getCommunication()!=REMAP)
                      &&(fref->getCommunication()!=BROADCAST_DIM)
                      &&(fref->getCommunication()!=UNKNOW)
                      &&(fref->getCommunication()!=IRREG))
                       // direct use array name as start memory position
                  {    
		       SgSymbol * memsym=s->getSymbolInCurrentScope(arraySym->identifier());
                       memExp = new SgVarRefExp(*memsym);
// Zheng
		       if(unknown_address(arraySym))
		       {
			useArrayName = TRUE;
		   	array2stack(s,memExp,sameAsi);
		       }
                  }
                  else
                  // use stack space as start memory position
                  {    
                       if ((fref->getCommunication()==UNKNOW))
                         tbssym=s->getSymbolInCurrentScope(mixstring,"stk_sdx",NULL,sameAsi);
                       else
                         tbssym=s->getSymbolInCurrentScope(mixstring,"tbs",NULL,sameAsi);
                       SgExpression *tbsExp = new SgVarRefExp(*tbssym);
			 // DO_PREFETCH
		       if ( prefetch_ok(body, i) )
		       {
			SgSymbol *baseSymb = s->getSymbolInCurrentScope(mixstring, "base", NULL, 1);
			SgExpression *baseExp = new SgVarRefExp(baseSymb);
			tbsExp = &(*baseExp + *tbsExp);
		       }

                       SgSymbol * stacksym;
                       #ifdef MEM_ALLOC
                       stacksym= s->getSymbolInCurrentScope(stackNameOfType(array->type()),"mb", NULL);
                       #else
                       stacksym=s->getSymbolInCurrentScope(allocNameOfType(array->type()));
                       #endif
                       SgVariableSymb  *array_name=(SgVariableSymb *)stacksym;
                       SgArrayRefExp * aryExp=new SgArrayRefExp (*array_name);
                       aryExp->addSubscript(*tbsExp);
                       memExp = (SgExpression * )aryExp ;
                  }
                  // to here we get the memory expr to read out of core data

                  SgSymbol * stridesym, * numbersym;
                  stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraySym->identifier(),sameAsi);
                  numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraySym->identifier());
                  SgSymbol * startsym;
                  if (  (fref->getCommunication()==REMAP)
                      ||(fref->getCommunication()==IRREG))
                     //  ||(fref->getCommunication()==UNKNOW))
                     startsym=s->getSymbolInCurrentScope(mixstring,"sdx",NULL,0);
                  else
                     startsym=s->getSymbolInCurrentScope(mixstring,"sdx",NULL,sameAsi);
                  SgExpression * startExp = new SgVarRefExp(*startsym);

		    // insert oc_read()
		  insert_oc_read(s, firstloop, i, dad, sameAsi, memExp, startExp, stridesym, numbersym);
              }
              // end of insert pcrc_oc_read() statement 
              //     after the array assignment stmt


              // allocate memory for the out of core array 
              //   and then free it,first 
              //   pcrc_tbs1=pcrc_real_stack_alloc(size,pcrc_mh1)
              //   
	      allocate_memory(s, outloopStmt, fref, i, dad);

              // replace array reference suce as 
              //           B(pcrc_sdxi) with
              //           real_mb(pcrc_tbsi+pcrc_sdxi)
              {   
                       // first generate array name or stack name
	      SgSymbol * newIndexSym,* oldIndexSym;
              SgExpression * newIndexExp,*oldIndexExp;
              SgSymbol * newArySym,* oldArySym;
              SgArrayRefExp * newAryExp,* oldAryExp;

              if (  (first_appear_in_RHS(sameAsi,body)==TRUE)
                     &&(not_conflict_with_lhs(s,i)==TRUE)
		     &&(prefetch_ok(body, i) == 0)
                     &&(fref->getCommunication()!=REMAP)
                     &&(fref->getCommunication()!=BROADCAST_DIM)
                     &&(fref->getCommunication()!=UNKNOW)
                     &&(fref->getCommunication()!=IRREG))
                     //  we can use array name instand of stack name 
              {
		  newAryExp= new SgArrayRefExp(*arraySym);
// Zheng
		  useArrayName = TRUE;
              }
	      else 
	      {
	          useArrayName = FALSE;
                  #ifdef MEM_ALLOC
                  newArySym= s->getSymbolInCurrentScope(stackNameOfType(array->type()), "mb",NULL);
                  #else
                  newArySym= s->getSymbolInCurrentScope(mixstring, stackNameOfType(array->type()), NULL);
                  #endif
                  newAryExp= new SgArrayRefExp(*newArySym);
                  useStack=TRUE;
              }// to here we get the new array reference name

              // then  generate new index name
              keepOneIndex=FALSE;
              if (index_num<=arrayType->dimension())
              {
              	int l;
                for (l=0;l<index_num;l++)
                {   
			if( index_appear_in_array(l, fref, arrayType)==FALSE)
                                break;
                }
                if (l>=index_num) keepOneIndex=TRUE;
              }
              if (fref->getCommunication()==IRREG)  keepOneIndex=TRUE;

              if (keepOneIndex==TRUE)
              	newIndexSym=s->getSymbolInCurrentScope(mixstring,"oci",NULL,0);
              else
                newIndexSym=s->getSymbolInCurrentScope(mixstring,"oci",NULL,sameAsi);
              newIndexExp=new SgVarRefExp(*newIndexSym);
              if (useStack==TRUE)
              {
              	  SgSymbol * tbssym;
                  if ((fref->getCommunication()==UNKNOW))
                       tbssym=s->getSymbolInCurrentScope(mixstring,"stk_sdx",NULL,sameAsi);
                  else
                       tbssym=s->getSymbolInCurrentScope(mixstring,"tbs",NULL,sameAsi);
                  SgExpression * baseExp=new SgVarRefExp(*tbssym);
		  SgExpression *subscript = &((*baseExp)+(*newIndexExp));
		     // DO_PREFETCH
		  if (prefetch_ok(body, i))
		  {
				SgSymbol *baseSym0=s->getSymbolInCurrentScope(mixstring,"base",NULL,0);
				SgExpression *baseexp = new SgVarRefExp(baseSym0);
				subscript = &( *subscript + *baseexp );
		  }
                  newAryExp->addSubscript( *subscript);
              }
	      else
                  newAryExp->addSubscript(*newIndexExp);
// Zheng
	      if(useArrayName == TRUE && 
			 unknown_address(arraySym) )
	      {
		  array2stack(s,newAryExp,sameAsi);
	      }
              SgExpression * oldExp,*newExp;
              //oldExp=(SgExpression *)oldAryExp;
              newExp=(SgExpression *)newAryExp;
              oldExp=fref->getexpression();
              //oldExp->replace(*newExp);
              int returnval=TRUE;

              if (  (!is_out_of_core(lhsarraySym))
                          &&(fref->getCommunication()==UNKNOW))
              {
                    SgSymbol* commSym=s->getSymbolInCurrentScope(mixstring, "comm",NULL,sameAsi);
                    SgExpression * commExp= new SgVarRefExp(* commSym);
                    commExp =& (SgNeqOp(*commExp ,*new SgValueExp(2)));
                    SgSymbol* sdxSym=s->getSymbolInCurrentScope(mixstring, "sdx",NULL,sameAsi);
                    SgSymbol* ociSym=s->getSymbolInCurrentScope(mixstring, "oci",NULL,0);
                    SgExpression * sdxExp= new SgVarRefExp(* sdxSym);
                    SgExpression * ociExp= new SgVarRefExp(* ociSym);
                    SgAssignStmt * assignStmt = new SgAssignStmt(*sdxExp, *ociExp);
                    SgIfStmt* ifAssignStmt=new SgIfStmt(*commExp,* assignStmt);
                    BodyAssignStmt->insertStmtBefore(*ifAssignStmt, * BodyAssignStmt->controlParent());
			    // if treat LHS as in_core
	      	    if (array->numberOfAttributes(SET_INCORE) > 0)
		    {
                          SgExpression * commExp= new SgVarRefExp(* commSym);
                          commExp =& (SgEqOp(*commExp ,*new SgValueExp(2)));
                          SgExpression * sdxExp= new SgVarRefExp(* sdxSym);
                          SgSymbol* sdxSym2=s->getSymbolInCurrentScope(mixstring, "sdx",NULL,body->numberOfAttributes(Forall_Ref));
                          SgExpression * ociExp= new SgVarRefExp(* sdxSym2);
                          SgAssignStmt * assignStmt = new SgAssignStmt(*sdxExp, *ociExp);
                          SgIfStmt* ifAssignStmt=new SgIfStmt(*commExp,* assignStmt);
                          BodyAssignStmt->insertStmtBefore(*ifAssignStmt, * BodyAssignStmt->controlParent());
		     }
              }
              else
                     returnval=replace_exp_with_exp(assignmaskStmt,oldExp,newExp);
              if (returnval==FALSE) 
              printf("\n 1.Can not find duplicated expr.\n");

              }// end of array reference replacement 

// Zheng
	      if( useArrayName == TRUE && unknown_address(arraySym) ) 
		   add_index_stmt(s,arraySym,i,outloopStmt);

              if (  (keepOneIndex==FALSE)
                  &&(fref->sameAs==-1))
              // introduce new out of core array index
              {

                     // before of insert 
                     //          pcrc_ocii=pcrc_ocii+1 
                     // after the array assignment or loop stmt
                     SgExpression * incociExp = new SgValueExp(1);
                     SgSymbol * newsym = s->getSymbolInCurrentScope(mixstring, "oci", NULL, sameAsi);
                     SgExpression * ociExp = new SgVarRefExp(*newsym);
                     incociExp = &((*ociExp)+(* incociExp )) ;
                     SgAssignStmt * incStmt= new SgAssignStmt(*ociExp, *incociExp);
                     SgStatement * loopStmt=assignmaskStmt;
                     for (k=0;k<index_num;k++)
                     {
                         if( index_appear_in_array(k, fref, arrayType))
                         {
                             loopStmt->insertStmtAfter( *incStmt, * loopStmt->controlParent());
                             break;
                         } 
                         else
                              loopStmt=loopStmt->controlParent();
                     }
                     // end  of insert 
                     //          pcrc_ocii=pcrc_ocii+1 
                     // after the array assignment or loop stmt


                     //  insert 
                     //         pcrc_ocii=pcrc_ocii-pcrc_sum_ocii 
                     //         pcrc_tmp_ocii =pcrc_ocii
                     //  to the first position of the found loop and insert
                     //         pcrc_sum_ocii=pcrc_ocii-pcrc_tmp_ocii and 
                     //  after the found loop
                     SgAssignStmt * assiStmt;
                     if ((k==index_num-1))
                     {
                              assiStmt= new SgAssignStmt(*ociExp->copyPtr(), *zeroExp->copyPtr());
                              firstloop->insertStmtBefore(*assiStmt, * firstloop->controlParent());
                     } else
                     if (index_num<=arrayType->dimension())
                     {   
                         int l;
                         for (l=0;l<index_num;l++)
                         {   if( index_appear_in_array(l, fref, arrayType)==FALSE)
                             break;
                         }
                         if (l>=index_num)
                         {
                              assiStmt= new SgAssignStmt(*ociExp->copyPtr(), *zeroExp->copyPtr());
                              firstloop->insertStmtBefore(*assiStmt, * firstloop->controlParent());
                              continue;
                         }
                     }
                     {
                              assiStmt= new SgAssignStmt(*ociExp->copyPtr(), *zeroExp->copyPtr());
                              firstloop->insertStmtBefore(*assiStmt, * firstloop->controlParent());
                     }
                     for (k=k+1;k<index_num;k++)
                     {
                         loopStmt=loopStmt->controlParent();
                         if (  (index_appear_in_array(k, fref, arrayType)==FALSE)
                             &&(k==index_num-1))
                         // need not to keep pcrc_ocii's value after loop end
                         {
                              assiStmt= new SgAssignStmt(*ociExp->copyPtr(), *zeroExp->copyPtr());
                              loopStmt->insertStmtBefore(*assiStmt, * loopStmt->controlParent());
                              continue;
                         }
                         if (index_appear_in_array(k, fref, arrayType)==FALSE)
                         // need to keep pcrc_ocii's value after loop end
                         // and restore it before next loop
                         {
                              // insert pcrc_ocii=pcrc_tmp_ocii before enter the
                              // inner loop
                              SgSymbol * tmpocisym ;
                              SgSymbol * sumocisym ;
                              {   
                                 tmpocisym = s->getSymbolInCurrentScope( mixstring, "tmp_oci", NULL,i,k);
                                 sumocisym = s->getSymbolInCurrentScope( mixstring, "sum_oci", NULL,i,k);
                              } 
                              SgExpression * tmpociExp = new SgVarRefExp(*tmpocisym);
                              SgExpression * sumociExp = new SgVarRefExp(*sumocisym);
                              assiStmt= new SgAssignStmt( *ociExp->copyPtr(), *ociExp->copyPtr()-*sumociExp->copyPtr());
                              //     pcrc_ocii=pcrc_ocii-pcrc_sum_ocii
                              loopStmt->insertStmtBefore(*assiStmt, * loopStmt->controlParent());
                              assiStmt= new SgAssignStmt( *tmpociExp->copyPtr(), *ociExp->copyPtr());
                              //     pcrc_tmp_ocii=pcrc_ocii
                              loopStmt->insertStmtBefore(*assiStmt, * loopStmt->controlParent());
                              //  insert 
                              //      pcrc_sum_oci=0 
                              //  before  loop
                              assiStmt= new SgAssignStmt(*sumociExp->copyPtr(), *zeroExp->copyPtr());
                              firstloop->insertStmtBefore(*assiStmt, * firstloop->controlParent());

                              //     pcrc_sum_ocii=pcrc_ocii-pcrc_tmp_ocii
                              assiStmt= new SgAssignStmt(*sumociExp->copyPtr(), *ociExp->copyPtr()-*tmpociExp->copyPtr());
                              loopStmt->insertStmtAfter(*assiStmt, * loopStmt->controlParent());
                              if ( (k<index_num-1))
                                  //&& FALSE)
                              //     insert 
                              //        pcrc_tmp_ocii=pcrc_ocii
                              //     after loop
                              {
                                 assiStmt= new SgAssignStmt(*sumociExp->copyPtr(), *zeroExp->copyPtr());
                                 //assiStmt= new SgAssignStmt(*tmpociExp->copyPtr(), *ociExp->copyPtr());
                                 loopStmt->controlParent()->insertStmtAfter( * assiStmt, * loopStmt->controlParent()->controlParent());
                              }
                         }// end of keep and restore index value
                     }// deal with index in outer loop 
              }// end of introduce new out of core array index

      // recover LHS's outofcore attributes
      if (treate_lhs_as_in_core == 1)
      {
 	lhsarraySym->addAttribute(Outofcore_Def, NULL, 0);
      }


         }//end of RHS or MASK out of core array

      }//end of out of core array reference 


  }// end of every forall_reference in body

    // DO_PREFETCH
    // insert statements outside do loop to perform first prefetch_read
  add_first_prefetch_read(s, outloopStmt);

    // optimization to combine all the same condition if statements as one IF
  combine_same_if(inner);

//  printf("transform OUT OF CORE ARRAY in FORALL  Successfully ! \n");
  if (!silentFlag)
  printf("out of core transformation(forall) performed. \n");

  return 1;

}// end of oc_replace_insert()

int trans_out_of_core(SgStatement *s,SgStatement *inner)
{    
     if (contain_out_of_core_array(s)==TRUE)
     {    
	  SgStatement * transStmt = loop_tile(inner);
          if (transStmt!=NULL)
          	oc_replace_insert(s,inner);
          else
                printf("\nCan not get tiled statement");
     }
     return 1;
}

int change_to_tiled_index(SgStatement * s ,SgStatement * indexStmt)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);

  for (int i=0; i<fhdef->getindexnumber(); i++) 
  {
      SgSymbol * oldsym=fhdef->getindexsymb(i);
      char newidentifier[20];
      //sprintf(newidentifier,"pcrc_T%s",oldsym->identifier());
      SgSymbol * newsym = s->getSymbolInCurrentScope(mixstring,"T",oldsym->identifier());
      indexStmt->replaceSymbBySymb(*oldsym,*newsym);
  }
  return 1;
}

SgStatement * get_first_inner(int index_num,SgStatement *inner)
{
      int i;
      SgStatement *firstloop=NULL;
      int org_numberOfChildren=inner->numberOfChildrenList1();
      //if ((org_numberOfChildren==0)&&(index_num>0)) return(NULL);
      //if (index_num<0) return(NULL);
      SgStatement * * children = new SgStatement * [org_numberOfChildren];
      /*if ((index_num==0)&&(inner->variant()==FOR_NODE))
      {   firstloop=inner;
          return(firstloop);
      }
      */
      for (i=0; i<org_numberOfChildren; i++)
        children[i]=inner->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
      {
          if (children[i]->variant()==FOR_NODE)
          {
/*
              if (index_num==1)
              {     firstloop=children[i]->childList1(0);
              }else
*/
              if (index_num==0)
              {     firstloop=children[i];
              }else
              {
                    //firstloop=get_first_inner(index_num-1,children[i]->childList1(0));
                    firstloop=get_first_inner(index_num-1,children[i]);
                    if (firstloop!=NULL) break;
              }
          }
          else
          if (children[i]->variant()==LOGIF_NODE)
          {
              firstloop=get_first_inner(index_num,children[i]);
              if (firstloop!=NULL) break;
          }
      }
      delete [ ] children;
      return (firstloop);
}

int contain_out_of_core_array(SgStatement *s)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  SgStatement * body = s->childList1(0);
  int out_of_core_num,i;
//=body->numberOfAttributes(INDEX_SDX);
//  return(out_of_core_num);

  for (i=0; i<body->numberOfAttributes(Forall_Ref); i++) 
  {
      forall_reference * fref = (forall_reference *) body->attributeValue(i, Forall_Ref);
      SgArrayRefExp *array = (SgArrayRefExp *) fref->getexpression();
      SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
      SgArrayType * arrayType=(SgArrayType *)arraySym->type();

      if (  (is_out_of_core(arraySym))
          ||(fref->getexpression()->numberOfAttributes(Outofcore_Def) >0))
      return(TRUE);
   }
   return(FALSE);
}

SgStatement  *get_forall_assign_stmt(int index_num,SgStatement  *inner)
{
      int i;

//      if (inner->variant()==FOR_NODE) index_num=index_num-1;
      SgStatement *assignmaskStmt=NULL;
      int org_numberOfChildren=inner->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
        children[i]=inner->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
      {
          if ((children[i]->variant()==ASSIGN_STAT)
              &&(index_num==0))
          {
              SgExpression * lhsExp=children[i]->expr(0);
              if (lhsExp->variant() == ARRAY_REF)
              {     assignmaskStmt=children[i];
                    break;
              }
          }
          if ((children[i]->variant()==LOGIF_NODE)
               &&(index_num==0))
          {
               assignmaskStmt=children[i];
               break;
          }  
          if (children[i]->variant()==FOR_NODE)
          {
              assignmaskStmt=get_forall_assign_stmt(index_num-1,children[i]);
          }
      }
/*
      if (assignmaskStmt->controlParent()->variant()==LOGIF_NODE)
      {  assignmaskStmt=assignmaskStmt->controlParent();
      } 
*/
      delete [ ] children;

      return (assignmaskStmt);
}

SgStatement  *get_body_assign_stmt(int index_num,SgStatement  *inner)
{
      int i;

      SgStatement *BodyAssignStmt=NULL;
      int org_numberOfChildren=inner->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
        children[i]=inner->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
      {
          if ((children[i]->variant()==ASSIGN_STAT)
              &&(index_num==0))
          {
              SgExpression * lhsExp=children[i]->expr(0);
              if (lhsExp->variant() == ARRAY_REF)
              {     BodyAssignStmt=children[i];
                    break;
              }
          }
          if ((children[i]->variant()==LOGIF_NODE)
               &&(index_num==0))
          {
                    BodyAssignStmt=get_forall_assign_stmt(index_num,children[i]);
                    break;
          }  
          if (children[i]->variant()==FOR_NODE)
          {
              BodyAssignStmt=get_forall_assign_stmt(index_num-1,children[i]);
              if (BodyAssignStmt!=NULL)
              break;
          }
      }
      delete [ ] children;
      return (BodyAssignStmt);
}

SgExpression * creat_read_num(SgStatement  *innerloop,int looplevel)
{
     SgExpression *  returnExp=NULL;
     if (looplevel==1)
     {    SgExpression * doHeaderExp=innerloop->expr(0);
          SgExpression * lboundExp=doHeaderExp->lhs()->lhs()->copyPtr();
          SgExpression * uboundExp=doHeaderExp->lhs()->rhs()->copyPtr();
          if (doHeaderExp->rhs()==NULL)
          {   
              ( uboundExp)=&((* uboundExp)-(* lboundExp));
          }else
          {    SgExpression * stepExp=doHeaderExp->rhs()->copyPtr();
              ( uboundExp)=&(((* uboundExp)-(* lboundExp))/(*stepExp));
          }
          SgExpression * oneExp=new SgValueExp(1);
          ( uboundExp)=&((* uboundExp)+(* oneExp));
          uboundExp=calculateExp(uboundExp);
          return(uboundExp);
     } else
     {
      int i;
      int org_numberOfChildren=innerloop->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
        children[i]=innerloop->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
      {
          if (children[i]->variant()==FOR_NODE)
          {
              returnExp=creat_read_num(children[i],looplevel-1);
          }
      }

      delete [ ] children;
      returnExp=calculateExp(returnExp);
      return (returnExp);

     }//end of else
}

int first_appear_in_RHS(int i,SgStatement *body)
{
    forall_reference * fref = (forall_reference *) body->attributeValue(i, Forall_Ref);
    SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
    for (int k=1;k<i;k++)
    {  forall_reference * RHSfref =(forall_reference *) body->attributeValue(k, Forall_Ref);
       SgSymbol * RHSarraySym=(SgSymbol *) RHSfref->getarraysymbol();
       if (strcmp(arraySym->identifier(),RHSarraySym->identifier())==0)
       {
            return(FALSE);
       }
    }
    return(TRUE);
}

SgStatement * get_out_loop_stmt(SgStatement * inner)
{
      if (inner->variant()==FOR_NODE) return(inner);
      if (inner==NULL) return (NULL);

      int i;
      SgStatement *out_loop_stmt=NULL;
      int org_numberOfChildren=inner->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
        children[i]=inner->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
      {
          if (children[i]->variant()==FOR_NODE)
          {
              out_loop_stmt=children[i];
              break;
          }
      }

      if (out_loop_stmt==NULL)
      {
           for (i=0; i<org_numberOfChildren; i++)
           {
               out_loop_stmt=get_out_loop_stmt(children[i]);
               if (out_loop_stmt!=NULL)
               break;
           }
      }
      delete [ ] children;
      return (out_loop_stmt);
}

int index_appear_in_array(int k,forall_reference * fref,SgArrayType * arrayType)
{
        for (int j=0;j<arrayType->dimension(); j++)
        {
               if (fref->getIndex(j,k) >=1)
               return(TRUE);
        }
        return(FALSE);
}

int replace_exp_with_exp(SgStatement * assignmaskStmt,SgExpression *oldExp,SgExpression *newExp)
{
     SgExpression *returnExp=NULL; 
     if (assignmaskStmt->variant()==ASSIGN_STAT)
     {  
        returnExp=get_exp_in_exp(assignmaskStmt->expr(1),oldExp);
        if (returnExp!=NULL)
        {     returnExp->replace(* newExp);
              //printf("REPLCAE SUCC\n");
              return(TRUE);
        }
        else
        {
              return (FALSE);
        }
     }
     if (assignmaskStmt->variant()==LOGIF_NODE) 
     {
        returnExp=get_exp_in_exp(assignmaskStmt->childList1(0)->expr(1),oldExp);
        if (returnExp==NULL)
        {
             returnExp=get_exp_in_exp(assignmaskStmt->expr(0),oldExp);
             if (returnExp!=NULL)
             {     returnExp->replace(* newExp);
                   return(TRUE);
             }
             else
             {
                   return (FALSE);
             }
        }
        else
        {
             returnExp->replace(* newExp);
             return(TRUE);
        }
        return(TRUE);   
     }
     return(FALSE);
}

SgExpression * get_exp_in_exp(SgExpression * sourceExp,SgExpression *objectExp)
{   
         SgExpression * resExp=NULL;

         if ( sourceExp==NULL) return(NULL);
         if (*sourceExp == *objectExp) 
         {    
		return(sourceExp);
	 }
         if (sourceExp->lhs()!=NULL)  
         {   resExp=get_exp_in_exp(sourceExp->lhs(),objectExp);
             if (resExp!=NULL)  
	     {	
                 return(resExp);
             }
         }

         if (sourceExp->rhs()!=NULL)  
         {   resExp=get_exp_in_exp(sourceExp->rhs(),objectExp);
             if (resExp!=NULL) 
             {
                 return(resExp);
             }
         }
         return(NULL);
}

void calculateTileSize(SgStatement* s,int numofloop,SgExpression * size[])
{
       int i;
       for (i=0;i<numofloop;i++)
       size[i]=creat_read_num(s,i+1) ;
}


// oc_stride_"name"_t[i_dim1 + 1]  = "stride"_(var_num)_(i_dim2) 
SgAssignStmt * make_stride_assign_special(SgStatement *s,SgSymbol * arraySym,char * stride ,int var_num,int i_dim1,int i_dim2,int t)
{
    SgSymbol * RstrideSym=s->getSymbolInCurrentScope(mixstring, stride,NULL,var_num,i_dim2);
    SgExpression * RstrideExp = new SgVarRefExp(*RstrideSym);
    SgSymbol * LstrideSym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraySym->identifier(),t);

    SgVariableSymb  *array_name=(SgVariableSymb *)LstrideSym;
    SgArrayRefExp * aryExp=new SgArrayRefExp (*array_name);
    SgExpression * valExp= new SgValueExp(i_dim1+1);
    aryExp->addSubscript(*valExp);
    SgAssignStmt * assignStmt = new SgAssignStmt(*aryExp, *RstrideExp);
    return(assignStmt);
}

SgExpression * get_LHS(SgStatement *assignmaskStmt)
{
      if (assignmaskStmt->variant()==ASSIGN_STAT)
      return(assignmaskStmt->expr(0));
      else
      return(assignmaskStmt->childList1(0)->expr(0));
}

int not_conflict_with_lhs(SgStatement * s,int i)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  if (fhdef->getcondition()==NULL) return(TRUE);
  SgStatement * body = s->childList1(0);
  forall_reference * fref ;
  SgArrayRefExp * array ;

  forall_reference *lhsfref = (forall_reference *) body->attributeValue(0, Forall_Ref);
  SgArrayRefExp *lhsarray = (SgArrayRefExp *) lhsfref->getexpression();
  SgSymbol * lhsarraySym=(SgSymbol *) lhsfref->getarraysymbol();

  fref = (forall_reference *) body->attributeValue(i, Forall_Ref);
  array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraySym=(SgSymbol *) fref->getarraysymbol();
  if (strcmp(lhsarraySym->identifier(),arraySym->identifier())==0)
  return(FALSE);
  else
  return(TRUE);
}

