/**@name Passes in trans1
Module trans1 contains passes that perform: 
\begin{itemize}
\item transform Data Mapping Directives to uniform.
\item transform function reference to subroutine call, if the function return an array type.
\item transform the array or array section in PRINT statement to Implied-do form.
\end{itemize}
@memo - passes performed in trans1
 */

//@{
/** enum to define pass types. After trans1, trans0 will encounter only limited
data mapping directives form. This will greatly reduce the difficulty in transformation
and generating node program.
*/
enum PassType {	
/// transform function reference to subroutine call, if the function return an array.
		FUNCTION_HEDR_PASS,	\
/// split Combine Directives into separate Directives.
		COMBINE_PASS , 	\
		COLLECT_PROCESSOR_INFO,	\
/// change the dummies in Align directives to uniform.
		ALIGN_COLON_PASS ,	\
/// complete the Distribute Directives , add all the omitted part.
		DIST_COMP_PASS ,	\
		COLLECT_ALIGN_DIST_INFO,	\
/// align all arrays to templates ultimately.
		ALIGN_ROOT_TEMP_PASS,	\
/// dirctly align all arrays to corresponding templates.
		ALIGN_COLLAPSE_PASS,	\
/// uniform the dummy expression in Align Directives to a*X+b form.
		ALIGN_COEF_PASS ,	\
/// Distribute all the templates by default if they are not distributed explicitly.
		ALIGN_ROOT_DIST_PASS,	\
/// distribute and align statement take effect after allocate.
		ALLOCATABLE_PASS,	\
/// transform the array or array section in PRINT statement to Implied-do form.
                PRINT_PASS	\
};	
//@}

// attribute contain the defintition directive statement belong to symbol
#define	Dist_Stmt	1
#define Align_Stmt      2
#define Temp_Stmt       3
#define Alloc_Stmt      4
#define Dynamic_Stmt    5 

// attributes contain the align tree
#define	Align_Parent	6
#define	Align_Son	7

// used by hedr_stmt
#define Align_Root      10

//
#define Dummy_Exp	15

//
#define Align_Star 	20

//
#define Alloc_Size      30

//
#define Proc_Def       40

//
#define Temp_Def	50
//
#define DUMP_Def  	100
//
#define ARG_ADD		10

#define ONLY_ONE_DIM_PROC

enum Flag { off, on };
