//  These are transformations of elementary intrinsic functions
//  intrinsic functions appear in the form of :
//  a=abs(b)
//  where, there is only function expression in the rhs.

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include "compilerApi.h"

extern int in_main_program;
extern int in_procedure ;
extern int in_function ;

int vectorSub(SgArrayRefExp *aref, int dim)         // dim start from 0
{
	int counter=-1;
	for (int i=0 ; i <aref->numberOfSubscripts(); i++ )
	{
		SgExpression *subs = aref->subscript(i);
		if (subs->variant() != DDOT ) continue;
		counter++;
		if (counter==dim) return i;
	}
	printf("Abnormal !!\n");
	return -1;
}

void varToArrayref(SgExpression *ref)
{
	SgArrayType *atype=isSgArrayType(ref->type());
	SgExpression *exprlist=NULL;
	for (int i = 0; i<atype->dimension() ; i++)
	{
		SgExpression *rangeop=new SgExpression(RANGE_OP,NULL,NULL,NULL);
		SgExpression *ddot=new SgExpression(DDOT,rangeop,NULL,NULL);
		exprlist=new SgExpression(EXPR_LIST,ddot,exprlist,NULL);
	}
	ref->setLhs(exprlist);
	ref->thellnd->variant=ARRAY_REF;
}

void trans_ele_intrinsic(SgStatement * s)
{
  SgStatement  * assign;
  SgForallStmt * forall;
  SgStatement  * body;
  SgExpression * forall_hedr; 
  SgSymbol     * newSymbol;
   
      if(s->expr(1)->variant()==INTRIN_FUNC_CALL)
       if(((SgFunctionSymb *)(s->expr(1)->symbol()))->is_elementary_function()
         &&  isSgArrayType(s->expr(0)->type()) )
          {
		assign = s->copyPtr();
		if (assign->expr(0)->variant() == VAR_REF)
			varToArrayref(assign->expr(0));
		if (assign->expr(1)->lhs()->lhs()->variant() == VAR_REF)
			varToArrayref(assign->expr(1)->lhs()->lhs());

		SgArrayRefExp *lhs=isSgArrayRefExp(assign->expr(0));
		ASSERT(lhs);
		SgSymbol *larrayname = lhs->symbol();
		SgArrayRefExp *rhs=isSgArrayRefExp(assign->expr(1)->lhs()->lhs());
		SgSymbol *rarrayname = assign->expr(1)->lhs()->lhs()->symbol();
		SgArrayType *arraytype = isSgArrayType(s->expr(0)->type()) ;

                SgExpression *control_list=NULL;
		int dim;
		int counter=lhs->type()->thetype->entry.ar_decl.num_dimensions;
		for (int i=counter-1; i>=0 ;i-- )
		{
			dim=vectorSub(lhs,i);
			SgExpression *lsubs = lhs->subscript(dim);
			SgExpression *l_lbound = lsubs->lhs()->lhs();
			SgExpression *l_ubound = lsubs->lhs()->rhs();
			SgExpression *l_step = lsubs->rhs();
			if (l_lbound == NULL)
                  		l_lbound=get_lbound(larrayname, i);
			if (l_ubound == NULL)
                  		l_ubound=get_ubound(larrayname, i);
			if (l_step == NULL )
				l_step = new SgValueExp(1);
                 	SgExpression *range_op=new SgExpression(RANGE_OP,l_lbound->copyPtr(),l_ubound->copyPtr(),NULL);
                  	SgExpression *ddot=new SgExpression(DDOT,range_op,l_step,NULL);
                  	newSymbol=s->getSymbolInCurrentScope("BDI",larrayname->identifier(),NULL,i);
                  	SgExpression *var_ref=new SgVarRefExp(newSymbol);
                  	SgExpression *index_op=new SgExpression(INDEX_OP,var_ref,ddot,NULL);
                  	control_list=new SgExpression(CONTROL_LIST,index_op,control_list,NULL);
			lsubs->replace(*var_ref);

			if (rhs)
			{
			dim=vectorSub(rhs,i);
			SgExpression *rsubs = rhs->subscript(dim);
			SgExpression *r_lbound = rsubs->lhs()->lhs();
			SgExpression *r_step = rsubs->rhs();
			if (r_lbound == NULL)
                  		r_lbound=get_lbound(rarrayname, i);
			if (r_step == NULL )
				r_step = new SgValueExp(1);
			
			SgExpression *coef ,*exp;
			coef = & ( *r_step / *l_step );
			coef=calculateExp(coef);
			exp = &( (*r_lbound) - (*coef) * (*l_lbound) );
			exp=calculateExp(exp);
			exp= &( (*coef) * (*var_ref) + (*exp) );
			rsubs->replace(*exp);
			}
		}

		// set the array element type 
		lhs->setType(arraytype->baseType());
		if (rhs) rhs->setType(arraytype->baseType());
		assign->expr(1)->setType(arraytype->baseType());

                forall_hedr=new SgExpression(FORALL_HEADER_OP,control_list,NULL,NULL);  
                forall=new SgForallStmt(*forall_hedr, *assign);
                s->insertStmtAfter(*forall,* s->controlParent());
                s->deleteStmt();
	}

}

