// transform forall construct into forall statement
#include        <stdio.h>
#include        <string.h>
#include        "compilerApi.h"
#include        "ext_func.h"

////////////////////////////////////////////////////////////////////////////////
SgExpression * change_forall_header(SgStatement * , SgSymbol * , SgExpression * );

void replace_index(SgStatement * , SgSymbol * , SgExpression * );

int normalize_forallconstruct_header(SgStatement *,SgStatement *);

void simple_forallconstruct_to_forall(SgStatement * );

int forallconstruct_to_multi_forallconstruct(SgStatement * , SgStatement * );

SgExpression * combine_forall_header(SgExpression * , SgExpression * , SgExpression * , SgExpression ** );

int forallconstruct_to_forall(SgStatement * , SgStatement  * );

//////////////////////////////////////////////////////////////////////////////////////

// if step of index variable "i"  is not "1"
// then introduce temporary variable "Ti"
// normalize lbound ,ubound, step of "i"
// replacer(stepi*Ti+lboundi)  takes the place of symbol(i)

void replace_index(SgStatement * current , SgSymbol * symbol, SgExpression * replacer)
{

  int             org_numberOfChildren=current->numberOfChildrenList1();
  int             i;

  for (i=0; i<org_numberOfChildren; i++)
 {  SgStatement *  stmt=current->childList1(i);
    switch(stmt->variant()) {
    case ASSIGN_STAT:
         stmt->expr(0)->replaceSymbolByExpression(*symbol,*replacer);
         stmt->expr(1)->replaceSymbolByExpression(*symbol,*replacer);
         break;
    case FORALL_STMT:
    case FORALL_CONSTRUCT_STMT:
         stmt->expr(0)->replaceSymbolByExpression(*symbol,*replacer);
         if(stmt->expr(1)!=NULL)
            stmt->expr(1)->replaceSymbolByExpression(*symbol,*replacer);
         replace_index(stmt,symbol,replacer);
         break;
        
   }
 }

}


SgExpression * change_forall_header(SgStatement * current , SgSymbol * symbol, SgExpression * index_op)
{

  SgSymbol * newSymbol;
  SgValueExp * int_val=new SgValueExp(0);
  SgExpression * step, *lbound, *ubound;

  newSymbol=current->getSymbolInCurrentScope("BDT",symbol->identifier(),NULL);
  step  =((SgSubscriptExp *) index_op->rhs())->step()->copyPtr();
  lbound=((SgSubscriptExp *) index_op->rhs())->lbound()->copyPtr();
  ubound=((SgSubscriptExp *) index_op->rhs())->ubound()->copyPtr();

  SgExpression * expr=&((*ubound - *lbound)/ *step);
  expr = calculateExp(expr);

  //set range_op's lbound and ubound    
  index_op->rhs()->lhs()->setLhs(int_val);
  index_op->rhs()->lhs()->setRhs(expr);
  //set step
  index_op->rhs()->setRhs(NULL);  
  expr=new SgExpression(VAR_REF,NULL,NULL,newSymbol);
  //set index variable
  index_op->setLhs(expr);

  expr=&((*step * *expr) + *lbound);  
  return  expr;
} 

//if  step is constant  and is 1, then nothing has been done  
//else normalize forall header

int normalize_forallconstruct_header(SgStatement * hedr_stmt,SgStatement * current)
{
  
  int             org_numberOfChildren=current->numberOfChildrenList1();
  int             i;
  
   for(SgExpression * expr=current->expr(0)->lhs(); expr; expr=expr->rhs())
    {
      SgExpression * step;
      int result;
 
      step =((SgSubscriptExp *) expr->lhs()->rhs())->step();


      if ( step->valueInteger(result) != -1)
        if( result == 1) continue;
        // result=1, then step=1
 
      SgSymbol * symbol=expr->lhs()->lhs()->symbol();
      // set forall header's lbound , ubound,step, index_variable
      SgExpression *replacer=change_forall_header(current,symbol,expr->lhs());       
      // replace index variable in the mask expression      
      if(current->expr(1)!=NULL)
      	current ->expr(1)->replaceSymbolByExpression(*symbol,*replacer);
      replace_index(current, symbol,replacer);
   }

   for(i=0; i<org_numberOfChildren; i++)
    {
       SgStatement * stmt=current->childList1(i);
       switch(stmt->variant())
         {
            case ASSIGN_STAT:
                  return 0;
            case FORALL_STMT:
            case FORALL_CONSTRUCT_STMT:
                  normalize_forallconstruct_header(hedr_stmt, stmt);
                  break;
         }
   }
  return 1;
}

void simple_forallconstruct_to_forall(SgStatement * current)
{
  current->thebif->variant=FORALL_STMT;
}


// divide a complex forall construct that includes ASSIGN_STAT, FORALL_STMT,and FORALL_CONSTRUCT_STMT
//into the forms as follows:
// 1:    forall(......)
//          assign_statement
//       end forall
// 2:    forall(......)
//            forall(......) assign_statement
//       end forall
// 3:    forall(......)
//          ......                    
//             forall(......)
//                forall(......) assign_statement
//             end forall
//          ......
//       end forall               

int forallconstruct_to_multi_forallconstruct(SgStatement * hedr_stmt, SgStatement * current)
{

  int             org_numberOfChildren=current->numberOfChildrenList1();
  SgStatement * * children= new SgStatement * [org_numberOfChildren];
  int             i;

  SgForallConstructStmt    * aforall;
  SgStatement   * aassign, * body;
  SgExpression  * forall_header_op,  * mask_exp;

  for (i=0; i<org_numberOfChildren; i++)
       children[i]=current->childList1(i);
 
  for ( i=org_numberOfChildren -1 ; i>=0 ; i--)
    {
      switch(children[i]->variant()) {
       case FORALL_CONSTRUCT_STMT:
               forallconstruct_to_multi_forallconstruct(hedr_stmt,children[i]);
               break;
      }
    }

  delete [] children ;
  org_numberOfChildren=current->numberOfChildrenList1();
  if (org_numberOfChildren == 2) return 0;

  children= new SgStatement * [org_numberOfChildren];
  for (i=0; i<org_numberOfChildren; i++)
       children[i]=current->childList1(i);

  for ( i=org_numberOfChildren-1 ; i>=0 ; i--)
    {
      switch(children[i]->variant()) {

      case ASSIGN_STAT: 
              aassign=children[i]->copyOnePtr();
              forall_header_op=current->expr(0)->copyPtr(); 
              if(  current->expr(1) != NULL)
                {
                  mask_exp=current->expr(1)->copyPtr();
                  aforall=new SgForallConstructStmt(*forall_header_op, *mask_exp, *aassign);
                 }
              else
                 aforall=new SgForallConstructStmt(*forall_header_op, *aassign);
              current->insertStmtAfter(*aforall, *current->controlParent());
              break;

      case FORALL_STMT:
       case FORALL_CONSTRUCT_STMT:
              body=children[i]->copyPtr();
              forall_header_op=current->expr(0)->copyPtr();
              if( current->expr(1)  != NULL)
                {
                  mask_exp=current->expr(1)->copyPtr();
                  aforall=new SgForallConstructStmt(*forall_header_op, *mask_exp, *body);
                 }
              else
                 aforall=new SgForallConstructStmt(*forall_header_op, *body);
              current->insertStmtAfter(*aforall, *current->controlParent());
              break; 
      }
    }

  current->deleteStmt();          
  return 1;
}

// combine two forall header
// generate a new forall header 
// make a new forall construct according to this new forall header

SgExpression * combine_forall_header(SgExpression * forall_header_1, SgExpression * forall_header_2, SgExpression * mask_exp, SgExpression ** new_mask_exp)
{
  SgExpression * new_forall_header, * expr=NULL;
 
  for(SgExpression * expr2=forall_header_2->lhs(); expr2 ; expr2=expr2->rhs())
    {
     for(SgExpression * expr1=forall_header_1->lhs(); expr1; expr1=expr1->rhs())         
       {   
         SgExpression * range_op2= expr2->lhs()->rhs()->lhs();
         SgExpression * range_op1= expr1->lhs()->rhs()->lhs();
	 SgSymbol     * index =  expr1->lhs()->lhs()->symbol();

	 if ( range_op2->lhs()->IsSymbolInExpression(*index) )
	 {
                 SgExpression * mask=&(expr2->lhs()->lhs()->copy() >= range_op2->lhs()->copy());      
                 range_op2->lhs()->replaceSymbolByExpression(*index, *range_op1->lhs()->copyPtr());
		 if ( range_op2->lhs()->isInteger() )
			range_op2->setLhs(new SgValueExp(range_op2->lhs()->valueInteger()) );
                 mask_exp=mask_exp?&(*mask_exp && *mask):mask;
	 }
	 if ( range_op2->rhs()->IsSymbolInExpression(*index) )
	 {
                 SgExpression * mask=&(expr2->lhs()->lhs()->copy() <= range_op2->rhs()->copy());      
                 range_op2->rhs()->replaceSymbolByExpression(*index, *range_op1->rhs()->copyPtr());
		 if ( range_op2->rhs()->isInteger() )
			range_op2->setRhs(new SgValueExp(range_op2->rhs()->valueInteger()) );
                 mask_exp=mask_exp?&(*mask_exp && *mask):mask;
	 }
       }
     }

  for( expr=forall_header_1->lhs(); expr->rhs(); expr=expr->rhs());

  expr->setRhs(forall_header_2->lhs());

  new_forall_header=forall_header_1;

  *new_mask_exp=mask_exp;
  return new_forall_header;
}


int forallconstruct_to_forall(SgStatement * hedr_stmt, SgStatement  * current)
{
    
  int             org_numberOfChildren=current->numberOfChildrenList1();
  SgStatement * * children= new SgStatement * [org_numberOfChildren];
  int             i;

  SgExpression  * current_header, * children_header,* new_forall_header;
  SgExpression  * mask_exp_1=NULL, * mask_exp_2=NULL, * mask_exp=NULL, * new_mask_exp=NULL;
  SgForallConstructStmt * aforall;
  SgStatement   * body;

  for (i=0; i<org_numberOfChildren; i++)
       children[i]=current->childList1(i);

  if(org_numberOfChildren==2 && children[0]->variant()==ASSIGN_STAT)
      {
         simple_forallconstruct_to_forall(current);
         return 0;
       }
  
   for(i=0; i<org_numberOfChildren; i++)
      {
        switch(children[i]->variant()) {
       
        case FORALL_STMT:
        case FORALL_CONSTRUCT_STMT:
              current_header = current->expr(0)->copyPtr();
              children_header= children[i]->expr(0)->copyPtr();

              if(current->expr(1)!=NULL)
                  mask_exp_1=current->expr(1)->copyPtr();
              if(children[i]->expr(1)!=NULL)
                  mask_exp_2=children[i]->expr(1)->copyPtr();
              if( mask_exp_1 && !mask_exp_2)
                  mask_exp=mask_exp_1;
              if( mask_exp_2 && !mask_exp_1)
                  mask_exp=mask_exp_2;
              if( mask_exp_1 && mask_exp_2 )
//                  new_mask_exp=new SgExpression(AND_OP,mask_exp_1, mask_exp_2,NULL);   
                  mask_exp= &( *mask_exp_1 && *mask_exp_2);
                 
              new_forall_header=combine_forall_header(current_header, children_header, mask_exp, &new_mask_exp); 
 
              body=children[i]->childList1(0)->copyPtr();
              aforall=new SgForallConstructStmt(*new_forall_header, *body);
              if (new_mask_exp)
                  aforall->setMask(*new_mask_exp);
              current->insertStmtAfter(*aforall, *current->controlParent());
              forallconstruct_to_forall(hedr_stmt, aforall); 
               
              break;   
        }
      }
   current->deleteStmt();
   return 1;

}
