      PROGRAM inverse_main
      INTEGER N
      PARAMETER(N=4)
      INTEGER i,j,k,maxl(2)
      INTEGER IS(N),JS(N)   !--record transform information of cols and rows
      INTEGER ic1,ic2
      REAL A(N,N),C(N,N),E(N,N)
      REAL T1(N),T2(N),D

      INTERFACE
        SUBROUTINE INVERSE(A,N)
          INTEGER,INTENT(IN)                 :: N
          REAL,DIMENSION(N,N),INTENT(INOUT)  :: A
!HPF$     DISTRIBUTE *(*,BLOCK)              :: A
!HPF$     OUT_OF_CORE               A
        END SUBROUTINE INVERSE
      END INTERFACE

!HPF$ PROCESSORS PROC(4)
!HPF$ DISTRIBUTE (*,BLOCK) ONTO PROC :: A,C,E
!HPF$ DISTRIBUTE (BLOCK) ONTO PROC :: IS,JS
!HPF$ DISTRIBUTE (BLOCK) ONTO PROC :: T1
!HPF$ OUT_OF_CORE               A,C,E
      
      FORALL (i=1:N,j=1:N) A(i,j)=400*i+50*j+1 
      FORALL (i=1:N) A(i,i)=100*i+108*i 
      C=A

      print *, "array A is:"
!      do i=1,N
!       print *, (C(i,j),j=1,N)
!      end do

!      call pcrc_clock(0)
      CALL INVERSE(A,N)
!      call pcrc_clock(1)

!--verify the result
      E=MATMUL(A,C)
      print *, "the product of array A and inversion(A) is C:"
      do i=1,N
       write(*,30) (E(i,j),j=1,N)
      end do
!      open (unit=10, file='result', form='unformatted')
!      do i=1,N
!       write(10) (C(i,j),j=1,N)
!      end do
!      close(10)
30    FORMAT(100F10.5)
!        STOP 
        END

      SUBROUTINE INVERSE(A,N)
      INTEGER,INTENT(IN)                 :: N
      REAL,DIMENSION(N,N),INTENT(INOUT)  :: A
      INTEGER i,j,k,maxl(2)
      INTEGER IS(N),JS(N)   !--record transform information of cols and rows
      INTEGER ic1,ic
      REAL B(N,N)
      REAL T1(N),T2(N),D
!HPF$ DISTRIBUTE *(*,BLOCK)              :: A
!HPF$ DISTRIBUTE (*,BLOCK)               :: B
!HPF$ DISTRIBUTE (BLOCK)                 :: IS,JS,T1
!HPF$ OUT_OF_CORE               A,B

!-- start eliminate process, from (1,1) to (N,N)
      DO k=1,N

        B=ABS(A)

        maxl=MAXLOC(B(k:N,k:N))  !--select major element
        IS(k)=maxl(1)+k-1
        JS(k)=maxl(2)+k-1
        ic1=maxl(1)+k-1
        ic2=maxl(2)+k-1
        D=A(ic1,ic2)
        IF (ABS(D) .LT. 1.0E-4) THEN        !--if D=0 then exit
          PRINT *, "there isn't inversion of array A"
          RETURN
        END IF
        
!--transfer theK row and the IS(k) row
        T1(1:N)=A(k,1:N)
        A(k,1:N)=A(ic1,1:N)
        A(ic1,1:N)=T1(1:N)

!--transfer the K col and the JS(k) col
        T2(1:N)=A(1:N,k)
        A(1:N,k)=A(1:N,ic2)
        A(1:N,ic2)=T2(1:N)

        A(k,k)=1.0/D
 
        FORALL (j=1:N,j .NE. k) A(k,j)=A(k,j)/D 
 
        FORALL (i=1:N,j=1:N,(i .NE. k .AND. j.NE.k)) & 
             A(i,j)=A(i,j)-A(i,k)*A(k,j)

        FORALL (i=1:N,i .NE. k) A(i,k)=-A(i,k)/D 

      END DO  
!--end eliminate process

!--retranspose to original order of cols and rows
      DO k=N,1,-1
        ic1=IS(k)
        ic2=JS(k)
        T1(1:N)=A(k,1:N)
        A(k,1:N)=A(ic2,1:N)
        A(ic2,1:N)=T1(1:N)

        T2(1:N)=A(1:N,k)
        A(1:N,k)=A(1:N,ic1)
        A(1:N,ic1)=T2(1:N)
      END DO  

      print *, "the inversion of array A is:"
      do i=1,N
       write(*,20) (A(i,j),j=1,N)
      end do
20    FORMAT(100F10.5)

      RETURN
      END

